import { IColorModule } from '../ColorModule';
import { ISubjectComposable } from '../IMarkedText';
import { ISubjectLedger } from './SubjectLedger';
export interface ISubjectEngine {
    link(markedText: ISubjectComposable): void;
    unlink(): void;
    setLedger(newLedger: ISubjectLedger): void;
    setColorModule(newColorModule: IColorModule): void;
    addSubjectsFromText(): void;
    addSubjects(subjects: Iterable<string>): void;
    resetColors(): void;
    lineConnectSubject(subjectName: string): void;
    lineDisconnectSubject(subjectName: string): void;
    toggleLines(subjectName: string): void;
}
export declare class SubjectEngine implements ISubjectEngine {
    private markedText;
    private ledger;
    private colorModule;
    private leaderLines;
    constructor(ledger: ISubjectLedger, colorModule: IColorModule);
    link(markedText: ISubjectComposable): void;
    unlink(): void;
    setLedger(newLedger: ISubjectLedger): void;
    setColorModule(newColorModule: IColorModule): void;
    addSubjectsFromText(): void;
    addSubjects(subjects: Iterable<string>): void;
    resetColors(): void;
    lineConnectSubject(subjectName: string): void;
    lineDisconnectSubject(subjectName: string): void;
    toggleLines(subjectName: string): void;
    subjectCSSClassName(subjectName: string): string;
    subjectSpans(subjectName: string): HTMLSpanElement[];
}
