import { ISubjectComposable } from '../IMarkedText';
import { ISubject, Subject } from './Subject';
export interface ISubjectLedger {
    get glossary(): Map<string, Subject>;
    get listSubjects(): ISubject[];
    get listActiveSubjects(): ISubject[];
    link(composable: ISubjectComposable): void;
    unlink(): void;
    byName(name: string): Subject | undefined;
    subjectColor(subjectName: string): string | undefined;
    subjectStyle(subjectName: string): any;
    isSubjectActive(subjectName: string): boolean;
    activateSubject(subjectName: string): void;
    deactivateSubject(subjectName: string): void;
    toggleSubject(subjectName: string): void;
    activateAllSubjects(): void;
    deactivateAllSubjects(): void;
}
export declare class SubjectLedger implements ISubjectLedger {
    private composable;
    private xGlossary;
    constructor();
    get glossary(): Map<string, Subject>;
    get listSubjects(): Subject[];
    get listActiveSubjects(): Subject[];
    link(composable: ISubjectComposable): void;
    unlink(): void;
    byName(name: string): Subject | undefined;
    subjectColor(subjectName: string): string | undefined;
    subjectStyle(subjectName: string): any;
    isSubjectActive(subjectName: string): boolean;
    activateSubject(subjectName: string): void;
    deactivateSubject(subjectName: string): void;
    toggleSubject(subjectName: string): void;
    activateAllSubjects(): void;
    deactivateAllSubjects(): void;
}
