var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
import { defineComponent, openBlock, createElementBlock, Fragment, renderList, mergeProps, toHandlers, toDisplayString, resolveComponent, normalizeClass, createVNode, reactive } from "vue";
var _export_sfc = (sfc, props) => {
  const target = sfc.__vccOpts || sfc;
  for (const [key, val] of props) {
    target[key] = val;
  }
  return target;
};
const BatchRenderer = defineComponent({
  name: "BatchRenderer",
  props: {
    batch: {
      type: Array,
      required: true
    },
    spanDataToStyles: {
      type: Function,
      required: true
    }
  },
  emits: [
    "trigger"
  ],
  methods: {
    spanDataToCbk(spanData) {
      return Object.assign({}, ...Object.entries(spanData.spanControllerEvents).map(([eventName, spanControllerEvent]) => ({
        [eventName]: (event) => this.$emit("trigger", {
          rawEvent: event,
          spanData,
          spanControllerEvent
        })
      })));
    }
  }
});
const _sfc_main$2 = BatchRenderer;
function _sfc_render$2(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(true), createElementBlock(Fragment, null, renderList(_ctx.batch, (spanData) => {
    return openBlock(), createElementBlock("span", mergeProps({
      key: spanData.key,
      class: spanData.cssClasses,
      style: _ctx.spanDataToStyles(spanData)
    }, toHandlers(_ctx.spanDataToCbk(spanData))), toDisplayString(spanData.text), 17);
  }), 128);
}
var BatchRenderer$1 = /* @__PURE__ */ _export_sfc(_sfc_main$2, [["render", _sfc_render$2]]);
const DepotRenderer = defineComponent({
  name: "DepotRenderer",
  components: {
    BatchRenderer: BatchRenderer$1
  },
  props: {
    spanBatches: {
      type: Array,
      required: true
    },
    spanDataToStyles: {
      type: Function,
      required: true
    }
  },
  emits: [
    "trigger"
  ]
});
const _sfc_main$1 = DepotRenderer;
function _sfc_render$1(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_BatchRenderer = resolveComponent("BatchRenderer");
  return openBlock(true), createElementBlock(Fragment, null, renderList(_ctx.spanBatches, (batch, idx) => {
    return openBlock(), createElementBlock("span", {
      key: idx,
      class: normalizeClass("span-batch-" + String(idx))
    }, [
      createVNode(_component_BatchRenderer, {
        batch,
        spanDataToStyles: _ctx.spanDataToStyles,
        onTrigger: _cache[0] || (_cache[0] = (...args) => _ctx.$emit("trigger", ...args))
      }, null, 8, ["batch", "spanDataToStyles"])
    ], 2);
  }), 128);
}
var DepotRenderer$1 = /* @__PURE__ */ _export_sfc(_sfc_main$1, [["render", _sfc_render$1]]);
var commonjsGlobal = typeof globalThis !== "undefined" ? globalThis : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : {};
var toString$1 = Object.prototype.toString;
var kindOf = function kindOf2(val) {
  var type = typeof val;
  if (type === "undefined") {
    return "undefined";
  }
  if (val === null) {
    return "null";
  }
  if (val === true || val === false || val instanceof Boolean) {
    return "boolean";
  }
  if (type === "string" || val instanceof String) {
    return "string";
  }
  if (type === "number" || val instanceof Number) {
    return "number";
  }
  if (type === "function" || val instanceof Function) {
    if (typeof val.constructor.name !== "undefined" && val.constructor.name.slice(0, 9) === "Generator") {
      return "generatorfunction";
    }
    return "function";
  }
  if (typeof Array.isArray !== "undefined" && Array.isArray(val)) {
    return "array";
  }
  if (val instanceof RegExp) {
    return "regexp";
  }
  if (val instanceof Date) {
    return "date";
  }
  type = toString$1.call(val);
  if (type === "[object RegExp]") {
    return "regexp";
  }
  if (type === "[object Date]") {
    return "date";
  }
  if (type === "[object Arguments]") {
    return "arguments";
  }
  if (type === "[object Error]") {
    return "error";
  }
  if (type === "[object Promise]") {
    return "promise";
  }
  if (isBuffer(val)) {
    return "buffer";
  }
  if (type === "[object Set]") {
    return "set";
  }
  if (type === "[object WeakSet]") {
    return "weakset";
  }
  if (type === "[object Map]") {
    return "map";
  }
  if (type === "[object WeakMap]") {
    return "weakmap";
  }
  if (type === "[object Symbol]") {
    return "symbol";
  }
  if (type === "[object Map Iterator]") {
    return "mapiterator";
  }
  if (type === "[object Set Iterator]") {
    return "setiterator";
  }
  if (type === "[object String Iterator]") {
    return "stringiterator";
  }
  if (type === "[object Array Iterator]") {
    return "arrayiterator";
  }
  if (type === "[object Int8Array]") {
    return "int8array";
  }
  if (type === "[object Uint8Array]") {
    return "uint8array";
  }
  if (type === "[object Uint8ClampedArray]") {
    return "uint8clampedarray";
  }
  if (type === "[object Int16Array]") {
    return "int16array";
  }
  if (type === "[object Uint16Array]") {
    return "uint16array";
  }
  if (type === "[object Int32Array]") {
    return "int32array";
  }
  if (type === "[object Uint32Array]") {
    return "uint32array";
  }
  if (type === "[object Float32Array]") {
    return "float32array";
  }
  if (type === "[object Float64Array]") {
    return "float64array";
  }
  return "object";
};
function isBuffer(val) {
  return val.constructor && typeof val.constructor.isBuffer === "function" && val.constructor.isBuffer(val);
}
var typeOf$1 = kindOf;
var defaultCompare$1 = function defaultCompare(a, b, prop) {
  if (prop != null && typeOf$1(prop) !== "string") {
    throw new TypeError('expected "prop" to be undefined or a string');
  }
  var typeA = typeOf$1(a);
  var typeB = typeOf$1(b);
  if (prop) {
    if (typeA === "object") {
      a = a[prop];
      typeA = typeOf$1(a);
    }
    if (typeB === "object") {
      b = b[prop];
      typeB = typeOf$1(b);
    }
  }
  if (typeA === "null") {
    return typeB === "null" ? 0 : typeB === "undefined" ? -1 : 1;
  } else if (typeA === "undefined") {
    return typeB === "null" ? 1 : typeB === "undefined" ? 0 : 1;
  } else if (typeB === "null" || typeB === "undefined") {
    return -1;
  } else {
    return a < b ? -1 : a > b ? 1 : 0;
  }
};
/*!
 * get-value <https://github.com/jonschlinkert/get-value>
 *
 * Copyright (c) 2014-2015, Jon Schlinkert.
 * Licensed under the MIT License.
 */
var getValue = function(obj, prop, a, b, c) {
  if (!isObject(obj) || !prop) {
    return obj;
  }
  prop = toString(prop);
  if (a)
    prop += "." + toString(a);
  if (b)
    prop += "." + toString(b);
  if (c)
    prop += "." + toString(c);
  if (prop in obj) {
    return obj[prop];
  }
  var segs = prop.split(".");
  var len = segs.length;
  var i = -1;
  while (obj && ++i < len) {
    var key = segs[i];
    while (key[key.length - 1] === "\\") {
      key = key.slice(0, -1) + "." + segs[++i];
    }
    obj = obj[key];
  }
  return obj;
};
function isObject(val) {
  return val !== null && (typeof val === "object" || typeof val === "function");
}
function toString(val) {
  if (!val)
    return "";
  if (Array.isArray(val)) {
    return val.join(".");
  }
  return val;
}
/*!
 * array-sort <https://github.com/jonschlinkert/array-sort>
 *
 * Copyright (c) 2015-2017, Jon Schlinkert.
 * Released under the MIT License.
 */
var defaultCompare2 = defaultCompare$1;
var typeOf = kindOf;
var get = getValue;
function arraySort(arr, props, opts) {
  if (arr == null) {
    return [];
  }
  if (!Array.isArray(arr)) {
    throw new TypeError("array-sort expects an array.");
  }
  if (arguments.length === 1) {
    return arr.sort();
  }
  var args = flatten([].slice.call(arguments, 1));
  if (typeOf(args[args.length - 1]) === "object") {
    opts = args.pop();
  }
  return arr.sort(sortBy(args, opts));
}
function sortBy(props, opts) {
  opts = opts || {};
  return function compareFn(a, b) {
    var len = props.length, i = -1;
    var result;
    while (++i < len) {
      result = compare(props[i], a, b);
      if (result !== 0) {
        break;
      }
    }
    if (opts.reverse === true) {
      return result * -1;
    }
    return result;
  };
}
function compare(prop, a, b) {
  if (typeof prop === "function") {
    return prop(a, b, compare.bind(null, null));
  }
  if (prop && typeof a === "object" && typeof b === "object") {
    return compare(null, get(a, prop), get(b, prop));
  }
  return defaultCompare2(a, b);
}
function flatten(arr) {
  return [].concat.apply([], arr);
}
var arraySort_1 = arraySort;
function compareMarks(mark1, mark2) {
  return mark1.begChar - mark2.begChar || mark1.endChar - mark2.endChar || (mark1.text ? 1 : 0) - (mark2.text ? 1 : 0) || mark1.text && mark2.text && mark1.text.localeCompare(mark2.text) || 0;
}
class Patch {
  constructor(added = [], rmed = []) {
    __publicField(this, "added");
    __publicField(this, "rmed");
    this.added = added;
    this.rmed = rmed;
  }
  get empty() {
    return this.added.length === 0 && this.rmed.length === 0;
  }
  reset() {
    this.added = [];
    this.rmed = [];
  }
  transform(array) {
    const splices = [];
    const iter = this.rmThenAddOrder();
    let elem = iter.next();
    while (!elem.done) {
      const idx = elem.value[1][0];
      if (elem.value[0] === 0) {
        const additions = [];
        while (!elem.done && elem.value[1][0] === idx) {
          additions.push(elem.value[1][1]);
          elem = iter.next();
        }
        splices.push([idx, 0, ...additions]);
      } else {
        let curIdx = idx;
        const additions = [];
        while (!elem.done && elem.value[1][0] <= curIdx) {
          switch (elem.value[0]) {
            case 0:
              additions.push(elem.value[1][1]);
              break;
            case 1:
              curIdx += 1;
              break;
          }
          elem = iter.next();
        }
        splices.push([idx, curIdx - idx, ...additions]);
      }
    }
    for (const splice of splices.reverse()) {
      array.splice(...splice);
    }
  }
  *rmThenAddOrder() {
    const addedIter = this.added[Symbol.iterator]();
    const rmedIter = this.rmed[Symbol.iterator]();
    let added = addedIter.next(), rmed = rmedIter.next();
    while (!added.done || !rmed.done) {
      if (!rmed.done && (added.done || rmed.value[0] <= added.value[0])) {
        yield [1, rmed.value];
        rmed = rmedIter.next();
      } else {
        yield [0, added.value];
        added = addedIter.next();
      }
    }
  }
  *addThenRmOrder() {
    const addedIter = this.added[Symbol.iterator]();
    const rmedIter = this.rmed[Symbol.iterator]();
    let added = addedIter.next(), rmed = rmedIter.next();
    while (!added.done || !rmed.done) {
      if (!rmed.done && (added.done || rmed.value[0] < added.value[0])) {
        yield [1, rmed.value];
        rmed = rmedIter.next();
      } else {
        yield [0, added.value];
        added = addedIter.next();
      }
    }
  }
}
function mergePatches(patch0, patch1) {
  console.log("mergePatches");
  console.log(patch0);
  console.log(patch1);
  const mergedPatch = new Patch();
  const iter0 = patch0.rmThenAddOrder();
  const iter1 = patch1.rmThenAddOrder();
  let elem0 = iter0.next(), elem1 = iter1.next(), idxDiffTot = 0;
  while (!elem0.done || !elem1.done) {
    const elem0Idx = elem0.done ? 0 : elem0.value[1][0];
    const elem1Idx = elem1.done ? 0 : elem1.value[1][0] + idxDiffTot;
    if (!elem0.done && (elem1.done || elem0Idx < elem1Idx)) {
      switch (elem0.value[0]) {
        case 0:
          idxDiffTot -= 1;
          mergedPatch.added.push([elem0Idx, elem0.value[1][1]]);
          break;
        case 1:
          idxDiffTot += 1;
          mergedPatch.rmed.push([elem0Idx, elem0.value[1][1]]);
          break;
      }
      elem0 = iter0.next();
    } else if (!elem1.done && (elem0.done || elem1Idx < elem0Idx)) {
      switch (elem1.value[0]) {
        case 0:
          mergedPatch.added.push([elem1Idx, elem1.value[1][1]]);
          break;
        case 1:
          mergedPatch.rmed.push([elem1Idx, elem1.value[1][1]]);
          break;
      }
      elem1 = iter1.next();
    } else {
      const goodElem0 = elem0.value;
      const goodElem1 = elem1.value;
      const type0 = goodElem0[0], type1 = goodElem1[0];
      if (type1 === 0) {
        mergedPatch.added.push([elem1Idx, goodElem1[1][1]]);
        elem1 = iter1.next();
      } else if (type0 === 0) {
        idxDiffTot -= 1;
        mergedPatch.added.push([elem0Idx, goodElem0[1][1]]);
        elem0 = iter0.next();
      } else if (type0 === 1) {
        idxDiffTot += 1;
        mergedPatch.added.push([elem0Idx, goodElem0[1][1]]);
        elem0 = iter0.next();
      } else if (type1 === 1) {
        mergedPatch.added.push([elem1Idx, goodElem1[1][1]]);
        elem1 = iter1.next();
      }
    }
  }
  return mergedPatch;
}
class Layers {
  constructor(layers) {
    __publicField(this, "layerNames");
    __publicField(this, "layers");
    __publicField(this, "layerPatches");
    __publicField(this, "layerPriorities");
    this.layerNames = [];
    this.layers = {};
    this.layerPatches = {};
    this.layerPriorities = [];
    for (const layer of layers) {
      const layerName = layer[0];
      if (this.layerNames.includes(layerName))
        throw Error("Layers should not share names");
      this.layerNames.push(layerName);
      const sortedMarks = arraySort_1(layer[2].slice(), ["begChar", "endChar", "text", "subjects"]);
      this.layers[layerName] = { typeSpanData: layer[1], marks: sortedMarks };
      this.layerPatches[layerName] = new Patch();
      this.layerPriorities.push(layerName);
    }
  }
  addLayer(name, typeSpanData, ...marks) {
    if (!this.layerNames.includes(name)) {
      this.layerNames.push(name);
      this.layers[name] = { typeSpanData, marks: [] };
      this.layerPatches[name] = new Patch();
      this.layerPriorities.push(name);
    }
    this.addToLayer(name, ...marks);
  }
  rmLayer(name) {
    if (this.layerNames.includes(name)) {
      this.layerNames.splice(this.layerNames.indexOf(name), 1);
      delete this.layers[name];
      delete this.layerPatches[name];
      this.layerPriorities.splice(this.layerPriorities.indexOf(name), 1);
    }
  }
  resetPatches() {
    this.layerNames.forEach((name) => {
      this.layerPatches[name] = new Patch();
    });
  }
  get length() {
    return this.layerNames.length;
  }
  layerByName(name) {
    return this.layers[name] || void 0;
  }
  getLayers() {
    return this.layers;
  }
  patchByName(name) {
    return this.layerPatches[name];
  }
  getPatches() {
    return this.layerPatches;
  }
  allPatches() {
    return this.layerNames.map((name) => this.layerPatches[name]);
  }
  get priorities() {
    return this.layerPriorities;
  }
  layerByPriority(priority) {
    if (this.layerPriorities.length <= priority)
      throw Error("No layer priority " + priority + " exists");
    return this.layers[this.layerPriorities[priority]];
  }
  layersByPriority() {
    return this.layerPriorities.map((name) => this.layers[name]);
  }
  permutePriority(permutation) {
    if (permutation.length !== this.layerNames.length || !Array.from({ length: permutation.length }, (_, i) => i).every((num) => permutation.includes(num)))
      throw new Error("Supply valid priority permutation");
    this.layerPriorities.splice(0, this.layerPriorities.length, ...this.layerPriorities.map((_, idx) => this.layerPriorities[permutation[idx]]));
  }
  layerToFront(layerName) {
    const priority = this.layerPriorities.indexOf(layerName);
    if (priority === -1)
      throw new Error("Unknown layer " + layerName);
    this.layerPriorities.splice(0, priority + 1, layerName, ...this.layerPriorities.slice(0, priority));
  }
  layerToBack(layerName) {
    const priority = this.layerPriorities.indexOf(layerName);
    if (priority === -1)
      throw new Error("Unknown layer " + layerName);
    this.layerPriorities.splice(priority, this.layerPriorities.length - priority, ...this.layerPriorities.slice(priority + 1, this.layerPriorities.length), layerName);
  }
  changeLayer(name, newMarks) {
    const newSortedMarks = arraySort_1(newMarks.slice(), ["begChar", "endChar", "text", "subjects"]);
    const newPatch = this.patchFromDiff(this.layerByName(name).marks, newSortedMarks);
    console.log(newPatch);
    this.layers[name].marks = newSortedMarks;
    this.mergePatch(name, newPatch);
  }
  addToLayer(name, ...addMarks) {
    const addSortedMarks = arraySort_1(addMarks.slice(), ["begChar", "endChar", "text", "subjects"]);
    const newPatch = this.patchFromAdd(this.layerByName(name).marks, addSortedMarks);
    newPatch.transform(this.layers[name].marks);
    this.mergePatch(name, newPatch);
  }
  rmFromLayer(name, ...rmMarks) {
    const rmSortedMarks = arraySort_1(rmMarks.slice(), ["begChar", "endChar", "text", "subjects"]);
    const newPatch = this.patchFromRm(this.layerByName(name).marks, rmSortedMarks);
    newPatch.transform(this.layers[name].marks);
    this.mergePatch(name, newPatch);
  }
  mergePatch(layerName, newPatch) {
    const mergedPatch = mergePatches(this.layerPatches[layerName], newPatch);
    this.layerPatches[layerName] = mergedPatch;
  }
  patchFromDiff(oldSortedMarks, newSortedMarks) {
    const newPatch = new Patch();
    let oldIdx = 0, newIdx = 0;
    while (oldIdx < oldSortedMarks.length && newIdx < newSortedMarks.length) {
      const oldMark = oldSortedMarks[oldIdx];
      const newMark = newSortedMarks[newIdx];
      const compare2 = compareMarks(oldMark, newMark);
      if (compare2 < 0) {
        newPatch.rmed.push([oldIdx, oldMark]);
        ++oldIdx;
      } else if (compare2 > 0) {
        newPatch.added.push([oldIdx, newMark]);
        ++newIdx;
      } else {
        if (oldMark.subjects.some((sub) => !newMark.subjects.includes(sub)) || newMark.subjects.some((sub) => !oldMark.subjects.includes(sub))) {
          newPatch.rmed.push([oldIdx, oldMark]);
          newPatch.added.push([oldIdx, newMark]);
        }
        ++oldIdx;
        ++newIdx;
      }
    }
    while (oldIdx < oldSortedMarks.length) {
      newPatch.rmed.push([oldIdx, oldSortedMarks[oldIdx]]);
      ++oldIdx;
    }
    while (newIdx < newSortedMarks.length) {
      newPatch.added.push([oldIdx, newSortedMarks[newIdx]]);
      ++newIdx;
    }
    return newPatch;
  }
  patchFromAdd(sortedMarks, addedSortedMarks) {
    const newPatch = new Patch();
    let oldIdx = 0, newIdx = 0;
    while (oldIdx < sortedMarks.length && newIdx < addedSortedMarks.length) {
      const oldMark = sortedMarks[oldIdx];
      const newMark = addedSortedMarks[newIdx];
      const compare2 = compareMarks(oldMark, newMark);
      if (compare2 > 0) {
        newPatch.added.push([oldIdx, newMark]);
        ++newIdx;
      } else {
        ++oldIdx;
      }
    }
    while (newIdx < addedSortedMarks.length) {
      newPatch.added.push([oldIdx, addedSortedMarks[newIdx]]);
      ++newIdx;
    }
    return newPatch;
  }
  patchFromRm(sortedMarks, rmedSortedMarks) {
    const newPatch = new Patch();
    let oldIdx = 0, newIdx = 0;
    while (oldIdx < sortedMarks.length && newIdx < rmedSortedMarks.length) {
      const oldMark = sortedMarks[oldIdx];
      const newMark = rmedSortedMarks[newIdx];
      const compare2 = compareMarks(oldMark, newMark);
      if (compare2 === 0 && oldMark.subjects.every((sub) => newMark.subjects.includes(sub)) && newMark.subjects.every((sub) => oldMark.subjects.includes(sub))) {
        newPatch.rmed.push([oldIdx, oldMark]);
        ++oldIdx;
        ++newIdx;
      } else if (compare2 > 0) {
        console.error("cannot find mark to remove; skipping:");
        console.error(newMark);
        ++newIdx;
      } else {
        ++oldIdx;
      }
    }
    while (newIdx < rmedSortedMarks.length) {
      console.error("cannot find mark to remove; skipping:");
      console.error(rmedSortedMarks[newIdx]);
      ++newIdx;
    }
    return newPatch;
  }
}
var TypeSpanData = /* @__PURE__ */ ((TypeSpanData2) => {
  TypeSpanData2[TypeSpanData2["Text"] = 0] = "Text";
  TypeSpanData2[TypeSpanData2["Mark"] = 1] = "Mark";
  TypeSpanData2[TypeSpanData2["Selection"] = 2] = "Selection";
  TypeSpanData2[TypeSpanData2["Meta"] = 3] = "Meta";
  return TypeSpanData2;
})(TypeSpanData || {});
class SpanData {
  constructor(charRange, key, cssClasses, subjects, spanControllerEvents, text) {
    __publicField(this, "charRange");
    __publicField(this, "key");
    __publicField(this, "cssClasses");
    __publicField(this, "subjects");
    __publicField(this, "spanControllerEvents");
    __publicField(this, "text");
    this.charRange = charRange;
    this.key = key;
    this.cssClasses = cssClasses;
    this.subjects = subjects;
    this.spanControllerEvents = spanControllerEvents;
    this.text = text;
  }
  clone() {
    return new SpanData(this.charRange.slice(), this.key.slice(), this.cssClasses.slice(), this.subjects.slice(), this.spanControllerEvents, this.text.slice());
  }
}
function createSpanData(typeSpanData, args) {
  switch (typeSpanData) {
    case 0:
      return TextSpanData(args.charRange, args.spanText);
    case 1:
      return MarkSpanData(args.charRange, args.spanText, args.marks);
    case 2:
      return SelectionSpanData(args.charRange, args.spanText);
    case 3:
      return MetaStringSpanData(args.charRange, args.spanText);
  }
}
function TextSpanData(charRange, spanText) {
  return new SpanData(charRange, "text-" + charRange[0] + "-" + charRange[1], ["mt-textspan"], [], {
    mouseup: (event, spanData, controller) => controller.onMouseUpText(event, spanData.charRange)
  }, spanText);
}
function MarkSpanData(charRange, spanText, marks) {
  if (!(marks == null ? void 0 : marks.length))
    return TextSpanData(charRange, spanText);
  else {
    const subjects = Array.from(new Set(Array().concat(...marks.map((mark) => mark.subjects))));
    const cssClasses = subjects.map((subject) => "mt-subject-" + subject);
    return new SpanData(charRange, "markrange-" + charRange[0] + "-" + charRange[1], cssClasses, subjects, {
      mouseup: (event, spanData, controller) => controller.onMouseUpMark(event, spanData.charRange, marks)
    }, spanText);
  }
}
function SelectionSpanData(charRange, spanText) {
  return new SpanData(charRange, "selection-" + charRange[0] + "-" + charRange[1], ["mt-selection"], [], {
    mouseup: (event, spanData, controller) => controller.onMouseUpSelection(event, spanData.charRange)
  }, spanText);
}
function MetaStringSpanData(charRange, spanText) {
  return new SpanData(charRange, "meta-char-" + spanText + "-" + charRange[0] + "-" + charRange[1], ["mt-meta-char"], [], {
    mouseup: (event, spanData, controller) => controller.onMouseUpMetaString(event, spanData.charRange, spanText)
  }, spanText);
}
var __defProp2 = Object.defineProperty;
var __defNormalProp2 = (obj, key, value) => key in obj ? __defProp2(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField2 = (obj, key, value) => {
  __defNormalProp2(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
function* chunks(arr, numChunks) {
  const avgFill = Math.floor(arr.length / numChunks);
  const remainder = arr.length - avgFill * numChunks;
  let sliceIdx = 0;
  for (let i = 0; i < remainder; ++i) {
    yield arr.slice(sliceIdx, sliceIdx + avgFill + 1);
    sliceIdx += avgFill + 1;
  }
  for (let i = remainder; i < numChunks; ++i) {
    yield arr.slice(sliceIdx, sliceIdx + avgFill);
    sliceIdx += avgFill;
  }
}
function proxyArrayAccess(arr) {
  const handler = {
    get(target, prop) {
      if (!["number", "string"].includes(typeof prop))
        return target[prop];
      const numProp = Number(prop);
      if (isNaN(numProp))
        return target[prop];
      if (numProp < 0 || numProp >= target.length)
        return void 0;
      const batchIdx = target.batchIdx(numProp);
      if (batchIdx == null)
        return void 0;
      return target.rawBatches[batchIdx[0]][batchIdx[1]];
    },
    set(target, prop, val) {
      if (!["number", "string"].includes(typeof prop))
        return target[prop];
      const numProp = Number(prop);
      if (isNaN(numProp))
        return target[prop] = val;
      if (numProp < 0 || numProp >= target.length)
        return false;
      const batchIdx = target.batchIdx(numProp);
      if (batchIdx == null)
        return false;
      return target.rawBatches[batchIdx[0]][batchIdx[1]] = val;
    }
  };
  return new Proxy(arr, handler);
}
class BatchArray {
  constructor(content, batchSize) {
    __publicField2(this, "rawBatches");
    __publicField2(this, "batchSize");
    const numBatches = Math.floor((content.length - 1) / batchSize) + 1;
    this.rawBatches = [...chunks(content, numBatches)];
    this.batchSize = batchSize;
  }
  *contentIterator() {
    let idx = 0;
    for (const batch of this.rawBatches) {
      for (const item of batch) {
        yield [idx, item];
        ++idx;
      }
    }
  }
  contentIdx(batchIdx, itemIdx) {
    if (batchIdx < 0 || batchIdx >= this.length)
      return void 0;
    if (itemIdx < 0 || itemIdx >= this.rawBatches[batchIdx].length)
      return void 0;
    let totIdx = 0;
    for (let idx = 0; idx < batchIdx; ++idx)
      totIdx += this.rawBatches[idx].length;
    return totIdx + itemIdx;
  }
  batchIdx(contentIdx) {
    if (contentIdx == null)
      return void 0;
    let numItems = 0;
    let [batchIdx, itemIdx] = [-1, -1];
    for (const [idx, batch] of this.rawBatches.entries()) {
      numItems += batch.length;
      if (batchIdx === -1 && numItems > contentIdx) {
        batchIdx = idx;
        itemIdx = contentIdx - (numItems - batch.length);
        break;
      }
    }
    if (batchIdx === -1)
      return void 0;
    return [batchIdx, itemIdx];
  }
  batchIdxs(begIdx, endIdx) {
    let numItems = 0;
    let [begBatchIdx, begItemIdx, endBatchIdx, endItemIdx] = [-1, -1, -1, -1];
    for (const [idx, batch] of this.rawBatches.entries()) {
      numItems += batch.length;
      if (begBatchIdx === -1 && numItems > begIdx) {
        begBatchIdx = idx;
        begItemIdx = begIdx - (numItems - batch.length);
      }
      if (endBatchIdx === -1 && numItems >= endIdx) {
        endBatchIdx = idx;
        endItemIdx = endIdx - (numItems - batch.length);
        if (begIdx === endIdx) {
          begBatchIdx = idx;
          begItemIdx = endItemIdx;
        }
        break;
      }
    }
    while (begBatchIdx > 0 && begItemIdx === 0) {
      begBatchIdx -= 1;
      begItemIdx = this.rawBatches[begBatchIdx].length;
    }
    while (endBatchIdx < this.rawBatches.length - 1 && endItemIdx === this.rawBatches[endBatchIdx].length) {
      endBatchIdx += 1;
      endItemIdx = 0;
    }
    if (begBatchIdx === -1) {
      begBatchIdx = this.rawBatches.length - 1;
      begItemIdx = this.rawBatches[begBatchIdx].length;
    }
    if (endBatchIdx === -1) {
      endBatchIdx = this.rawBatches.length - 1;
      endItemIdx = this.rawBatches[endBatchIdx].length;
    }
    return [[begBatchIdx, begItemIdx], [endBatchIdx, endItemIdx]];
  }
  find(predicate, thisArg) {
    let totIndex = 0;
    for (const batch of this.rawBatches) {
      const batchPred = (value, index) => predicate(value, index + totIndex, this);
      const search = batch.find(batchPred, thisArg);
      if (search != null)
        return search;
      totIndex += batch.length;
    }
    return void 0;
  }
  findIndex(predicate, thisArg) {
    let totIndex = 0;
    for (const batch of this.rawBatches) {
      const batchPred = (value, index) => predicate(value, index + totIndex, this);
      const searchIdx = batch.findIndex(batchPred, thisArg);
      if (searchIdx >= 0)
        return totIndex + searchIdx;
      totIndex += batch.length;
    }
    return -1;
  }
  fill(value, start, end) {
    if (this.rawBatches.length === 0)
      return this;
    let startBatchIdx;
    if (start == null || start < -this.length)
      startBatchIdx = [0, 0];
    else if (start >= 0)
      startBatchIdx = this.batchIdx(start);
    else
      startBatchIdx = this.batchIdx(this.length + start);
    if (startBatchIdx == null)
      return this;
    let endBatchIdx;
    if (end == null || end > this.length)
      endBatchIdx = [this.rawBatches.length, 0];
    else if (end >= 0)
      endBatchIdx = this.batchIdx(end);
    else
      endBatchIdx = this.batchIdx(this.length + end);
    if (endBatchIdx == null)
      return this;
    if (startBatchIdx[0] > endBatchIdx[0])
      return this;
    if (startBatchIdx[0] === endBatchIdx[0]) {
      this.rawBatches[startBatchIdx[0]].fill(value, startBatchIdx[1], endBatchIdx[1]);
    } else {
      let batch = this.rawBatches[startBatchIdx[0]];
      batch.fill(value, startBatchIdx[1]);
      for (let batchIdx = startBatchIdx[0] + 1; batchIdx < endBatchIdx[0]; ++batchIdx) {
        batch = this.rawBatches[batchIdx];
        batch.fill(value);
      }
      batch = this.rawBatches[endBatchIdx[0]];
      batch.fill(value, void 0, endBatchIdx[1]);
    }
    return this;
  }
  copyWithin(target, start, end) {
    if (this.rawBatches.length === 0)
      return this;
    let startBatchIdx;
    if (start < -this.length)
      startBatchIdx = [0, 0];
    else if (start >= 0)
      startBatchIdx = this.batchIdx(start);
    else
      startBatchIdx = this.batchIdx(this.length + start);
    if (startBatchIdx == null)
      return this;
    let endBatchIdx;
    if (end == null || end > this.length)
      endBatchIdx = [this.rawBatches.length, 0];
    else if (end >= 0)
      endBatchIdx = this.batchIdx(end);
    else
      endBatchIdx = this.batchIdx(this.length + end);
    if (endBatchIdx == null)
      return this;
    if (startBatchIdx[0] > endBatchIdx[0])
      return this;
    let targetBatchIdx;
    if (target < -this.length)
      targetBatchIdx = [0, 0];
    else if (target >= 0)
      targetBatchIdx = this.batchIdx(target);
    else
      targetBatchIdx = this.batchIdx(this.length + target);
    if (targetBatchIdx == null)
      return this;
    if (startBatchIdx[0] === targetBatchIdx[0] && startBatchIdx[1] === targetBatchIdx[1])
      return this;
    if (startBatchIdx[0] > targetBatchIdx[0] || startBatchIdx[0] === targetBatchIdx[0] && startBatchIdx[1] > targetBatchIdx[1]) {
      let [origBatch, origItem] = startBatchIdx;
      let [copyBatch, copyItem] = targetBatchIdx;
      while (origBatch < endBatchIdx[0] || origItem < endBatchIdx[1]) {
        this.rawBatches[copyBatch][copyItem] = this.rawBatches[origBatch][origItem];
        ++origItem;
        if (origItem >= this.rawBatches[origBatch].length) {
          ++origBatch;
          origItem = 0;
        }
        ++copyItem;
        if (copyItem >= this.rawBatches[copyBatch].length) {
          ++copyBatch;
          copyItem = 0;
        }
      }
    } else {
      const realContentStart = this.contentIdx(...startBatchIdx);
      const realContentEnd = this.contentIdx(...endBatchIdx);
      const realContentTarget = this.contentIdx(...targetBatchIdx);
      const lastTarget = realContentTarget + realContentEnd - realContentStart;
      let origBatchIdx = endBatchIdx;
      let copyBatchIdx = this.batchIdx(lastTarget);
      if (copyBatchIdx == null) {
        const goodContentEnd = realContentStart + this.length - realContentTarget;
        origBatchIdx = this.batchIdx(goodContentEnd);
        copyBatchIdx = [this.rawBatches.length, 0];
      }
      let [origBatch, origItem] = origBatchIdx;
      let [copyBatch, copyItem] = copyBatchIdx;
      while (origBatch > startBatchIdx[0] || origItem > startBatchIdx[1]) {
        --origItem;
        if (origItem < 0) {
          --origBatch;
          origItem = this.rawBatches[origBatch].length - 1;
        }
        --copyItem;
        if (copyItem < 0) {
          --copyBatch;
          copyItem = this.rawBatches[copyBatch].length - 1;
        }
        this.rawBatches[copyBatch][copyItem] = this.rawBatches[origBatch][origItem];
      }
    }
    return this;
  }
  *[Symbol.iterator]() {
    for (const batch of this.rawBatches) {
      for (const item of batch)
        yield item;
    }
  }
  *entries() {
    let idx = 0;
    for (const iter of this) {
      yield [idx, iter];
      idx += 1;
    }
  }
  *keys() {
    for (const [idx] of this.entries()) {
      yield idx;
    }
  }
  *values() {
    yield* this;
  }
  includes(searchElement, fromIndex) {
    if (fromIndex == null) {
      return this.rawBatches.some((batch) => batch.includes(searchElement));
    } else {
      const startBatchIdx = this.batchIdx(fromIndex);
      if (startBatchIdx == null)
        return false;
      if (this.rawBatches[startBatchIdx[0]].includes(searchElement, startBatchIdx[1]))
        return true;
      for (let batchIdx = startBatchIdx[0] + 1; batchIdx < this.rawBatches.length; ++batchIdx) {
        if (this.rawBatches[batchIdx].includes(searchElement))
          return true;
      }
      return false;
    }
  }
  get length() {
    return this.rawBatches.reduce((num, batch) => num + batch.length, 0);
  }
  toString() {
    return this.rawBatches.toString();
  }
  toLocaleString() {
    return this.rawBatches.toLocaleString();
  }
  concat(...items) {
    const output = this.clone();
    for (const item of items) {
      if (item.rawBatches != null)
        output.rawBatches = output.rawBatches.concat(item.rawBatches);
    }
    return output;
  }
  join(separator) {
    return this.rawBatches.map((batch) => batch.join(separator)).join(separator);
  }
  reverse() {
    const output = this.clone();
    output.rawBatches = output.rawBatches.reverse().map((batch) => batch.reverse());
    return output;
  }
  slice(start, end) {
    const output = [];
    if (start == null && end == null) {
      for (const batch of this.rawBatches)
        output.push(...batch);
    } else if (end == null) {
      if (start >= this.length)
        return [];
      let begBatchIdx = this.batchIdx(start);
      if (begBatchIdx == null)
        begBatchIdx = [0, 0];
      output.push(...this.rawBatches[begBatchIdx[0]].slice(begBatchIdx[1]));
      for (let i = begBatchIdx[0] + 1; i < this.rawBatches.length; ++i)
        output.push(...this.rawBatches[i]);
    } else if (start == null) {
      if (end <= 0)
        return [];
      let endBatchIdx = this.batchIdx(end);
      if (endBatchIdx == null) {
        const last = this.rawBatches.length - 1;
        endBatchIdx = [last, this.rawBatches[last].length];
      }
      for (let i = 0; i < endBatchIdx[0] + 1 && i < this.rawBatches.length; ++i)
        output.push(...this.rawBatches[i]);
      output.push(...this.rawBatches[endBatchIdx[0]].slice(0, endBatchIdx[1]));
    } else {
      if (start >= this.length)
        return [];
      if (end <= 0)
        return [];
      let begBatchIdx = this.batchIdx(start);
      if (begBatchIdx == null)
        begBatchIdx = [0, 0];
      let endBatchIdx = this.batchIdx(end);
      if (endBatchIdx == null) {
        const last = this.rawBatches.length - 1;
        endBatchIdx = [last, this.rawBatches[last].length];
      }
      if (begBatchIdx[0] === endBatchIdx[0]) {
        output.push(...this.rawBatches[begBatchIdx[0]].slice(begBatchIdx[1], endBatchIdx[1]));
      } else {
        output.push(...this.rawBatches[begBatchIdx[0]].slice(begBatchIdx[1]));
        for (let i = begBatchIdx[0] + 1; i < endBatchIdx[0] && i < this.rawBatches.length; ++i)
          output.push(...this.rawBatches[i]);
        output.push(...this.rawBatches[endBatchIdx[0]].slice(0, endBatchIdx[1]));
      }
    }
    return output;
  }
  sort(compareFn) {
    const sortedBatches = [].concat(...this.rawBatches).sort(compareFn);
    let idx = 0;
    for (const batch of this.rawBatches) {
      for (let itemIdx = 0; itemIdx < batch.length; ++itemIdx) {
        batch[itemIdx] = sortedBatches[idx];
        idx += 1;
      }
    }
    return this;
  }
  indexOf(searchElement, fromIndex) {
    if (fromIndex == null) {
      return this.findIndex((val) => val === searchElement);
    } else {
      const startBatchIdx = this.batchIdx(fromIndex);
      if (startBatchIdx == null)
        return -1;
      let batchTot = 0;
      for (let batchIdx = 0; batchIdx < startBatchIdx[0]; ++batchIdx) {
        batchTot += this.rawBatches[batchIdx].length;
      }
      let trial = this.rawBatches[startBatchIdx[0]].indexOf(searchElement, startBatchIdx[1]);
      if (trial !== -1)
        return batchTot + trial;
      batchTot += this.rawBatches[startBatchIdx[0]].length;
      for (let batchIdx = startBatchIdx[0] + 1; batchIdx < this.rawBatches.length; ++batchIdx) {
        trial = this.rawBatches[batchIdx].indexOf(searchElement);
        if (trial !== -1)
          return batchTot + trial;
        batchTot += this.rawBatches[batchIdx].length;
      }
      return -1;
    }
  }
  lastIndexOf(searchElement, fromIndex) {
    if (this.rawBatches.length === 0)
      return -1;
    let startBatchIdx;
    if (fromIndex) {
      startBatchIdx = this.batchIdx(fromIndex);
      if (startBatchIdx == null)
        return -1;
    } else {
      startBatchIdx = [
        this.rawBatches.length - 1,
        this.rawBatches[this.rawBatches.length - 1].length
      ];
    }
    let batchTot = 0;
    for (let batchIdx = this.rawBatches.length - 1; batchIdx > startBatchIdx[0]; --batchIdx) {
      batchTot += this.rawBatches[batchIdx].length;
    }
    let trial = this.rawBatches[startBatchIdx[0]].lastIndexOf(searchElement, startBatchIdx[1]);
    batchTot += this.rawBatches[startBatchIdx[0]].length;
    if (trial !== -1)
      return this.length - batchTot + trial;
    for (let batchIdx = startBatchIdx[0] - 1; batchIdx >= 0; --batchIdx) {
      trial = this.rawBatches[batchIdx].lastIndexOf(searchElement);
      batchTot += this.rawBatches[batchIdx].length;
      if (trial !== -1)
        return this.length - batchTot + trial;
    }
    return -1;
  }
  every(predicate, thisArg) {
    return this.rawBatches.every((batch) => batch.every(predicate, thisArg));
  }
  some(predicate, thisArg) {
    return this.rawBatches.some((batch) => batch.some(predicate, thisArg));
  }
  forEach(callbackfn, thisArg) {
    this.rawBatches.forEach((batch) => batch.forEach(callbackfn, thisArg), thisArg);
  }
  map(callbackfn, thisArg) {
    const output = [];
    for (const batch of this.rawBatches)
      output.push(...batch.map(callbackfn, thisArg));
    return output;
  }
  filter(predicate, thisArg) {
    const output = [];
    for (const batch of this.rawBatches)
      output.push(...batch.filter(predicate, thisArg));
    return output;
  }
  flatMap(callback) {
    return Array.prototype.concat(...this.map(callback));
  }
  flat(depth) {
    return Array.prototype.flat(depth);
  }
  reduce(callbackfn, initialValue) {
    let reduction;
    if (initialValue != null) {
      reduction = initialValue;
      for (const batch of this.rawBatches)
        reduction = batch.reduce(callbackfn, reduction);
    } else {
      const callbackfnT = callbackfn;
      reduction = this.rawBatches[0].reduce(callbackfnT);
      for (const batch of this.rawBatches.slice(1)) {
        reduction = batch.reduce(callbackfnT, reduction);
      }
    }
    return reduction;
  }
  reduceRight(callbackfn, initialValue) {
    let reduction;
    if (initialValue != null) {
      reduction = initialValue;
      for (const batch of this.rawBatches.reverse())
        reduction = batch.reduceRight(callbackfn, reduction);
    } else {
      const callbackfnT = callbackfn;
      reduction = this.rawBatches[this.rawBatches.length - 1].reduceRight(callbackfnT);
      for (const batch of this.rawBatches.reverse().slice(1)) {
        reduction = batch.reduceRight(callbackfnT, reduction);
      }
    }
    return reduction;
  }
  at(n) {
    return n >= 0 && n < this.length ? this[n] : void 0;
  }
  [Symbol.unscopables]() {
    return {
      copyWithin: false,
      entries: false,
      fill: false,
      find: false,
      findIndex: false,
      keys: false,
      values: false
    };
  }
}
class _BubbleBatchArray extends BatchArray {
  constructor(content, maxBatchSize, minBatchSize = maxBatchSize / 2) {
    const optimalSize = minBatchSize + Math.round((maxBatchSize - minBatchSize) / 2);
    super(content, optimalSize);
    __publicField2(this, "minBatchSize");
    __publicField2(this, "maxBatchSize");
    __publicField2(this, "optimalSize");
    if (minBatchSize > maxBatchSize / 2) {
      console.warn("Minimum batch size for BubbleBatchArray should be less than half maximum batch size; setting to max/2.");
      this.minBatchSize = maxBatchSize / 2;
    } else
      this.minBatchSize = minBatchSize;
    this.maxBatchSize = maxBatchSize;
    this.optimalSize = optimalSize;
  }
  filterInPlace(callbackFcn) {
    this.rawBatches.forEach((batch, idx) => {
      this.rawBatches[idx] = batch.filter(callbackFcn);
    });
    this.mergeSmallBatches();
  }
  concat(...items) {
    let output = [];
    output = output.concat(...this.rawBatches);
    for (const item of items) {
      if (item.rawBatches)
        output = output.concat(...item.rawBatches);
    }
    return BubbleBatchArray(output, this.minBatchSize, this.maxBatchSize);
  }
  splice(begIdx, numRemoved, ...addedItems) {
    const [rmedElems, affectedBatchRange] = this.spliceNoBubble(begIdx, numRemoved, ...addedItems);
    const mergeRange = this.mergeSmallBatches(affectedBatchRange);
    this.splitLargeBatches(mergeRange);
    return rmedElems;
  }
  spliceAll(...splices) {
    if (splices.length === 0)
      return;
    const sortedSplices = splices.sort((splice1, splice2) => splice1[0] - splice2[0]);
    const reducedSplices = [sortedSplices[0]];
    let currentLast = 0;
    for (let idx = 1; idx < sortedSplices.length; ++idx) {
      const newSplice = sortedSplices[idx];
      const prevSplice = reducedSplices[currentLast];
      const prevEnd = prevSplice[0] + prevSplice[1];
      if (newSplice[0] >= prevEnd) {
        reducedSplices.push(newSplice);
        ++currentLast;
      } else
        prevSplice[1] = Math.max(prevSplice[1], prevEnd - prevSplice[0]);
    }
    const affectedBatchRanges = [];
    let prevRange = null;
    for (const splice of reducedSplices.reverse()) {
      const [, batchRange] = this.spliceNoBubble(...splice);
      if (prevRange != null && batchRange[1] >= prevRange[0]) {
        if (batchRange[0] < prevRange[0])
          prevRange[0] = batchRange[0];
      } else {
        affectedBatchRanges.push(batchRange);
        prevRange = batchRange;
      }
    }
    let mergeRanges2 = [];
    for (const batchRange of affectedBatchRanges) {
      const mergeRange = this.mergeSmallBatches(batchRange);
      const overlapping = mergeRanges2.filter((range) => range[0] < mergeRange[1] && mergeRange[0] < range[1]);
      if (overlapping.length > 0) {
        mergeRanges2 = mergeRanges2.filter((range) => !overlapping.includes(range));
        for (const r of overlapping) {
          if (r[0] < mergeRange[0])
            mergeRange[0] = r[0];
          if (r[1] < mergeRange[1])
            mergeRange[1] = r[1];
        }
      }
      mergeRanges2.push(mergeRange);
    }
    for (const batchRange of mergeRanges2) {
      this.splitLargeBatches(batchRange);
    }
  }
  spliceNoBubble(begIdx, numRemoved, ...addedItems) {
    const [[begBatch, begItem], [endBatch, endItem]] = this.batchIdxs(begIdx, begIdx + numRemoved);
    const rmedItems = [];
    if (begBatch === endBatch) {
      rmedItems.push(...this.rawBatches[begBatch].splice(begItem, numRemoved, ...addedItems));
    } else {
      const avgFill = Math.floor(addedItems.length / (endBatch - begBatch + 1));
      const remainder = addedItems.length - avgFill * (endBatch - begBatch + 1);
      let numAdded = 0;
      for (const [batchIdx, batch] of this.rawBatches.slice(begBatch, endBatch + 1).entries()) {
        let fill = avgFill;
        if (batchIdx < remainder)
          fill += 1;
        const start = batchIdx === 0 ? begItem : 0;
        const end = batchIdx === endBatch - begBatch ? endItem : batch.length;
        rmedItems.push(...batch.splice(start, end - start, ...addedItems.slice(numAdded, numAdded + fill)));
        numAdded += fill;
      }
    }
    return [rmedItems, [begBatch, endBatch + 1]];
  }
  mergeSmallBatches(batchRange = [0, this.rawBatches.length]) {
    if (batchRange[0] < 0 || batchRange[0] >= this.rawBatches.length)
      batchRange[0] = 0;
    if (batchRange[1] <= 0 || batchRange[1] > this.rawBatches.length)
      batchRange[1] = this.rawBatches.length;
    const merges = [];
    let idx = batchRange[0];
    while (idx < batchRange[1]) {
      let batch = this.rawBatches[idx];
      if (batch.length < this.minBatchSize) {
        const merge = [idx, idx + 1];
        let mergeTot = batch.length;
        ++idx;
        while (idx < this.rawBatches.length) {
          batch = this.rawBatches[idx];
          if (batch.length > this.minBatchSize)
            break;
          mergeTot += batch.length;
          if (mergeTot > this.maxBatchSize)
            break;
          merge[1] += 1;
          ++idx;
        }
        if (merge[1] - merge[0] > 1)
          merges.push(merge);
      } else {
        ++idx;
      }
    }
    let mergedSoFar = 0;
    for (const merge of merges) {
      const begMerge = merge[0] - mergedSoFar;
      const numMerge = merge[1] - merge[0];
      this.rawBatches.splice(begMerge, numMerge, [].concat(...this.rawBatches.slice(begMerge, begMerge + numMerge)));
      mergedSoFar += numMerge - 1;
    }
    return [batchRange[0], batchRange[1] - mergedSoFar];
  }
  splitLargeBatches(batchRange = [0, this.rawBatches.length]) {
    const splitIdxs = [];
    for (let idx = batchRange[0]; idx < batchRange[1]; ++idx) {
      if (this.rawBatches[idx].length > this.maxBatchSize)
        splitIdxs.push(idx);
    }
    let splitSoFar = 0;
    for (const idx of splitIdxs) {
      const splitIdx = idx + splitSoFar;
      const batch = this.rawBatches[splitIdx];
      const numSplit = Math.round(batch.length / this.optimalSize);
      this.rawBatches.splice(splitIdx, 1, ...chunks(batch, numSplit));
      splitSoFar += numSplit - 1;
    }
  }
  clone() {
    const copy = BubbleBatchArray([], this.maxBatchSize, this.minBatchSize);
    copy.rawBatches = this.rawBatches.map((batch) => batch.slice());
    return copy;
  }
  pop() {
    while (this.rawBatches.length > 0) {
      const poppedEl = this.rawBatches[this.rawBatches.length - 1].pop();
      if (poppedEl != null) {
        if (this.rawBatches[this.rawBatches.length - 1].length === 0)
          this.rawBatches.pop();
        this.mergeSmallBatches([this.rawBatches.length - 2, this.rawBatches.length - 1]);
        return poppedEl;
      } else
        this.rawBatches.pop();
    }
    return void 0;
  }
  push(...items) {
    let origEndBatchIdx = this.rawBatches.length - 1;
    if (origEndBatchIdx < 0)
      origEndBatchIdx = 0;
    if (this.rawBatches.length === 0 || this.rawBatches[this.rawBatches.length - 1].length >= this.batchSize)
      this.rawBatches.push([]);
    let elIdx = 0;
    while (elIdx < items.length) {
      const endBatch = this.rawBatches[this.rawBatches.length - 1];
      const endBatchSpace = this.batchSize - endBatch.length;
      if (items.length - elIdx <= endBatchSpace) {
        endBatch.push(...items.slice(elIdx));
      } else {
        endBatch.push(...items.slice(elIdx, elIdx + endBatchSpace));
        this.rawBatches.push([]);
      }
      elIdx += endBatchSpace;
    }
    this.splitLargeBatches([origEndBatchIdx, this.rawBatches.length]);
    return this.length;
  }
  shift() {
    while (this.rawBatches.length > 0) {
      const shiftedEl = this.rawBatches[0].shift();
      if (shiftedEl != null) {
        if (this.rawBatches[0].length === 0)
          this.rawBatches.shift();
        this.mergeSmallBatches([0, 1]);
        return shiftedEl;
      } else
        this.rawBatches.shift();
    }
    return void 0;
  }
  unshift(...items) {
    let origBegBatchIdx = 0;
    if (this.rawBatches.length === 0 || this.rawBatches[0].length >= this.batchSize) {
      this.rawBatches.unshift([]);
      origBegBatchIdx += 1;
    }
    let elIdx = items.length;
    while (elIdx > 0) {
      const begBatch = this.rawBatches[0];
      const begBatchSpace = this.batchSize - begBatch.length;
      if (elIdx <= begBatchSpace) {
        begBatch.unshift(...items.slice(0, elIdx));
      } else {
        begBatch.unshift(...items.slice(elIdx - begBatchSpace, elIdx));
        this.rawBatches.unshift([]);
        origBegBatchIdx += 1;
      }
      elIdx -= begBatchSpace;
    }
    this.splitLargeBatches([0, origBegBatchIdx + 1]);
    return this.length;
  }
}
function BubbleBatchArray(content, maxBatchSize, minBatchSize) {
  return proxyArrayAccess(new _BubbleBatchArray(content, maxBatchSize, minBatchSize));
}
class Press {
  constructor(sourceText, syncedSpanBatches, layers, batchSize, heartbeatTime = 100) {
    __publicField(this, "sourceText");
    __publicField(this, "syncedSpanBatches");
    __publicField(this, "taskQueue");
    __publicField(this, "isQueueRunning");
    __publicField(this, "shouldTaskCancel");
    __publicField(this, "layers");
    __publicField(this, "heartbeatTime");
    __publicField(this, "batchSyncTimeout");
    __publicField(this, "batchSize");
    __publicField(this, "spanDataBatchArray");
    this.sourceText = sourceText;
    this.syncedSpanBatches = syncedSpanBatches;
    this.taskQueue = [];
    this.isQueueRunning = false;
    this.shouldTaskCancel = 0;
    this.layers = layers;
    this.heartbeatTime = heartbeatTime;
    this.batchSyncTimeout = null;
    this.batchSize = batchSize;
    this.spanDataBatchArray = BubbleBatchArray([], this.batchSize);
    this.produceSpanData();
  }
  async waitForReady() {
    while (this.taskQueue.length > 0 || this.isQueueRunning) {
      await new Promise((resolve) => window.setTimeout(resolve, this.heartbeatTime));
    }
  }
  async reset() {
    this.taskQueue = [];
    this.shouldTaskCancel += 1;
    while (this.isQueueRunning) {
      await new Promise((resolve) => window.setTimeout(resolve, this.heartbeatTime));
    }
    this.shouldTaskCancel -= 1;
    this.produceSpanData();
  }
  syncSpanBatches() {
    this.batchSyncTimeout = null;
    if (this.syncedSpanBatches !== this.spanDataBatchArray.rawBatches) {
      this.syncedSpanBatches.splice(0, this.syncedSpanBatches.length, ...this.spanDataBatchArray.rawBatches);
      if (this.isQueueRunning && this.batchSyncTimeout == null) {
        this.batchSyncTimeout = window.setTimeout(() => {
          this.syncSpanBatches();
        }, this.heartbeatTime);
      }
    }
  }
  runQueue() {
    if (!this.isQueueRunning) {
      this.isQueueRunning = true;
      this.asyncRunQueue();
    }
  }
  async asyncRunQueue() {
    for (let task = this.taskQueue.shift(); task != null; task = this.taskQueue.shift()) {
      await task();
    }
    this.isQueueRunning = false;
  }
  implementPatch() {
    this.patchSpanData();
  }
  produceSpanData() {
    this.taskQueue.push(async () => {
      this.spanDataBatchArray.rawBatches = [];
      this.layers.resetPatches();
      await this.asyncFillSpanBatches();
    });
    this.runQueue();
    this.batchSyncTimeout = window.setTimeout(() => {
      this.syncSpanBatches();
    }, this.heartbeatTime);
  }
  patchSpanData() {
    this.taskQueue.push(async () => {
      await this.asyncPatchSpanData();
    });
    this.runQueue();
    this.batchSyncTimeout = window.setTimeout(() => {
      this.syncSpanBatches();
    }, this.heartbeatTime);
  }
  async asyncFillSpanBatches() {
    for await (const spans of this.batchPressLayersBtwn(0, this.sourceText.length)) {
      if (this.shouldTaskCancel)
        return;
      this.spanDataBatchArray.push(...spans);
    }
  }
  async asyncPatchSpanData() {
    const affectedRanges = calcAffectedRanges(this.layers.allPatches());
    const spanIter = this.spanDataBatchArray.contentIterator();
    const mergedSpanRanges = calcOverlappingSpanRanges(affectedRanges, spanIter);
    console.log(mergedSpanRanges);
    const spanPatch = new Patch();
    const contentIter = this.spanDataBatchArray.contentIterator();
    let curContent = contentIter.next();
    for (const spanRange of mergedSpanRanges) {
      console.log(spanRange);
      const addedSpans = [];
      for await (const spans of this.batchPressLayersBtwn(spanRange[0], spanRange[1])) {
        if (this.shouldTaskCancel)
          return;
        addedSpans.push(...spans);
      }
      while (!curContent.done && curContent.value[1].charRange[0] < spanRange[0]) {
        curContent = contentIter.next();
      }
      if (curContent.done)
        break;
      const idxChange = curContent.value[0];
      spanPatch.added.push(...addedSpans.map((val) => [idxChange, val]));
      while (!curContent.done && (curContent.value[1].charRange[1] < spanRange[1] || curContent.value[1].charRange[1] === spanRange[1] && curContent.value[1].charRange[0] < spanRange[1])) {
        spanPatch.rmed.push(curContent.value);
        curContent = contentIter.next();
      }
    }
    this.layers.resetPatches();
    if (!spanPatch.empty) {
      spanPatch.transform(this.spanDataBatchArray);
    }
  }
  *batchPressLayersBtwn(begChar, endChar, batchSize = 30) {
    const gen = this.pressLayersBtwn(begChar, endChar);
    let iter = gen.next();
    while (!iter.done) {
      const output = [];
      for (let i = 0; i < batchSize; ++i) {
        if (iter.value != null) {
          output.push(iter.value);
          iter = gen.next();
        }
      }
      yield output;
    }
  }
  *pressLayersBtwn(begChar, endChar) {
    var _a;
    let layerInfo = this.layers.layersByPriority().map((layer) => {
      const idx = layer.marks.findIndex((mark2) => mark2.endChar > begChar || mark2.begChar === mark2.endChar && mark2.begChar === begChar);
      const endIdx = layer.marks.findIndex((mark2) => mark2.begChar >= endChar);
      const mark = idx > -1 ? layer.marks[idx] : null;
      const currentMarks = [];
      return {
        idx,
        endIdx: endIdx > -1 ? endIdx : layer.marks.length,
        mark,
        currentMarks,
        layer
      };
    });
    console.log(layerInfo);
    console.log(layerInfo.map((info) => ({
      idx: info.idx,
      endIdx: info.endIdx,
      mark: info.mark != null ? info.mark : null,
      currentMarks: [...info.currentMarks]
    })));
    layerInfo = layerInfo.filter((info) => info.mark != null);
    console.log(layerInfo);
    let spanChar = begChar;
    while (spanChar < endChar) {
      let isUpcomingSet = false;
      let upcomingChar = endChar;
      let topLayerMarks = [];
      let topLayerType = TypeSpanData.Text;
      for (const info of layerInfo) {
        while (info.mark != null && info.mark.begChar <= spanChar) {
          info.currentMarks.push(info.mark);
          info.idx += 1;
          if (info.idx === info.endIdx)
            info.mark = null;
          else
            info.mark = info.layer.marks[info.idx];
        }
        const rmIdxs = [];
        const skipChar = isUpcomingSet ? upcomingChar : spanChar;
        for (let idx = 0; idx < info.currentMarks.length; ++idx) {
          const mark = info.currentMarks[idx];
          if (mark.endChar <= skipChar) {
            rmIdxs.push(idx);
            if (mark.begChar === skipChar) {
              const spanText = mark.text ? mark.text : "";
              yield createSpanData(info.layer.typeSpanData, {
                charRange: [mark.begChar, mark.endChar],
                spanText,
                marks: [mark]
              });
            }
          }
        }
        info.currentMarks = info.currentMarks.filter((_, idx) => !rmIdxs.includes(idx));
        if (!isUpcomingSet) {
          if (info.mark != null) {
            upcomingChar = Math.min(upcomingChar, info.mark.begChar);
          }
          if (info.currentMarks.length) {
            isUpcomingSet = true;
            topLayerMarks = [...info.currentMarks];
            topLayerType = info.layer.typeSpanData;
            upcomingChar = Math.min(upcomingChar, ...topLayerMarks.map((mark) => mark.endChar));
          }
        }
      }
      if (topLayerMarks.length) {
        let spanText = (_a = topLayerMarks.find((mark) => !!mark.text)) == null ? void 0 : _a.text;
        if (!spanText)
          spanText = this.sourceText.substring(spanChar, upcomingChar);
        yield createSpanData(topLayerType, {
          charRange: [spanChar, upcomingChar],
          spanText,
          marks: topLayerMarks
        });
      }
      spanChar = upcomingChar;
    }
  }
}
function calcAffectedRanges(patches) {
  const affectedRanges = [];
  for (const patch of patches) {
    for (const patchIter of patch.rmThenAddOrder()) {
      const patchRange = [patchIter[1][1].begChar, patchIter[1][1].endChar];
      const overlappingIdxs = [];
      for (const [idx, affectedRange] of affectedRanges.entries()) {
        if (affectedRange[0] < patchRange[1] && patchRange[0] < affectedRange[1])
          overlappingIdxs.push(idx);
      }
      const mergeRanges2 = [patchRange];
      for (const idx of overlappingIdxs.reverse()) {
        mergeRanges2.push(affectedRanges.splice(idx, 1)[0]);
      }
      affectedRanges.push([
        Math.min(...mergeRanges2.map((range) => range[0])),
        Math.max(...mergeRanges2.map((range) => range[1]))
      ]);
    }
  }
  arraySort_1(affectedRanges, (range0, range1) => range0[0] - range1[0]);
  return mergeRanges(affectedRanges);
}
function calcOverlappingSpanRanges(affectedRanges, spanIter) {
  const affectedSpanRanges = [];
  let curSpan = spanIter.next();
  let lastSpanData = void 0;
  while (!curSpan.done) {
    const spanData = curSpan.value[1];
    if (affectedRanges.some((range) => range[0] < spanData.charRange[1] && spanData.charRange[0] < range[1])) {
      let [begAffected, endAffected] = spanData.charRange;
      if (lastSpanData && affectedRanges.some((range) => range[0] === spanData.charRange[0])) {
        begAffected = lastSpanData.charRange[0];
      }
      lastSpanData = curSpan.value[1];
      curSpan = spanIter.next();
      if (!curSpan.done && affectedRanges.some((range) => range[1] === spanData.charRange[1])) {
        endAffected = curSpan.value[1].charRange[1];
      }
      affectedSpanRanges.push([begAffected, endAffected]);
    } else {
      if (affectedRanges.some((range) => range[0] === spanData.charRange[1] || spanData.charRange[0] === range[1])) {
        affectedSpanRanges.push(spanData.charRange);
      }
      lastSpanData = curSpan.value[1];
      curSpan = spanIter.next();
    }
  }
  return mergeRanges(affectedSpanRanges);
}
function mergeRanges(sortedSpanRanges) {
  const mergedSpanRanges = [];
  for (const range of sortedSpanRanges) {
    const lastRange = mergedSpanRanges[mergedSpanRanges.length - 1];
    if (lastRange && lastRange[1] >= range[0])
      mergedSpanRanges[mergedSpanRanges.length - 1][1] = range[1];
    else
      mergedSpanRanges.push([range[0], range[1]]);
  }
  return mergedSpanRanges;
}
class Manuscript {
  constructor(text, marks, batchSize = 20, textSpanMaxLength = 1e5) {
    __publicField(this, "text");
    __publicField(this, "layers");
    __publicField(this, "depotBatchSize");
    __publicField(this, "selectionCharRange");
    __publicField(this, "syncedSpanBatches");
    __publicField(this, "press");
    __publicField(this, "metaStringLookup");
    this.text = text;
    const textMarks = [];
    let lastSpanEnd = 0;
    for (const spanEnd of splitIntegerEvenly(text.length, textSpanMaxLength)) {
      textMarks.push({ begChar: lastSpanEnd, endChar: spanEnd, subjects: [] });
      lastSpanEnd = spanEnd;
    }
    this.layers = new Layers([
      ["selection", TypeSpanData.Selection, []],
      ["meta", TypeSpanData.Meta, []],
      ["mark", TypeSpanData.Mark, marks],
      ["base", TypeSpanData.Text, textMarks]
    ]);
    this.depotBatchSize = batchSize;
    this.selectionCharRange = null;
    this.syncedSpanBatches = reactive([]);
    this.press = new Press(this.text, this.syncedSpanBatches, this.layers, this.depotBatchSize);
    this.metaStringLookup = /* @__PURE__ */ new Map();
  }
  async waitForReady() {
    await this.press.waitForReady();
  }
  get baseText() {
    return this.text;
  }
  get batchSize() {
    return this.depotBatchSize;
  }
  set batchSize(val) {
    this.depotBatchSize = val;
  }
  get selection() {
    return this.selectionCharRange;
  }
  set selection(newSelection) {
    this.setSelection(newSelection, true);
  }
  setSelection(newSelection, immediate = true) {
    this.selectionCharRange = newSelection;
    const newMarks = newSelection == null ? [] : [{
      begChar: newSelection[0],
      endChar: newSelection[1],
      subjects: []
    }];
    this.layers.changeLayer("selection", newMarks);
    const sel = window.getSelection();
    if (sel)
      sel.removeAllRanges();
    if (immediate)
      this.press.implementPatch();
  }
  get spanBatches() {
    return this.syncedSpanBatches;
  }
  refresh() {
    this.press.implementPatch();
  }
  resetSpans() {
    this.press.reset();
  }
  changeMarks(newMarks, immediate = true) {
    this.layers.changeLayer("mark", newMarks);
    if (immediate)
      this.press.implementPatch();
  }
  metaStringEncloseSections(begSections, endSections) {
    var _a;
    const metaChars = [
      ...begSections.map((idx) => ["[", idx]),
      ...endSections.map((idx) => ["]", idx])
    ];
    if (!this.metaStringLookup.has("enclose-sections"))
      this.metaStringLookup.set("enclose-sections", []);
    (_a = this.metaStringLookup.get("enclose-sections")) == null ? void 0 : _a.push(...metaChars);
    this.refreshMetaStrings();
  }
  metaStringDivideBatches() {
    var _a;
    const metaChars = Array(...this.spanBatches.filter((batch) => batch.length > 0).map((batch) => ["|", batch[0].charRange[0]]));
    if (!this.metaStringLookup.has("divide-batches"))
      this.metaStringLookup.set("divide-batches", []);
    (_a = this.metaStringLookup.get("divide-batches")) == null ? void 0 : _a.push(...metaChars);
    this.refreshMetaStrings();
  }
  removeMetaStrings(metaStringType) {
    if (metaStringType == null) {
      this.metaStringLookup.clear();
    } else {
      this.metaStringLookup.delete(metaStringType);
    }
    this.refreshMetaStrings();
  }
  setMetaStrings(metaStrings, immediate = true) {
    const newMarks = metaStrings.map((metaString) => ({
      begChar: metaString[1],
      endChar: metaString[1],
      text: metaString[0],
      subjects: []
    }));
    this.layers.changeLayer("meta", newMarks);
    if (immediate)
      this.press.implementPatch();
  }
  refreshMetaStrings() {
    const metaChars = [].concat(...this.metaStringLookup.values());
    this.setMetaStrings(metaChars);
  }
}
function* splitIntegerEvenly(big, maxChunk) {
  const numTextMarks = Math.ceil(big / maxChunk);
  const actualSpanSize = big / numTextMarks;
  const spanBiggerNum = big % numTextMarks;
  let spanChar = 0;
  for (let i = 0; i < spanBiggerNum; ++i) {
    spanChar = spanChar + actualSpanSize + 1;
    yield spanChar;
  }
  for (let i = spanBiggerNum; i < numTextMarks; ++i) {
    spanChar = spanChar + actualSpanSize;
    yield spanChar;
  }
}
var chroma$1 = { exports: {} };
/**
 * chroma.js - JavaScript library for color conversions
 *
 * Copyright (c) 2011-2019, Gregor Aisch
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, this
 * list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation
 * and/or other materials provided with the distribution.
 *
 * 3. The name Gregor Aisch may not be used to endorse or promote products
 * derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL GREGOR AISCH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * -------------------------------------------------------
 *
 * chroma.js includes colors from colorbrewer2.org, which are released under
 * the following license:
 *
 * Copyright (c) 2002 Cynthia Brewer, Mark Harrower,
 * and The Pennsylvania State University.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific
 * language governing permissions and limitations under the License.
 *
 * ------------------------------------------------------
 *
 * Named colors are taken from X11 Color Names.
 * http://www.w3.org/TR/css3-color/#svg-color
 *
 * @preserve
 */
(function(module, exports) {
  (function(global2, factory) {
    module.exports = factory();
  })(commonjsGlobal, function() {
    var limit$2 = function(x, min2, max2) {
      if (min2 === void 0)
        min2 = 0;
      if (max2 === void 0)
        max2 = 1;
      return x < min2 ? min2 : x > max2 ? max2 : x;
    };
    var limit$1 = limit$2;
    var clip_rgb$3 = function(rgb2) {
      rgb2._clipped = false;
      rgb2._unclipped = rgb2.slice(0);
      for (var i2 = 0; i2 <= 3; i2++) {
        if (i2 < 3) {
          if (rgb2[i2] < 0 || rgb2[i2] > 255) {
            rgb2._clipped = true;
          }
          rgb2[i2] = limit$1(rgb2[i2], 0, 255);
        } else if (i2 === 3) {
          rgb2[i2] = limit$1(rgb2[i2], 0, 1);
        }
      }
      return rgb2;
    };
    var classToType = {};
    for (var i$1 = 0, list$1 = ["Boolean", "Number", "String", "Function", "Array", "Date", "RegExp", "Undefined", "Null"]; i$1 < list$1.length; i$1 += 1) {
      var name = list$1[i$1];
      classToType["[object " + name + "]"] = name.toLowerCase();
    }
    var type$p = function(obj) {
      return classToType[Object.prototype.toString.call(obj)] || "object";
    };
    var type$o = type$p;
    var unpack$B = function(args, keyOrder) {
      if (keyOrder === void 0)
        keyOrder = null;
      if (args.length >= 3) {
        return Array.prototype.slice.call(args);
      }
      if (type$o(args[0]) == "object" && keyOrder) {
        return keyOrder.split("").filter(function(k) {
          return args[0][k] !== void 0;
        }).map(function(k) {
          return args[0][k];
        });
      }
      return args[0];
    };
    var type$n = type$p;
    var last$4 = function(args) {
      if (args.length < 2) {
        return null;
      }
      var l = args.length - 1;
      if (type$n(args[l]) == "string") {
        return args[l].toLowerCase();
      }
      return null;
    };
    var PI$2 = Math.PI;
    var utils = {
      clip_rgb: clip_rgb$3,
      limit: limit$2,
      type: type$p,
      unpack: unpack$B,
      last: last$4,
      PI: PI$2,
      TWOPI: PI$2 * 2,
      PITHIRD: PI$2 / 3,
      DEG2RAD: PI$2 / 180,
      RAD2DEG: 180 / PI$2
    };
    var input$h = {
      format: {},
      autodetect: []
    };
    var last$3 = utils.last;
    var clip_rgb$2 = utils.clip_rgb;
    var type$m = utils.type;
    var _input = input$h;
    var Color$D = function Color2() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      var me = this;
      if (type$m(args[0]) === "object" && args[0].constructor && args[0].constructor === this.constructor) {
        return args[0];
      }
      var mode = last$3(args);
      var autodetect = false;
      if (!mode) {
        autodetect = true;
        if (!_input.sorted) {
          _input.autodetect = _input.autodetect.sort(function(a, b) {
            return b.p - a.p;
          });
          _input.sorted = true;
        }
        for (var i2 = 0, list2 = _input.autodetect; i2 < list2.length; i2 += 1) {
          var chk = list2[i2];
          mode = chk.test.apply(chk, args);
          if (mode) {
            break;
          }
        }
      }
      if (_input.format[mode]) {
        var rgb2 = _input.format[mode].apply(null, autodetect ? args : args.slice(0, -1));
        me._rgb = clip_rgb$2(rgb2);
      } else {
        throw new Error("unknown format: " + args);
      }
      if (me._rgb.length === 3) {
        me._rgb.push(1);
      }
    };
    Color$D.prototype.toString = function toString2() {
      if (type$m(this.hex) == "function") {
        return this.hex();
      }
      return "[" + this._rgb.join(",") + "]";
    };
    var Color_1 = Color$D;
    var chroma$k = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      return new (Function.prototype.bind.apply(chroma$k.Color, [null].concat(args)))();
    };
    chroma$k.Color = Color_1;
    chroma$k.version = "2.4.2";
    var chroma_1 = chroma$k;
    var unpack$A = utils.unpack;
    var max$2 = Math.max;
    var rgb2cmyk$1 = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      var ref = unpack$A(args, "rgb");
      var r = ref[0];
      var g = ref[1];
      var b = ref[2];
      r = r / 255;
      g = g / 255;
      b = b / 255;
      var k = 1 - max$2(r, max$2(g, b));
      var f = k < 1 ? 1 / (1 - k) : 0;
      var c = (1 - r - k) * f;
      var m = (1 - g - k) * f;
      var y = (1 - b - k) * f;
      return [c, m, y, k];
    };
    var rgb2cmyk_1 = rgb2cmyk$1;
    var unpack$z = utils.unpack;
    var cmyk2rgb = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      args = unpack$z(args, "cmyk");
      var c = args[0];
      var m = args[1];
      var y = args[2];
      var k = args[3];
      var alpha = args.length > 4 ? args[4] : 1;
      if (k === 1) {
        return [0, 0, 0, alpha];
      }
      return [
        c >= 1 ? 0 : 255 * (1 - c) * (1 - k),
        m >= 1 ? 0 : 255 * (1 - m) * (1 - k),
        y >= 1 ? 0 : 255 * (1 - y) * (1 - k),
        alpha
      ];
    };
    var cmyk2rgb_1 = cmyk2rgb;
    var chroma$j = chroma_1;
    var Color$C = Color_1;
    var input$g = input$h;
    var unpack$y = utils.unpack;
    var type$l = utils.type;
    var rgb2cmyk = rgb2cmyk_1;
    Color$C.prototype.cmyk = function() {
      return rgb2cmyk(this._rgb);
    };
    chroma$j.cmyk = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      return new (Function.prototype.bind.apply(Color$C, [null].concat(args, ["cmyk"])))();
    };
    input$g.format.cmyk = cmyk2rgb_1;
    input$g.autodetect.push({
      p: 2,
      test: function() {
        var args = [], len = arguments.length;
        while (len--)
          args[len] = arguments[len];
        args = unpack$y(args, "cmyk");
        if (type$l(args) === "array" && args.length === 4) {
          return "cmyk";
        }
      }
    });
    var unpack$x = utils.unpack;
    var last$2 = utils.last;
    var rnd = function(a) {
      return Math.round(a * 100) / 100;
    };
    var hsl2css$1 = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      var hsla = unpack$x(args, "hsla");
      var mode = last$2(args) || "lsa";
      hsla[0] = rnd(hsla[0] || 0);
      hsla[1] = rnd(hsla[1] * 100) + "%";
      hsla[2] = rnd(hsla[2] * 100) + "%";
      if (mode === "hsla" || hsla.length > 3 && hsla[3] < 1) {
        hsla[3] = hsla.length > 3 ? hsla[3] : 1;
        mode = "hsla";
      } else {
        hsla.length = 3;
      }
      return mode + "(" + hsla.join(",") + ")";
    };
    var hsl2css_1 = hsl2css$1;
    var unpack$w = utils.unpack;
    var rgb2hsl$3 = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      args = unpack$w(args, "rgba");
      var r = args[0];
      var g = args[1];
      var b = args[2];
      r /= 255;
      g /= 255;
      b /= 255;
      var min2 = Math.min(r, g, b);
      var max2 = Math.max(r, g, b);
      var l = (max2 + min2) / 2;
      var s, h;
      if (max2 === min2) {
        s = 0;
        h = Number.NaN;
      } else {
        s = l < 0.5 ? (max2 - min2) / (max2 + min2) : (max2 - min2) / (2 - max2 - min2);
      }
      if (r == max2) {
        h = (g - b) / (max2 - min2);
      } else if (g == max2) {
        h = 2 + (b - r) / (max2 - min2);
      } else if (b == max2) {
        h = 4 + (r - g) / (max2 - min2);
      }
      h *= 60;
      if (h < 0) {
        h += 360;
      }
      if (args.length > 3 && args[3] !== void 0) {
        return [h, s, l, args[3]];
      }
      return [h, s, l];
    };
    var rgb2hsl_1 = rgb2hsl$3;
    var unpack$v = utils.unpack;
    var last$1 = utils.last;
    var hsl2css = hsl2css_1;
    var rgb2hsl$2 = rgb2hsl_1;
    var round$6 = Math.round;
    var rgb2css$1 = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      var rgba = unpack$v(args, "rgba");
      var mode = last$1(args) || "rgb";
      if (mode.substr(0, 3) == "hsl") {
        return hsl2css(rgb2hsl$2(rgba), mode);
      }
      rgba[0] = round$6(rgba[0]);
      rgba[1] = round$6(rgba[1]);
      rgba[2] = round$6(rgba[2]);
      if (mode === "rgba" || rgba.length > 3 && rgba[3] < 1) {
        rgba[3] = rgba.length > 3 ? rgba[3] : 1;
        mode = "rgba";
      }
      return mode + "(" + rgba.slice(0, mode === "rgb" ? 3 : 4).join(",") + ")";
    };
    var rgb2css_1 = rgb2css$1;
    var unpack$u = utils.unpack;
    var round$5 = Math.round;
    var hsl2rgb$1 = function() {
      var assign;
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      args = unpack$u(args, "hsl");
      var h = args[0];
      var s = args[1];
      var l = args[2];
      var r, g, b;
      if (s === 0) {
        r = g = b = l * 255;
      } else {
        var t3 = [0, 0, 0];
        var c = [0, 0, 0];
        var t2 = l < 0.5 ? l * (1 + s) : l + s - l * s;
        var t1 = 2 * l - t2;
        var h_ = h / 360;
        t3[0] = h_ + 1 / 3;
        t3[1] = h_;
        t3[2] = h_ - 1 / 3;
        for (var i2 = 0; i2 < 3; i2++) {
          if (t3[i2] < 0) {
            t3[i2] += 1;
          }
          if (t3[i2] > 1) {
            t3[i2] -= 1;
          }
          if (6 * t3[i2] < 1) {
            c[i2] = t1 + (t2 - t1) * 6 * t3[i2];
          } else if (2 * t3[i2] < 1) {
            c[i2] = t2;
          } else if (3 * t3[i2] < 2) {
            c[i2] = t1 + (t2 - t1) * (2 / 3 - t3[i2]) * 6;
          } else {
            c[i2] = t1;
          }
        }
        assign = [round$5(c[0] * 255), round$5(c[1] * 255), round$5(c[2] * 255)], r = assign[0], g = assign[1], b = assign[2];
      }
      if (args.length > 3) {
        return [r, g, b, args[3]];
      }
      return [r, g, b, 1];
    };
    var hsl2rgb_1 = hsl2rgb$1;
    var hsl2rgb = hsl2rgb_1;
    var input$f = input$h;
    var RE_RGB = /^rgb\(\s*(-?\d+),\s*(-?\d+)\s*,\s*(-?\d+)\s*\)$/;
    var RE_RGBA = /^rgba\(\s*(-?\d+),\s*(-?\d+)\s*,\s*(-?\d+)\s*,\s*([01]|[01]?\.\d+)\)$/;
    var RE_RGB_PCT = /^rgb\(\s*(-?\d+(?:\.\d+)?)%,\s*(-?\d+(?:\.\d+)?)%\s*,\s*(-?\d+(?:\.\d+)?)%\s*\)$/;
    var RE_RGBA_PCT = /^rgba\(\s*(-?\d+(?:\.\d+)?)%,\s*(-?\d+(?:\.\d+)?)%\s*,\s*(-?\d+(?:\.\d+)?)%\s*,\s*([01]|[01]?\.\d+)\)$/;
    var RE_HSL = /^hsl\(\s*(-?\d+(?:\.\d+)?),\s*(-?\d+(?:\.\d+)?)%\s*,\s*(-?\d+(?:\.\d+)?)%\s*\)$/;
    var RE_HSLA = /^hsla\(\s*(-?\d+(?:\.\d+)?),\s*(-?\d+(?:\.\d+)?)%\s*,\s*(-?\d+(?:\.\d+)?)%\s*,\s*([01]|[01]?\.\d+)\)$/;
    var round$4 = Math.round;
    var css2rgb$1 = function(css) {
      css = css.toLowerCase().trim();
      var m;
      if (input$f.format.named) {
        try {
          return input$f.format.named(css);
        } catch (e) {
        }
      }
      if (m = css.match(RE_RGB)) {
        var rgb2 = m.slice(1, 4);
        for (var i2 = 0; i2 < 3; i2++) {
          rgb2[i2] = +rgb2[i2];
        }
        rgb2[3] = 1;
        return rgb2;
      }
      if (m = css.match(RE_RGBA)) {
        var rgb$1 = m.slice(1, 5);
        for (var i$12 = 0; i$12 < 4; i$12++) {
          rgb$1[i$12] = +rgb$1[i$12];
        }
        return rgb$1;
      }
      if (m = css.match(RE_RGB_PCT)) {
        var rgb$2 = m.slice(1, 4);
        for (var i$2 = 0; i$2 < 3; i$2++) {
          rgb$2[i$2] = round$4(rgb$2[i$2] * 2.55);
        }
        rgb$2[3] = 1;
        return rgb$2;
      }
      if (m = css.match(RE_RGBA_PCT)) {
        var rgb$3 = m.slice(1, 5);
        for (var i$3 = 0; i$3 < 3; i$3++) {
          rgb$3[i$3] = round$4(rgb$3[i$3] * 2.55);
        }
        rgb$3[3] = +rgb$3[3];
        return rgb$3;
      }
      if (m = css.match(RE_HSL)) {
        var hsl2 = m.slice(1, 4);
        hsl2[1] *= 0.01;
        hsl2[2] *= 0.01;
        var rgb$4 = hsl2rgb(hsl2);
        rgb$4[3] = 1;
        return rgb$4;
      }
      if (m = css.match(RE_HSLA)) {
        var hsl$1 = m.slice(1, 4);
        hsl$1[1] *= 0.01;
        hsl$1[2] *= 0.01;
        var rgb$5 = hsl2rgb(hsl$1);
        rgb$5[3] = +m[4];
        return rgb$5;
      }
    };
    css2rgb$1.test = function(s) {
      return RE_RGB.test(s) || RE_RGBA.test(s) || RE_RGB_PCT.test(s) || RE_RGBA_PCT.test(s) || RE_HSL.test(s) || RE_HSLA.test(s);
    };
    var css2rgb_1 = css2rgb$1;
    var chroma$i = chroma_1;
    var Color$B = Color_1;
    var input$e = input$h;
    var type$k = utils.type;
    var rgb2css = rgb2css_1;
    var css2rgb = css2rgb_1;
    Color$B.prototype.css = function(mode) {
      return rgb2css(this._rgb, mode);
    };
    chroma$i.css = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      return new (Function.prototype.bind.apply(Color$B, [null].concat(args, ["css"])))();
    };
    input$e.format.css = css2rgb;
    input$e.autodetect.push({
      p: 5,
      test: function(h) {
        var rest = [], len = arguments.length - 1;
        while (len-- > 0)
          rest[len] = arguments[len + 1];
        if (!rest.length && type$k(h) === "string" && css2rgb.test(h)) {
          return "css";
        }
      }
    });
    var Color$A = Color_1;
    var chroma$h = chroma_1;
    var input$d = input$h;
    var unpack$t = utils.unpack;
    input$d.format.gl = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      var rgb2 = unpack$t(args, "rgba");
      rgb2[0] *= 255;
      rgb2[1] *= 255;
      rgb2[2] *= 255;
      return rgb2;
    };
    chroma$h.gl = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      return new (Function.prototype.bind.apply(Color$A, [null].concat(args, ["gl"])))();
    };
    Color$A.prototype.gl = function() {
      var rgb2 = this._rgb;
      return [rgb2[0] / 255, rgb2[1] / 255, rgb2[2] / 255, rgb2[3]];
    };
    var unpack$s = utils.unpack;
    var rgb2hcg$1 = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      var ref = unpack$s(args, "rgb");
      var r = ref[0];
      var g = ref[1];
      var b = ref[2];
      var min2 = Math.min(r, g, b);
      var max2 = Math.max(r, g, b);
      var delta = max2 - min2;
      var c = delta * 100 / 255;
      var _g = min2 / (255 - delta) * 100;
      var h;
      if (delta === 0) {
        h = Number.NaN;
      } else {
        if (r === max2) {
          h = (g - b) / delta;
        }
        if (g === max2) {
          h = 2 + (b - r) / delta;
        }
        if (b === max2) {
          h = 4 + (r - g) / delta;
        }
        h *= 60;
        if (h < 0) {
          h += 360;
        }
      }
      return [h, c, _g];
    };
    var rgb2hcg_1 = rgb2hcg$1;
    var unpack$r = utils.unpack;
    var floor$3 = Math.floor;
    var hcg2rgb = function() {
      var assign, assign$1, assign$2, assign$3, assign$4, assign$5;
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      args = unpack$r(args, "hcg");
      var h = args[0];
      var c = args[1];
      var _g = args[2];
      var r, g, b;
      _g = _g * 255;
      var _c = c * 255;
      if (c === 0) {
        r = g = b = _g;
      } else {
        if (h === 360) {
          h = 0;
        }
        if (h > 360) {
          h -= 360;
        }
        if (h < 0) {
          h += 360;
        }
        h /= 60;
        var i2 = floor$3(h);
        var f = h - i2;
        var p = _g * (1 - c);
        var q = p + _c * (1 - f);
        var t = p + _c * f;
        var v = p + _c;
        switch (i2) {
          case 0:
            assign = [v, t, p], r = assign[0], g = assign[1], b = assign[2];
            break;
          case 1:
            assign$1 = [q, v, p], r = assign$1[0], g = assign$1[1], b = assign$1[2];
            break;
          case 2:
            assign$2 = [p, v, t], r = assign$2[0], g = assign$2[1], b = assign$2[2];
            break;
          case 3:
            assign$3 = [p, q, v], r = assign$3[0], g = assign$3[1], b = assign$3[2];
            break;
          case 4:
            assign$4 = [t, p, v], r = assign$4[0], g = assign$4[1], b = assign$4[2];
            break;
          case 5:
            assign$5 = [v, p, q], r = assign$5[0], g = assign$5[1], b = assign$5[2];
            break;
        }
      }
      return [r, g, b, args.length > 3 ? args[3] : 1];
    };
    var hcg2rgb_1 = hcg2rgb;
    var unpack$q = utils.unpack;
    var type$j = utils.type;
    var chroma$g = chroma_1;
    var Color$z = Color_1;
    var input$c = input$h;
    var rgb2hcg = rgb2hcg_1;
    Color$z.prototype.hcg = function() {
      return rgb2hcg(this._rgb);
    };
    chroma$g.hcg = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      return new (Function.prototype.bind.apply(Color$z, [null].concat(args, ["hcg"])))();
    };
    input$c.format.hcg = hcg2rgb_1;
    input$c.autodetect.push({
      p: 1,
      test: function() {
        var args = [], len = arguments.length;
        while (len--)
          args[len] = arguments[len];
        args = unpack$q(args, "hcg");
        if (type$j(args) === "array" && args.length === 3) {
          return "hcg";
        }
      }
    });
    var unpack$p = utils.unpack;
    var last = utils.last;
    var round$3 = Math.round;
    var rgb2hex$2 = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      var ref = unpack$p(args, "rgba");
      var r = ref[0];
      var g = ref[1];
      var b = ref[2];
      var a = ref[3];
      var mode = last(args) || "auto";
      if (a === void 0) {
        a = 1;
      }
      if (mode === "auto") {
        mode = a < 1 ? "rgba" : "rgb";
      }
      r = round$3(r);
      g = round$3(g);
      b = round$3(b);
      var u = r << 16 | g << 8 | b;
      var str = "000000" + u.toString(16);
      str = str.substr(str.length - 6);
      var hxa = "0" + round$3(a * 255).toString(16);
      hxa = hxa.substr(hxa.length - 2);
      switch (mode.toLowerCase()) {
        case "rgba":
          return "#" + str + hxa;
        case "argb":
          return "#" + hxa + str;
        default:
          return "#" + str;
      }
    };
    var rgb2hex_1 = rgb2hex$2;
    var RE_HEX = /^#?([A-Fa-f0-9]{6}|[A-Fa-f0-9]{3})$/;
    var RE_HEXA = /^#?([A-Fa-f0-9]{8}|[A-Fa-f0-9]{4})$/;
    var hex2rgb$1 = function(hex) {
      if (hex.match(RE_HEX)) {
        if (hex.length === 4 || hex.length === 7) {
          hex = hex.substr(1);
        }
        if (hex.length === 3) {
          hex = hex.split("");
          hex = hex[0] + hex[0] + hex[1] + hex[1] + hex[2] + hex[2];
        }
        var u = parseInt(hex, 16);
        var r = u >> 16;
        var g = u >> 8 & 255;
        var b = u & 255;
        return [r, g, b, 1];
      }
      if (hex.match(RE_HEXA)) {
        if (hex.length === 5 || hex.length === 9) {
          hex = hex.substr(1);
        }
        if (hex.length === 4) {
          hex = hex.split("");
          hex = hex[0] + hex[0] + hex[1] + hex[1] + hex[2] + hex[2] + hex[3] + hex[3];
        }
        var u$1 = parseInt(hex, 16);
        var r$1 = u$1 >> 24 & 255;
        var g$1 = u$1 >> 16 & 255;
        var b$1 = u$1 >> 8 & 255;
        var a = Math.round((u$1 & 255) / 255 * 100) / 100;
        return [r$1, g$1, b$1, a];
      }
      throw new Error("unknown hex color: " + hex);
    };
    var hex2rgb_1 = hex2rgb$1;
    var chroma$f = chroma_1;
    var Color$y = Color_1;
    var type$i = utils.type;
    var input$b = input$h;
    var rgb2hex$1 = rgb2hex_1;
    Color$y.prototype.hex = function(mode) {
      return rgb2hex$1(this._rgb, mode);
    };
    chroma$f.hex = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      return new (Function.prototype.bind.apply(Color$y, [null].concat(args, ["hex"])))();
    };
    input$b.format.hex = hex2rgb_1;
    input$b.autodetect.push({
      p: 4,
      test: function(h) {
        var rest = [], len = arguments.length - 1;
        while (len-- > 0)
          rest[len] = arguments[len + 1];
        if (!rest.length && type$i(h) === "string" && [3, 4, 5, 6, 7, 8, 9].indexOf(h.length) >= 0) {
          return "hex";
        }
      }
    });
    var unpack$o = utils.unpack;
    var TWOPI$2 = utils.TWOPI;
    var min$2 = Math.min;
    var sqrt$4 = Math.sqrt;
    var acos = Math.acos;
    var rgb2hsi$1 = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      var ref = unpack$o(args, "rgb");
      var r = ref[0];
      var g = ref[1];
      var b = ref[2];
      r /= 255;
      g /= 255;
      b /= 255;
      var h;
      var min_ = min$2(r, g, b);
      var i2 = (r + g + b) / 3;
      var s = i2 > 0 ? 1 - min_ / i2 : 0;
      if (s === 0) {
        h = NaN;
      } else {
        h = (r - g + (r - b)) / 2;
        h /= sqrt$4((r - g) * (r - g) + (r - b) * (g - b));
        h = acos(h);
        if (b > g) {
          h = TWOPI$2 - h;
        }
        h /= TWOPI$2;
      }
      return [h * 360, s, i2];
    };
    var rgb2hsi_1 = rgb2hsi$1;
    var unpack$n = utils.unpack;
    var limit = utils.limit;
    var TWOPI$1 = utils.TWOPI;
    var PITHIRD = utils.PITHIRD;
    var cos$4 = Math.cos;
    var hsi2rgb = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      args = unpack$n(args, "hsi");
      var h = args[0];
      var s = args[1];
      var i2 = args[2];
      var r, g, b;
      if (isNaN(h)) {
        h = 0;
      }
      if (isNaN(s)) {
        s = 0;
      }
      if (h > 360) {
        h -= 360;
      }
      if (h < 0) {
        h += 360;
      }
      h /= 360;
      if (h < 1 / 3) {
        b = (1 - s) / 3;
        r = (1 + s * cos$4(TWOPI$1 * h) / cos$4(PITHIRD - TWOPI$1 * h)) / 3;
        g = 1 - (b + r);
      } else if (h < 2 / 3) {
        h -= 1 / 3;
        r = (1 - s) / 3;
        g = (1 + s * cos$4(TWOPI$1 * h) / cos$4(PITHIRD - TWOPI$1 * h)) / 3;
        b = 1 - (r + g);
      } else {
        h -= 2 / 3;
        g = (1 - s) / 3;
        b = (1 + s * cos$4(TWOPI$1 * h) / cos$4(PITHIRD - TWOPI$1 * h)) / 3;
        r = 1 - (g + b);
      }
      r = limit(i2 * r * 3);
      g = limit(i2 * g * 3);
      b = limit(i2 * b * 3);
      return [r * 255, g * 255, b * 255, args.length > 3 ? args[3] : 1];
    };
    var hsi2rgb_1 = hsi2rgb;
    var unpack$m = utils.unpack;
    var type$h = utils.type;
    var chroma$e = chroma_1;
    var Color$x = Color_1;
    var input$a = input$h;
    var rgb2hsi = rgb2hsi_1;
    Color$x.prototype.hsi = function() {
      return rgb2hsi(this._rgb);
    };
    chroma$e.hsi = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      return new (Function.prototype.bind.apply(Color$x, [null].concat(args, ["hsi"])))();
    };
    input$a.format.hsi = hsi2rgb_1;
    input$a.autodetect.push({
      p: 2,
      test: function() {
        var args = [], len = arguments.length;
        while (len--)
          args[len] = arguments[len];
        args = unpack$m(args, "hsi");
        if (type$h(args) === "array" && args.length === 3) {
          return "hsi";
        }
      }
    });
    var unpack$l = utils.unpack;
    var type$g = utils.type;
    var chroma$d = chroma_1;
    var Color$w = Color_1;
    var input$9 = input$h;
    var rgb2hsl$1 = rgb2hsl_1;
    Color$w.prototype.hsl = function() {
      return rgb2hsl$1(this._rgb);
    };
    chroma$d.hsl = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      return new (Function.prototype.bind.apply(Color$w, [null].concat(args, ["hsl"])))();
    };
    input$9.format.hsl = hsl2rgb_1;
    input$9.autodetect.push({
      p: 2,
      test: function() {
        var args = [], len = arguments.length;
        while (len--)
          args[len] = arguments[len];
        args = unpack$l(args, "hsl");
        if (type$g(args) === "array" && args.length === 3) {
          return "hsl";
        }
      }
    });
    var unpack$k = utils.unpack;
    var min$1 = Math.min;
    var max$1 = Math.max;
    var rgb2hsl = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      args = unpack$k(args, "rgb");
      var r = args[0];
      var g = args[1];
      var b = args[2];
      var min_ = min$1(r, g, b);
      var max_ = max$1(r, g, b);
      var delta = max_ - min_;
      var h, s, v;
      v = max_ / 255;
      if (max_ === 0) {
        h = Number.NaN;
        s = 0;
      } else {
        s = delta / max_;
        if (r === max_) {
          h = (g - b) / delta;
        }
        if (g === max_) {
          h = 2 + (b - r) / delta;
        }
        if (b === max_) {
          h = 4 + (r - g) / delta;
        }
        h *= 60;
        if (h < 0) {
          h += 360;
        }
      }
      return [h, s, v];
    };
    var rgb2hsv$1 = rgb2hsl;
    var unpack$j = utils.unpack;
    var floor$2 = Math.floor;
    var hsv2rgb = function() {
      var assign, assign$1, assign$2, assign$3, assign$4, assign$5;
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      args = unpack$j(args, "hsv");
      var h = args[0];
      var s = args[1];
      var v = args[2];
      var r, g, b;
      v *= 255;
      if (s === 0) {
        r = g = b = v;
      } else {
        if (h === 360) {
          h = 0;
        }
        if (h > 360) {
          h -= 360;
        }
        if (h < 0) {
          h += 360;
        }
        h /= 60;
        var i2 = floor$2(h);
        var f = h - i2;
        var p = v * (1 - s);
        var q = v * (1 - s * f);
        var t = v * (1 - s * (1 - f));
        switch (i2) {
          case 0:
            assign = [v, t, p], r = assign[0], g = assign[1], b = assign[2];
            break;
          case 1:
            assign$1 = [q, v, p], r = assign$1[0], g = assign$1[1], b = assign$1[2];
            break;
          case 2:
            assign$2 = [p, v, t], r = assign$2[0], g = assign$2[1], b = assign$2[2];
            break;
          case 3:
            assign$3 = [p, q, v], r = assign$3[0], g = assign$3[1], b = assign$3[2];
            break;
          case 4:
            assign$4 = [t, p, v], r = assign$4[0], g = assign$4[1], b = assign$4[2];
            break;
          case 5:
            assign$5 = [v, p, q], r = assign$5[0], g = assign$5[1], b = assign$5[2];
            break;
        }
      }
      return [r, g, b, args.length > 3 ? args[3] : 1];
    };
    var hsv2rgb_1 = hsv2rgb;
    var unpack$i = utils.unpack;
    var type$f = utils.type;
    var chroma$c = chroma_1;
    var Color$v = Color_1;
    var input$8 = input$h;
    var rgb2hsv = rgb2hsv$1;
    Color$v.prototype.hsv = function() {
      return rgb2hsv(this._rgb);
    };
    chroma$c.hsv = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      return new (Function.prototype.bind.apply(Color$v, [null].concat(args, ["hsv"])))();
    };
    input$8.format.hsv = hsv2rgb_1;
    input$8.autodetect.push({
      p: 2,
      test: function() {
        var args = [], len = arguments.length;
        while (len--)
          args[len] = arguments[len];
        args = unpack$i(args, "hsv");
        if (type$f(args) === "array" && args.length === 3) {
          return "hsv";
        }
      }
    });
    var labConstants = {
      Kn: 18,
      Xn: 0.95047,
      Yn: 1,
      Zn: 1.08883,
      t0: 0.137931034,
      t1: 0.206896552,
      t2: 0.12841855,
      t3: 8856452e-9
    };
    var LAB_CONSTANTS$3 = labConstants;
    var unpack$h = utils.unpack;
    var pow$a = Math.pow;
    var rgb2lab$2 = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      var ref = unpack$h(args, "rgb");
      var r = ref[0];
      var g = ref[1];
      var b = ref[2];
      var ref$1 = rgb2xyz(r, g, b);
      var x = ref$1[0];
      var y = ref$1[1];
      var z = ref$1[2];
      var l = 116 * y - 16;
      return [l < 0 ? 0 : l, 500 * (x - y), 200 * (y - z)];
    };
    var rgb_xyz = function(r) {
      if ((r /= 255) <= 0.04045) {
        return r / 12.92;
      }
      return pow$a((r + 0.055) / 1.055, 2.4);
    };
    var xyz_lab = function(t) {
      if (t > LAB_CONSTANTS$3.t3) {
        return pow$a(t, 1 / 3);
      }
      return t / LAB_CONSTANTS$3.t2 + LAB_CONSTANTS$3.t0;
    };
    var rgb2xyz = function(r, g, b) {
      r = rgb_xyz(r);
      g = rgb_xyz(g);
      b = rgb_xyz(b);
      var x = xyz_lab((0.4124564 * r + 0.3575761 * g + 0.1804375 * b) / LAB_CONSTANTS$3.Xn);
      var y = xyz_lab((0.2126729 * r + 0.7151522 * g + 0.072175 * b) / LAB_CONSTANTS$3.Yn);
      var z = xyz_lab((0.0193339 * r + 0.119192 * g + 0.9503041 * b) / LAB_CONSTANTS$3.Zn);
      return [x, y, z];
    };
    var rgb2lab_1 = rgb2lab$2;
    var LAB_CONSTANTS$2 = labConstants;
    var unpack$g = utils.unpack;
    var pow$9 = Math.pow;
    var lab2rgb$1 = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      args = unpack$g(args, "lab");
      var l = args[0];
      var a = args[1];
      var b = args[2];
      var x, y, z, r, g, b_;
      y = (l + 16) / 116;
      x = isNaN(a) ? y : y + a / 500;
      z = isNaN(b) ? y : y - b / 200;
      y = LAB_CONSTANTS$2.Yn * lab_xyz(y);
      x = LAB_CONSTANTS$2.Xn * lab_xyz(x);
      z = LAB_CONSTANTS$2.Zn * lab_xyz(z);
      r = xyz_rgb(3.2404542 * x - 1.5371385 * y - 0.4985314 * z);
      g = xyz_rgb(-0.969266 * x + 1.8760108 * y + 0.041556 * z);
      b_ = xyz_rgb(0.0556434 * x - 0.2040259 * y + 1.0572252 * z);
      return [r, g, b_, args.length > 3 ? args[3] : 1];
    };
    var xyz_rgb = function(r) {
      return 255 * (r <= 304e-5 ? 12.92 * r : 1.055 * pow$9(r, 1 / 2.4) - 0.055);
    };
    var lab_xyz = function(t) {
      return t > LAB_CONSTANTS$2.t1 ? t * t * t : LAB_CONSTANTS$2.t2 * (t - LAB_CONSTANTS$2.t0);
    };
    var lab2rgb_1 = lab2rgb$1;
    var unpack$f = utils.unpack;
    var type$e = utils.type;
    var chroma$b = chroma_1;
    var Color$u = Color_1;
    var input$7 = input$h;
    var rgb2lab$1 = rgb2lab_1;
    Color$u.prototype.lab = function() {
      return rgb2lab$1(this._rgb);
    };
    chroma$b.lab = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      return new (Function.prototype.bind.apply(Color$u, [null].concat(args, ["lab"])))();
    };
    input$7.format.lab = lab2rgb_1;
    input$7.autodetect.push({
      p: 2,
      test: function() {
        var args = [], len = arguments.length;
        while (len--)
          args[len] = arguments[len];
        args = unpack$f(args, "lab");
        if (type$e(args) === "array" && args.length === 3) {
          return "lab";
        }
      }
    });
    var unpack$e = utils.unpack;
    var RAD2DEG = utils.RAD2DEG;
    var sqrt$3 = Math.sqrt;
    var atan2$2 = Math.atan2;
    var round$2 = Math.round;
    var lab2lch$2 = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      var ref = unpack$e(args, "lab");
      var l = ref[0];
      var a = ref[1];
      var b = ref[2];
      var c = sqrt$3(a * a + b * b);
      var h = (atan2$2(b, a) * RAD2DEG + 360) % 360;
      if (round$2(c * 1e4) === 0) {
        h = Number.NaN;
      }
      return [l, c, h];
    };
    var lab2lch_1 = lab2lch$2;
    var unpack$d = utils.unpack;
    var rgb2lab = rgb2lab_1;
    var lab2lch$1 = lab2lch_1;
    var rgb2lch$1 = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      var ref = unpack$d(args, "rgb");
      var r = ref[0];
      var g = ref[1];
      var b = ref[2];
      var ref$1 = rgb2lab(r, g, b);
      var l = ref$1[0];
      var a = ref$1[1];
      var b_ = ref$1[2];
      return lab2lch$1(l, a, b_);
    };
    var rgb2lch_1 = rgb2lch$1;
    var unpack$c = utils.unpack;
    var DEG2RAD = utils.DEG2RAD;
    var sin$3 = Math.sin;
    var cos$3 = Math.cos;
    var lch2lab$2 = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      var ref = unpack$c(args, "lch");
      var l = ref[0];
      var c = ref[1];
      var h = ref[2];
      if (isNaN(h)) {
        h = 0;
      }
      h = h * DEG2RAD;
      return [l, cos$3(h) * c, sin$3(h) * c];
    };
    var lch2lab_1 = lch2lab$2;
    var unpack$b = utils.unpack;
    var lch2lab$1 = lch2lab_1;
    var lab2rgb = lab2rgb_1;
    var lch2rgb$1 = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      args = unpack$b(args, "lch");
      var l = args[0];
      var c = args[1];
      var h = args[2];
      var ref = lch2lab$1(l, c, h);
      var L = ref[0];
      var a = ref[1];
      var b_ = ref[2];
      var ref$1 = lab2rgb(L, a, b_);
      var r = ref$1[0];
      var g = ref$1[1];
      var b = ref$1[2];
      return [r, g, b, args.length > 3 ? args[3] : 1];
    };
    var lch2rgb_1 = lch2rgb$1;
    var unpack$a = utils.unpack;
    var lch2rgb = lch2rgb_1;
    var hcl2rgb = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      var hcl = unpack$a(args, "hcl").reverse();
      return lch2rgb.apply(void 0, hcl);
    };
    var hcl2rgb_1 = hcl2rgb;
    var unpack$9 = utils.unpack;
    var type$d = utils.type;
    var chroma$a = chroma_1;
    var Color$t = Color_1;
    var input$6 = input$h;
    var rgb2lch = rgb2lch_1;
    Color$t.prototype.lch = function() {
      return rgb2lch(this._rgb);
    };
    Color$t.prototype.hcl = function() {
      return rgb2lch(this._rgb).reverse();
    };
    chroma$a.lch = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      return new (Function.prototype.bind.apply(Color$t, [null].concat(args, ["lch"])))();
    };
    chroma$a.hcl = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      return new (Function.prototype.bind.apply(Color$t, [null].concat(args, ["hcl"])))();
    };
    input$6.format.lch = lch2rgb_1;
    input$6.format.hcl = hcl2rgb_1;
    ["lch", "hcl"].forEach(function(m) {
      return input$6.autodetect.push({
        p: 2,
        test: function() {
          var args = [], len = arguments.length;
          while (len--)
            args[len] = arguments[len];
          args = unpack$9(args, m);
          if (type$d(args) === "array" && args.length === 3) {
            return m;
          }
        }
      });
    });
    var w3cx11$1 = {
      aliceblue: "#f0f8ff",
      antiquewhite: "#faebd7",
      aqua: "#00ffff",
      aquamarine: "#7fffd4",
      azure: "#f0ffff",
      beige: "#f5f5dc",
      bisque: "#ffe4c4",
      black: "#000000",
      blanchedalmond: "#ffebcd",
      blue: "#0000ff",
      blueviolet: "#8a2be2",
      brown: "#a52a2a",
      burlywood: "#deb887",
      cadetblue: "#5f9ea0",
      chartreuse: "#7fff00",
      chocolate: "#d2691e",
      coral: "#ff7f50",
      cornflower: "#6495ed",
      cornflowerblue: "#6495ed",
      cornsilk: "#fff8dc",
      crimson: "#dc143c",
      cyan: "#00ffff",
      darkblue: "#00008b",
      darkcyan: "#008b8b",
      darkgoldenrod: "#b8860b",
      darkgray: "#a9a9a9",
      darkgreen: "#006400",
      darkgrey: "#a9a9a9",
      darkkhaki: "#bdb76b",
      darkmagenta: "#8b008b",
      darkolivegreen: "#556b2f",
      darkorange: "#ff8c00",
      darkorchid: "#9932cc",
      darkred: "#8b0000",
      darksalmon: "#e9967a",
      darkseagreen: "#8fbc8f",
      darkslateblue: "#483d8b",
      darkslategray: "#2f4f4f",
      darkslategrey: "#2f4f4f",
      darkturquoise: "#00ced1",
      darkviolet: "#9400d3",
      deeppink: "#ff1493",
      deepskyblue: "#00bfff",
      dimgray: "#696969",
      dimgrey: "#696969",
      dodgerblue: "#1e90ff",
      firebrick: "#b22222",
      floralwhite: "#fffaf0",
      forestgreen: "#228b22",
      fuchsia: "#ff00ff",
      gainsboro: "#dcdcdc",
      ghostwhite: "#f8f8ff",
      gold: "#ffd700",
      goldenrod: "#daa520",
      gray: "#808080",
      green: "#008000",
      greenyellow: "#adff2f",
      grey: "#808080",
      honeydew: "#f0fff0",
      hotpink: "#ff69b4",
      indianred: "#cd5c5c",
      indigo: "#4b0082",
      ivory: "#fffff0",
      khaki: "#f0e68c",
      laserlemon: "#ffff54",
      lavender: "#e6e6fa",
      lavenderblush: "#fff0f5",
      lawngreen: "#7cfc00",
      lemonchiffon: "#fffacd",
      lightblue: "#add8e6",
      lightcoral: "#f08080",
      lightcyan: "#e0ffff",
      lightgoldenrod: "#fafad2",
      lightgoldenrodyellow: "#fafad2",
      lightgray: "#d3d3d3",
      lightgreen: "#90ee90",
      lightgrey: "#d3d3d3",
      lightpink: "#ffb6c1",
      lightsalmon: "#ffa07a",
      lightseagreen: "#20b2aa",
      lightskyblue: "#87cefa",
      lightslategray: "#778899",
      lightslategrey: "#778899",
      lightsteelblue: "#b0c4de",
      lightyellow: "#ffffe0",
      lime: "#00ff00",
      limegreen: "#32cd32",
      linen: "#faf0e6",
      magenta: "#ff00ff",
      maroon: "#800000",
      maroon2: "#7f0000",
      maroon3: "#b03060",
      mediumaquamarine: "#66cdaa",
      mediumblue: "#0000cd",
      mediumorchid: "#ba55d3",
      mediumpurple: "#9370db",
      mediumseagreen: "#3cb371",
      mediumslateblue: "#7b68ee",
      mediumspringgreen: "#00fa9a",
      mediumturquoise: "#48d1cc",
      mediumvioletred: "#c71585",
      midnightblue: "#191970",
      mintcream: "#f5fffa",
      mistyrose: "#ffe4e1",
      moccasin: "#ffe4b5",
      navajowhite: "#ffdead",
      navy: "#000080",
      oldlace: "#fdf5e6",
      olive: "#808000",
      olivedrab: "#6b8e23",
      orange: "#ffa500",
      orangered: "#ff4500",
      orchid: "#da70d6",
      palegoldenrod: "#eee8aa",
      palegreen: "#98fb98",
      paleturquoise: "#afeeee",
      palevioletred: "#db7093",
      papayawhip: "#ffefd5",
      peachpuff: "#ffdab9",
      peru: "#cd853f",
      pink: "#ffc0cb",
      plum: "#dda0dd",
      powderblue: "#b0e0e6",
      purple: "#800080",
      purple2: "#7f007f",
      purple3: "#a020f0",
      rebeccapurple: "#663399",
      red: "#ff0000",
      rosybrown: "#bc8f8f",
      royalblue: "#4169e1",
      saddlebrown: "#8b4513",
      salmon: "#fa8072",
      sandybrown: "#f4a460",
      seagreen: "#2e8b57",
      seashell: "#fff5ee",
      sienna: "#a0522d",
      silver: "#c0c0c0",
      skyblue: "#87ceeb",
      slateblue: "#6a5acd",
      slategray: "#708090",
      slategrey: "#708090",
      snow: "#fffafa",
      springgreen: "#00ff7f",
      steelblue: "#4682b4",
      tan: "#d2b48c",
      teal: "#008080",
      thistle: "#d8bfd8",
      tomato: "#ff6347",
      turquoise: "#40e0d0",
      violet: "#ee82ee",
      wheat: "#f5deb3",
      white: "#ffffff",
      whitesmoke: "#f5f5f5",
      yellow: "#ffff00",
      yellowgreen: "#9acd32"
    };
    var w3cx11_1 = w3cx11$1;
    var Color$s = Color_1;
    var input$5 = input$h;
    var type$c = utils.type;
    var w3cx11 = w3cx11_1;
    var hex2rgb = hex2rgb_1;
    var rgb2hex = rgb2hex_1;
    Color$s.prototype.name = function() {
      var hex = rgb2hex(this._rgb, "rgb");
      for (var i2 = 0, list2 = Object.keys(w3cx11); i2 < list2.length; i2 += 1) {
        var n = list2[i2];
        if (w3cx11[n] === hex) {
          return n.toLowerCase();
        }
      }
      return hex;
    };
    input$5.format.named = function(name2) {
      name2 = name2.toLowerCase();
      if (w3cx11[name2]) {
        return hex2rgb(w3cx11[name2]);
      }
      throw new Error("unknown color name: " + name2);
    };
    input$5.autodetect.push({
      p: 5,
      test: function(h) {
        var rest = [], len = arguments.length - 1;
        while (len-- > 0)
          rest[len] = arguments[len + 1];
        if (!rest.length && type$c(h) === "string" && w3cx11[h.toLowerCase()]) {
          return "named";
        }
      }
    });
    var unpack$8 = utils.unpack;
    var rgb2num$1 = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      var ref = unpack$8(args, "rgb");
      var r = ref[0];
      var g = ref[1];
      var b = ref[2];
      return (r << 16) + (g << 8) + b;
    };
    var rgb2num_1 = rgb2num$1;
    var type$b = utils.type;
    var num2rgb = function(num2) {
      if (type$b(num2) == "number" && num2 >= 0 && num2 <= 16777215) {
        var r = num2 >> 16;
        var g = num2 >> 8 & 255;
        var b = num2 & 255;
        return [r, g, b, 1];
      }
      throw new Error("unknown num color: " + num2);
    };
    var num2rgb_1 = num2rgb;
    var chroma$9 = chroma_1;
    var Color$r = Color_1;
    var input$4 = input$h;
    var type$a = utils.type;
    var rgb2num = rgb2num_1;
    Color$r.prototype.num = function() {
      return rgb2num(this._rgb);
    };
    chroma$9.num = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      return new (Function.prototype.bind.apply(Color$r, [null].concat(args, ["num"])))();
    };
    input$4.format.num = num2rgb_1;
    input$4.autodetect.push({
      p: 5,
      test: function() {
        var args = [], len = arguments.length;
        while (len--)
          args[len] = arguments[len];
        if (args.length === 1 && type$a(args[0]) === "number" && args[0] >= 0 && args[0] <= 16777215) {
          return "num";
        }
      }
    });
    var chroma$8 = chroma_1;
    var Color$q = Color_1;
    var input$3 = input$h;
    var unpack$7 = utils.unpack;
    var type$9 = utils.type;
    var round$1 = Math.round;
    Color$q.prototype.rgb = function(rnd2) {
      if (rnd2 === void 0)
        rnd2 = true;
      if (rnd2 === false) {
        return this._rgb.slice(0, 3);
      }
      return this._rgb.slice(0, 3).map(round$1);
    };
    Color$q.prototype.rgba = function(rnd2) {
      if (rnd2 === void 0)
        rnd2 = true;
      return this._rgb.slice(0, 4).map(function(v, i2) {
        return i2 < 3 ? rnd2 === false ? v : round$1(v) : v;
      });
    };
    chroma$8.rgb = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      return new (Function.prototype.bind.apply(Color$q, [null].concat(args, ["rgb"])))();
    };
    input$3.format.rgb = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      var rgba = unpack$7(args, "rgba");
      if (rgba[3] === void 0) {
        rgba[3] = 1;
      }
      return rgba;
    };
    input$3.autodetect.push({
      p: 3,
      test: function() {
        var args = [], len = arguments.length;
        while (len--)
          args[len] = arguments[len];
        args = unpack$7(args, "rgba");
        if (type$9(args) === "array" && (args.length === 3 || args.length === 4 && type$9(args[3]) == "number" && args[3] >= 0 && args[3] <= 1)) {
          return "rgb";
        }
      }
    });
    var log$1 = Math.log;
    var temperature2rgb$1 = function(kelvin) {
      var temp = kelvin / 100;
      var r, g, b;
      if (temp < 66) {
        r = 255;
        g = temp < 6 ? 0 : -155.25485562709179 - 0.44596950469579133 * (g = temp - 2) + 104.49216199393888 * log$1(g);
        b = temp < 20 ? 0 : -254.76935184120902 + 0.8274096064007395 * (b = temp - 10) + 115.67994401066147 * log$1(b);
      } else {
        r = 351.97690566805693 + 0.114206453784165 * (r = temp - 55) - 40.25366309332127 * log$1(r);
        g = 325.4494125711974 + 0.07943456536662342 * (g = temp - 50) - 28.0852963507957 * log$1(g);
        b = 255;
      }
      return [r, g, b, 1];
    };
    var temperature2rgb_1 = temperature2rgb$1;
    var temperature2rgb = temperature2rgb_1;
    var unpack$6 = utils.unpack;
    var round = Math.round;
    var rgb2temperature$1 = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      var rgb2 = unpack$6(args, "rgb");
      var r = rgb2[0], b = rgb2[2];
      var minTemp = 1e3;
      var maxTemp = 4e4;
      var eps = 0.4;
      var temp;
      while (maxTemp - minTemp > eps) {
        temp = (maxTemp + minTemp) * 0.5;
        var rgb$1 = temperature2rgb(temp);
        if (rgb$1[2] / rgb$1[0] >= b / r) {
          maxTemp = temp;
        } else {
          minTemp = temp;
        }
      }
      return round(temp);
    };
    var rgb2temperature_1 = rgb2temperature$1;
    var chroma$7 = chroma_1;
    var Color$p = Color_1;
    var input$2 = input$h;
    var rgb2temperature = rgb2temperature_1;
    Color$p.prototype.temp = Color$p.prototype.kelvin = Color$p.prototype.temperature = function() {
      return rgb2temperature(this._rgb);
    };
    chroma$7.temp = chroma$7.kelvin = chroma$7.temperature = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      return new (Function.prototype.bind.apply(Color$p, [null].concat(args, ["temp"])))();
    };
    input$2.format.temp = input$2.format.kelvin = input$2.format.temperature = temperature2rgb_1;
    var unpack$5 = utils.unpack;
    var cbrt = Math.cbrt;
    var pow$8 = Math.pow;
    var sign$1 = Math.sign;
    var rgb2oklab$2 = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      var ref = unpack$5(args, "rgb");
      var r = ref[0];
      var g = ref[1];
      var b = ref[2];
      var ref$1 = [rgb2lrgb(r / 255), rgb2lrgb(g / 255), rgb2lrgb(b / 255)];
      var lr = ref$1[0];
      var lg = ref$1[1];
      var lb = ref$1[2];
      var l = cbrt(0.4122214708 * lr + 0.5363325363 * lg + 0.0514459929 * lb);
      var m = cbrt(0.2119034982 * lr + 0.6806995451 * lg + 0.1073969566 * lb);
      var s = cbrt(0.0883024619 * lr + 0.2817188376 * lg + 0.6299787005 * lb);
      return [
        0.2104542553 * l + 0.793617785 * m - 0.0040720468 * s,
        1.9779984951 * l - 2.428592205 * m + 0.4505937099 * s,
        0.0259040371 * l + 0.7827717662 * m - 0.808675766 * s
      ];
    };
    var rgb2oklab_1 = rgb2oklab$2;
    function rgb2lrgb(c) {
      var abs2 = Math.abs(c);
      if (abs2 < 0.04045) {
        return c / 12.92;
      }
      return (sign$1(c) || 1) * pow$8((abs2 + 0.055) / 1.055, 2.4);
    }
    var unpack$4 = utils.unpack;
    var pow$7 = Math.pow;
    var sign = Math.sign;
    var oklab2rgb$1 = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      args = unpack$4(args, "lab");
      var L = args[0];
      var a = args[1];
      var b = args[2];
      var l = pow$7(L + 0.3963377774 * a + 0.2158037573 * b, 3);
      var m = pow$7(L - 0.1055613458 * a - 0.0638541728 * b, 3);
      var s = pow$7(L - 0.0894841775 * a - 1.291485548 * b, 3);
      return [
        255 * lrgb2rgb(4.0767416621 * l - 3.3077115913 * m + 0.2309699292 * s),
        255 * lrgb2rgb(-1.2684380046 * l + 2.6097574011 * m - 0.3413193965 * s),
        255 * lrgb2rgb(-0.0041960863 * l - 0.7034186147 * m + 1.707614701 * s),
        args.length > 3 ? args[3] : 1
      ];
    };
    var oklab2rgb_1 = oklab2rgb$1;
    function lrgb2rgb(c) {
      var abs2 = Math.abs(c);
      if (abs2 > 31308e-7) {
        return (sign(c) || 1) * (1.055 * pow$7(abs2, 1 / 2.4) - 0.055);
      }
      return c * 12.92;
    }
    var unpack$3 = utils.unpack;
    var type$8 = utils.type;
    var chroma$6 = chroma_1;
    var Color$o = Color_1;
    var input$1 = input$h;
    var rgb2oklab$1 = rgb2oklab_1;
    Color$o.prototype.oklab = function() {
      return rgb2oklab$1(this._rgb);
    };
    chroma$6.oklab = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      return new (Function.prototype.bind.apply(Color$o, [null].concat(args, ["oklab"])))();
    };
    input$1.format.oklab = oklab2rgb_1;
    input$1.autodetect.push({
      p: 3,
      test: function() {
        var args = [], len = arguments.length;
        while (len--)
          args[len] = arguments[len];
        args = unpack$3(args, "oklab");
        if (type$8(args) === "array" && args.length === 3) {
          return "oklab";
        }
      }
    });
    var unpack$2 = utils.unpack;
    var rgb2oklab = rgb2oklab_1;
    var lab2lch = lab2lch_1;
    var rgb2oklch$1 = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      var ref = unpack$2(args, "rgb");
      var r = ref[0];
      var g = ref[1];
      var b = ref[2];
      var ref$1 = rgb2oklab(r, g, b);
      var l = ref$1[0];
      var a = ref$1[1];
      var b_ = ref$1[2];
      return lab2lch(l, a, b_);
    };
    var rgb2oklch_1 = rgb2oklch$1;
    var unpack$1 = utils.unpack;
    var lch2lab = lch2lab_1;
    var oklab2rgb = oklab2rgb_1;
    var oklch2rgb = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      args = unpack$1(args, "lch");
      var l = args[0];
      var c = args[1];
      var h = args[2];
      var ref = lch2lab(l, c, h);
      var L = ref[0];
      var a = ref[1];
      var b_ = ref[2];
      var ref$1 = oklab2rgb(L, a, b_);
      var r = ref$1[0];
      var g = ref$1[1];
      var b = ref$1[2];
      return [r, g, b, args.length > 3 ? args[3] : 1];
    };
    var oklch2rgb_1 = oklch2rgb;
    var unpack = utils.unpack;
    var type$7 = utils.type;
    var chroma$5 = chroma_1;
    var Color$n = Color_1;
    var input = input$h;
    var rgb2oklch = rgb2oklch_1;
    Color$n.prototype.oklch = function() {
      return rgb2oklch(this._rgb);
    };
    chroma$5.oklch = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      return new (Function.prototype.bind.apply(Color$n, [null].concat(args, ["oklch"])))();
    };
    input.format.oklch = oklch2rgb_1;
    input.autodetect.push({
      p: 3,
      test: function() {
        var args = [], len = arguments.length;
        while (len--)
          args[len] = arguments[len];
        args = unpack(args, "oklch");
        if (type$7(args) === "array" && args.length === 3) {
          return "oklch";
        }
      }
    });
    var Color$m = Color_1;
    var type$6 = utils.type;
    Color$m.prototype.alpha = function(a, mutate) {
      if (mutate === void 0)
        mutate = false;
      if (a !== void 0 && type$6(a) === "number") {
        if (mutate) {
          this._rgb[3] = a;
          return this;
        }
        return new Color$m([this._rgb[0], this._rgb[1], this._rgb[2], a], "rgb");
      }
      return this._rgb[3];
    };
    var Color$l = Color_1;
    Color$l.prototype.clipped = function() {
      return this._rgb._clipped || false;
    };
    var Color$k = Color_1;
    var LAB_CONSTANTS$1 = labConstants;
    Color$k.prototype.darken = function(amount) {
      if (amount === void 0)
        amount = 1;
      var me = this;
      var lab2 = me.lab();
      lab2[0] -= LAB_CONSTANTS$1.Kn * amount;
      return new Color$k(lab2, "lab").alpha(me.alpha(), true);
    };
    Color$k.prototype.brighten = function(amount) {
      if (amount === void 0)
        amount = 1;
      return this.darken(-amount);
    };
    Color$k.prototype.darker = Color$k.prototype.darken;
    Color$k.prototype.brighter = Color$k.prototype.brighten;
    var Color$j = Color_1;
    Color$j.prototype.get = function(mc) {
      var ref = mc.split(".");
      var mode = ref[0];
      var channel = ref[1];
      var src = this[mode]();
      if (channel) {
        var i2 = mode.indexOf(channel) - (mode.substr(0, 2) === "ok" ? 2 : 0);
        if (i2 > -1) {
          return src[i2];
        }
        throw new Error("unknown channel " + channel + " in mode " + mode);
      } else {
        return src;
      }
    };
    var Color$i = Color_1;
    var type$5 = utils.type;
    var pow$6 = Math.pow;
    var EPS = 1e-7;
    var MAX_ITER = 20;
    Color$i.prototype.luminance = function(lum) {
      if (lum !== void 0 && type$5(lum) === "number") {
        if (lum === 0) {
          return new Color$i([0, 0, 0, this._rgb[3]], "rgb");
        }
        if (lum === 1) {
          return new Color$i([255, 255, 255, this._rgb[3]], "rgb");
        }
        var cur_lum = this.luminance();
        var mode = "rgb";
        var max_iter = MAX_ITER;
        var test = function(low, high) {
          var mid = low.interpolate(high, 0.5, mode);
          var lm = mid.luminance();
          if (Math.abs(lum - lm) < EPS || !max_iter--) {
            return mid;
          }
          return lm > lum ? test(low, mid) : test(mid, high);
        };
        var rgb2 = (cur_lum > lum ? test(new Color$i([0, 0, 0]), this) : test(this, new Color$i([255, 255, 255]))).rgb();
        return new Color$i(rgb2.concat([this._rgb[3]]));
      }
      return rgb2luminance.apply(void 0, this._rgb.slice(0, 3));
    };
    var rgb2luminance = function(r, g, b) {
      r = luminance_x(r);
      g = luminance_x(g);
      b = luminance_x(b);
      return 0.2126 * r + 0.7152 * g + 0.0722 * b;
    };
    var luminance_x = function(x) {
      x /= 255;
      return x <= 0.03928 ? x / 12.92 : pow$6((x + 0.055) / 1.055, 2.4);
    };
    var interpolator$1 = {};
    var Color$h = Color_1;
    var type$4 = utils.type;
    var interpolator = interpolator$1;
    var mix$1 = function(col1, col2, f) {
      if (f === void 0)
        f = 0.5;
      var rest = [], len = arguments.length - 3;
      while (len-- > 0)
        rest[len] = arguments[len + 3];
      var mode = rest[0] || "lrgb";
      if (!interpolator[mode] && !rest.length) {
        mode = Object.keys(interpolator)[0];
      }
      if (!interpolator[mode]) {
        throw new Error("interpolation mode " + mode + " is not defined");
      }
      if (type$4(col1) !== "object") {
        col1 = new Color$h(col1);
      }
      if (type$4(col2) !== "object") {
        col2 = new Color$h(col2);
      }
      return interpolator[mode](col1, col2, f).alpha(col1.alpha() + f * (col2.alpha() - col1.alpha()));
    };
    var Color$g = Color_1;
    var mix = mix$1;
    Color$g.prototype.mix = Color$g.prototype.interpolate = function(col2, f) {
      if (f === void 0)
        f = 0.5;
      var rest = [], len = arguments.length - 2;
      while (len-- > 0)
        rest[len] = arguments[len + 2];
      return mix.apply(void 0, [this, col2, f].concat(rest));
    };
    var Color$f = Color_1;
    Color$f.prototype.premultiply = function(mutate) {
      if (mutate === void 0)
        mutate = false;
      var rgb2 = this._rgb;
      var a = rgb2[3];
      if (mutate) {
        this._rgb = [rgb2[0] * a, rgb2[1] * a, rgb2[2] * a, a];
        return this;
      } else {
        return new Color$f([rgb2[0] * a, rgb2[1] * a, rgb2[2] * a, a], "rgb");
      }
    };
    var Color$e = Color_1;
    var LAB_CONSTANTS = labConstants;
    Color$e.prototype.saturate = function(amount) {
      if (amount === void 0)
        amount = 1;
      var me = this;
      var lch2 = me.lch();
      lch2[1] += LAB_CONSTANTS.Kn * amount;
      if (lch2[1] < 0) {
        lch2[1] = 0;
      }
      return new Color$e(lch2, "lch").alpha(me.alpha(), true);
    };
    Color$e.prototype.desaturate = function(amount) {
      if (amount === void 0)
        amount = 1;
      return this.saturate(-amount);
    };
    var Color$d = Color_1;
    var type$3 = utils.type;
    Color$d.prototype.set = function(mc, value, mutate) {
      if (mutate === void 0)
        mutate = false;
      var ref = mc.split(".");
      var mode = ref[0];
      var channel = ref[1];
      var src = this[mode]();
      if (channel) {
        var i2 = mode.indexOf(channel) - (mode.substr(0, 2) === "ok" ? 2 : 0);
        if (i2 > -1) {
          if (type$3(value) == "string") {
            switch (value.charAt(0)) {
              case "+":
                src[i2] += +value;
                break;
              case "-":
                src[i2] += +value;
                break;
              case "*":
                src[i2] *= +value.substr(1);
                break;
              case "/":
                src[i2] /= +value.substr(1);
                break;
              default:
                src[i2] = +value;
            }
          } else if (type$3(value) === "number") {
            src[i2] = value;
          } else {
            throw new Error("unsupported value for Color.set");
          }
          var out = new Color$d(src, mode);
          if (mutate) {
            this._rgb = out._rgb;
            return this;
          }
          return out;
        }
        throw new Error("unknown channel " + channel + " in mode " + mode);
      } else {
        return src;
      }
    };
    var Color$c = Color_1;
    var rgb = function(col1, col2, f) {
      var xyz0 = col1._rgb;
      var xyz1 = col2._rgb;
      return new Color$c(xyz0[0] + f * (xyz1[0] - xyz0[0]), xyz0[1] + f * (xyz1[1] - xyz0[1]), xyz0[2] + f * (xyz1[2] - xyz0[2]), "rgb");
    };
    interpolator$1.rgb = rgb;
    var Color$b = Color_1;
    var sqrt$2 = Math.sqrt;
    var pow$5 = Math.pow;
    var lrgb = function(col1, col2, f) {
      var ref = col1._rgb;
      var x1 = ref[0];
      var y1 = ref[1];
      var z1 = ref[2];
      var ref$1 = col2._rgb;
      var x2 = ref$1[0];
      var y2 = ref$1[1];
      var z2 = ref$1[2];
      return new Color$b(sqrt$2(pow$5(x1, 2) * (1 - f) + pow$5(x2, 2) * f), sqrt$2(pow$5(y1, 2) * (1 - f) + pow$5(y2, 2) * f), sqrt$2(pow$5(z1, 2) * (1 - f) + pow$5(z2, 2) * f), "rgb");
    };
    interpolator$1.lrgb = lrgb;
    var Color$a = Color_1;
    var lab = function(col1, col2, f) {
      var xyz0 = col1.lab();
      var xyz1 = col2.lab();
      return new Color$a(xyz0[0] + f * (xyz1[0] - xyz0[0]), xyz0[1] + f * (xyz1[1] - xyz0[1]), xyz0[2] + f * (xyz1[2] - xyz0[2]), "lab");
    };
    interpolator$1.lab = lab;
    var Color$9 = Color_1;
    var _hsx = function(col1, col2, f, m) {
      var assign, assign$1;
      var xyz0, xyz1;
      if (m === "hsl") {
        xyz0 = col1.hsl();
        xyz1 = col2.hsl();
      } else if (m === "hsv") {
        xyz0 = col1.hsv();
        xyz1 = col2.hsv();
      } else if (m === "hcg") {
        xyz0 = col1.hcg();
        xyz1 = col2.hcg();
      } else if (m === "hsi") {
        xyz0 = col1.hsi();
        xyz1 = col2.hsi();
      } else if (m === "lch" || m === "hcl") {
        m = "hcl";
        xyz0 = col1.hcl();
        xyz1 = col2.hcl();
      } else if (m === "oklch") {
        xyz0 = col1.oklch().reverse();
        xyz1 = col2.oklch().reverse();
      }
      var hue0, hue1, sat0, sat1, lbv0, lbv1;
      if (m.substr(0, 1) === "h" || m === "oklch") {
        assign = xyz0, hue0 = assign[0], sat0 = assign[1], lbv0 = assign[2];
        assign$1 = xyz1, hue1 = assign$1[0], sat1 = assign$1[1], lbv1 = assign$1[2];
      }
      var sat, hue, lbv, dh;
      if (!isNaN(hue0) && !isNaN(hue1)) {
        if (hue1 > hue0 && hue1 - hue0 > 180) {
          dh = hue1 - (hue0 + 360);
        } else if (hue1 < hue0 && hue0 - hue1 > 180) {
          dh = hue1 + 360 - hue0;
        } else {
          dh = hue1 - hue0;
        }
        hue = hue0 + f * dh;
      } else if (!isNaN(hue0)) {
        hue = hue0;
        if ((lbv1 == 1 || lbv1 == 0) && m != "hsv") {
          sat = sat0;
        }
      } else if (!isNaN(hue1)) {
        hue = hue1;
        if ((lbv0 == 1 || lbv0 == 0) && m != "hsv") {
          sat = sat1;
        }
      } else {
        hue = Number.NaN;
      }
      if (sat === void 0) {
        sat = sat0 + f * (sat1 - sat0);
      }
      lbv = lbv0 + f * (lbv1 - lbv0);
      return m === "oklch" ? new Color$9([lbv, sat, hue], m) : new Color$9([hue, sat, lbv], m);
    };
    var interpolate_hsx$5 = _hsx;
    var lch = function(col1, col2, f) {
      return interpolate_hsx$5(col1, col2, f, "lch");
    };
    interpolator$1.lch = lch;
    interpolator$1.hcl = lch;
    var Color$8 = Color_1;
    var num = function(col1, col2, f) {
      var c1 = col1.num();
      var c2 = col2.num();
      return new Color$8(c1 + f * (c2 - c1), "num");
    };
    interpolator$1.num = num;
    var interpolate_hsx$4 = _hsx;
    var hcg = function(col1, col2, f) {
      return interpolate_hsx$4(col1, col2, f, "hcg");
    };
    interpolator$1.hcg = hcg;
    var interpolate_hsx$3 = _hsx;
    var hsi = function(col1, col2, f) {
      return interpolate_hsx$3(col1, col2, f, "hsi");
    };
    interpolator$1.hsi = hsi;
    var interpolate_hsx$2 = _hsx;
    var hsl = function(col1, col2, f) {
      return interpolate_hsx$2(col1, col2, f, "hsl");
    };
    interpolator$1.hsl = hsl;
    var interpolate_hsx$1 = _hsx;
    var hsv = function(col1, col2, f) {
      return interpolate_hsx$1(col1, col2, f, "hsv");
    };
    interpolator$1.hsv = hsv;
    var Color$7 = Color_1;
    var oklab = function(col1, col2, f) {
      var xyz0 = col1.oklab();
      var xyz1 = col2.oklab();
      return new Color$7(xyz0[0] + f * (xyz1[0] - xyz0[0]), xyz0[1] + f * (xyz1[1] - xyz0[1]), xyz0[2] + f * (xyz1[2] - xyz0[2]), "oklab");
    };
    interpolator$1.oklab = oklab;
    var interpolate_hsx = _hsx;
    var oklch = function(col1, col2, f) {
      return interpolate_hsx(col1, col2, f, "oklch");
    };
    interpolator$1.oklch = oklch;
    var Color$6 = Color_1;
    var clip_rgb$1 = utils.clip_rgb;
    var pow$4 = Math.pow;
    var sqrt$1 = Math.sqrt;
    var PI$1 = Math.PI;
    var cos$2 = Math.cos;
    var sin$2 = Math.sin;
    var atan2$1 = Math.atan2;
    var average = function(colors, mode, weights) {
      if (mode === void 0)
        mode = "lrgb";
      if (weights === void 0)
        weights = null;
      var l = colors.length;
      if (!weights) {
        weights = Array.from(new Array(l)).map(function() {
          return 1;
        });
      }
      var k = l / weights.reduce(function(a, b) {
        return a + b;
      });
      weights.forEach(function(w, i3) {
        weights[i3] *= k;
      });
      colors = colors.map(function(c) {
        return new Color$6(c);
      });
      if (mode === "lrgb") {
        return _average_lrgb(colors, weights);
      }
      var first = colors.shift();
      var xyz = first.get(mode);
      var cnt = [];
      var dx = 0;
      var dy = 0;
      for (var i2 = 0; i2 < xyz.length; i2++) {
        xyz[i2] = (xyz[i2] || 0) * weights[0];
        cnt.push(isNaN(xyz[i2]) ? 0 : weights[0]);
        if (mode.charAt(i2) === "h" && !isNaN(xyz[i2])) {
          var A = xyz[i2] / 180 * PI$1;
          dx += cos$2(A) * weights[0];
          dy += sin$2(A) * weights[0];
        }
      }
      var alpha = first.alpha() * weights[0];
      colors.forEach(function(c, ci) {
        var xyz2 = c.get(mode);
        alpha += c.alpha() * weights[ci + 1];
        for (var i3 = 0; i3 < xyz.length; i3++) {
          if (!isNaN(xyz2[i3])) {
            cnt[i3] += weights[ci + 1];
            if (mode.charAt(i3) === "h") {
              var A2 = xyz2[i3] / 180 * PI$1;
              dx += cos$2(A2) * weights[ci + 1];
              dy += sin$2(A2) * weights[ci + 1];
            } else {
              xyz[i3] += xyz2[i3] * weights[ci + 1];
            }
          }
        }
      });
      for (var i$12 = 0; i$12 < xyz.length; i$12++) {
        if (mode.charAt(i$12) === "h") {
          var A$1 = atan2$1(dy / cnt[i$12], dx / cnt[i$12]) / PI$1 * 180;
          while (A$1 < 0) {
            A$1 += 360;
          }
          while (A$1 >= 360) {
            A$1 -= 360;
          }
          xyz[i$12] = A$1;
        } else {
          xyz[i$12] = xyz[i$12] / cnt[i$12];
        }
      }
      alpha /= l;
      return new Color$6(xyz, mode).alpha(alpha > 0.99999 ? 1 : alpha, true);
    };
    var _average_lrgb = function(colors, weights) {
      var l = colors.length;
      var xyz = [0, 0, 0, 0];
      for (var i2 = 0; i2 < colors.length; i2++) {
        var col = colors[i2];
        var f = weights[i2] / l;
        var rgb2 = col._rgb;
        xyz[0] += pow$4(rgb2[0], 2) * f;
        xyz[1] += pow$4(rgb2[1], 2) * f;
        xyz[2] += pow$4(rgb2[2], 2) * f;
        xyz[3] += rgb2[3] * f;
      }
      xyz[0] = sqrt$1(xyz[0]);
      xyz[1] = sqrt$1(xyz[1]);
      xyz[2] = sqrt$1(xyz[2]);
      if (xyz[3] > 0.9999999) {
        xyz[3] = 1;
      }
      return new Color$6(clip_rgb$1(xyz));
    };
    var chroma$4 = chroma_1;
    var type$2 = utils.type;
    var pow$3 = Math.pow;
    var scale$2 = function(colors) {
      var _mode = "rgb";
      var _nacol = chroma$4("#ccc");
      var _spread = 0;
      var _domain = [0, 1];
      var _pos = [];
      var _padding = [0, 0];
      var _classes = false;
      var _colors = [];
      var _out = false;
      var _min = 0;
      var _max = 1;
      var _correctLightness = false;
      var _colorCache = {};
      var _useCache = true;
      var _gamma = 1;
      var setColors = function(colors2) {
        colors2 = colors2 || ["#fff", "#000"];
        if (colors2 && type$2(colors2) === "string" && chroma$4.brewer && chroma$4.brewer[colors2.toLowerCase()]) {
          colors2 = chroma$4.brewer[colors2.toLowerCase()];
        }
        if (type$2(colors2) === "array") {
          if (colors2.length === 1) {
            colors2 = [colors2[0], colors2[0]];
          }
          colors2 = colors2.slice(0);
          for (var c = 0; c < colors2.length; c++) {
            colors2[c] = chroma$4(colors2[c]);
          }
          _pos.length = 0;
          for (var c$1 = 0; c$1 < colors2.length; c$1++) {
            _pos.push(c$1 / (colors2.length - 1));
          }
        }
        resetCache();
        return _colors = colors2;
      };
      var getClass = function(value) {
        if (_classes != null) {
          var n = _classes.length - 1;
          var i2 = 0;
          while (i2 < n && value >= _classes[i2]) {
            i2++;
          }
          return i2 - 1;
        }
        return 0;
      };
      var tMapLightness = function(t) {
        return t;
      };
      var tMapDomain = function(t) {
        return t;
      };
      var getColor = function(val, bypassMap) {
        var col, t;
        if (bypassMap == null) {
          bypassMap = false;
        }
        if (isNaN(val) || val === null) {
          return _nacol;
        }
        if (!bypassMap) {
          if (_classes && _classes.length > 2) {
            var c = getClass(val);
            t = c / (_classes.length - 2);
          } else if (_max !== _min) {
            t = (val - _min) / (_max - _min);
          } else {
            t = 1;
          }
        } else {
          t = val;
        }
        t = tMapDomain(t);
        if (!bypassMap) {
          t = tMapLightness(t);
        }
        if (_gamma !== 1) {
          t = pow$3(t, _gamma);
        }
        t = _padding[0] + t * (1 - _padding[0] - _padding[1]);
        t = Math.min(1, Math.max(0, t));
        var k = Math.floor(t * 1e4);
        if (_useCache && _colorCache[k]) {
          col = _colorCache[k];
        } else {
          if (type$2(_colors) === "array") {
            for (var i2 = 0; i2 < _pos.length; i2++) {
              var p = _pos[i2];
              if (t <= p) {
                col = _colors[i2];
                break;
              }
              if (t >= p && i2 === _pos.length - 1) {
                col = _colors[i2];
                break;
              }
              if (t > p && t < _pos[i2 + 1]) {
                t = (t - p) / (_pos[i2 + 1] - p);
                col = chroma$4.interpolate(_colors[i2], _colors[i2 + 1], t, _mode);
                break;
              }
            }
          } else if (type$2(_colors) === "function") {
            col = _colors(t);
          }
          if (_useCache) {
            _colorCache[k] = col;
          }
        }
        return col;
      };
      var resetCache = function() {
        return _colorCache = {};
      };
      setColors(colors);
      var f = function(v) {
        var c = chroma$4(getColor(v));
        if (_out && c[_out]) {
          return c[_out]();
        } else {
          return c;
        }
      };
      f.classes = function(classes) {
        if (classes != null) {
          if (type$2(classes) === "array") {
            _classes = classes;
            _domain = [classes[0], classes[classes.length - 1]];
          } else {
            var d = chroma$4.analyze(_domain);
            if (classes === 0) {
              _classes = [d.min, d.max];
            } else {
              _classes = chroma$4.limits(d, "e", classes);
            }
          }
          return f;
        }
        return _classes;
      };
      f.domain = function(domain) {
        if (!arguments.length) {
          return _domain;
        }
        _min = domain[0];
        _max = domain[domain.length - 1];
        _pos = [];
        var k = _colors.length;
        if (domain.length === k && _min !== _max) {
          for (var i2 = 0, list2 = Array.from(domain); i2 < list2.length; i2 += 1) {
            var d = list2[i2];
            _pos.push((d - _min) / (_max - _min));
          }
        } else {
          for (var c = 0; c < k; c++) {
            _pos.push(c / (k - 1));
          }
          if (domain.length > 2) {
            var tOut = domain.map(function(d2, i3) {
              return i3 / (domain.length - 1);
            });
            var tBreaks = domain.map(function(d2) {
              return (d2 - _min) / (_max - _min);
            });
            if (!tBreaks.every(function(val, i3) {
              return tOut[i3] === val;
            })) {
              tMapDomain = function(t) {
                if (t <= 0 || t >= 1) {
                  return t;
                }
                var i3 = 0;
                while (t >= tBreaks[i3 + 1]) {
                  i3++;
                }
                var f2 = (t - tBreaks[i3]) / (tBreaks[i3 + 1] - tBreaks[i3]);
                var out = tOut[i3] + f2 * (tOut[i3 + 1] - tOut[i3]);
                return out;
              };
            }
          }
        }
        _domain = [_min, _max];
        return f;
      };
      f.mode = function(_m) {
        if (!arguments.length) {
          return _mode;
        }
        _mode = _m;
        resetCache();
        return f;
      };
      f.range = function(colors2, _pos2) {
        setColors(colors2);
        return f;
      };
      f.out = function(_o) {
        _out = _o;
        return f;
      };
      f.spread = function(val) {
        if (!arguments.length) {
          return _spread;
        }
        _spread = val;
        return f;
      };
      f.correctLightness = function(v) {
        if (v == null) {
          v = true;
        }
        _correctLightness = v;
        resetCache();
        if (_correctLightness) {
          tMapLightness = function(t) {
            var L0 = getColor(0, true).lab()[0];
            var L1 = getColor(1, true).lab()[0];
            var pol = L0 > L1;
            var L_actual = getColor(t, true).lab()[0];
            var L_ideal = L0 + (L1 - L0) * t;
            var L_diff = L_actual - L_ideal;
            var t0 = 0;
            var t1 = 1;
            var max_iter = 20;
            while (Math.abs(L_diff) > 0.01 && max_iter-- > 0) {
              (function() {
                if (pol) {
                  L_diff *= -1;
                }
                if (L_diff < 0) {
                  t0 = t;
                  t += (t1 - t) * 0.5;
                } else {
                  t1 = t;
                  t += (t0 - t) * 0.5;
                }
                L_actual = getColor(t, true).lab()[0];
                return L_diff = L_actual - L_ideal;
              })();
            }
            return t;
          };
        } else {
          tMapLightness = function(t) {
            return t;
          };
        }
        return f;
      };
      f.padding = function(p) {
        if (p != null) {
          if (type$2(p) === "number") {
            p = [p, p];
          }
          _padding = p;
          return f;
        } else {
          return _padding;
        }
      };
      f.colors = function(numColors, out) {
        if (arguments.length < 2) {
          out = "hex";
        }
        var result = [];
        if (arguments.length === 0) {
          result = _colors.slice(0);
        } else if (numColors === 1) {
          result = [f(0.5)];
        } else if (numColors > 1) {
          var dm = _domain[0];
          var dd = _domain[1] - dm;
          result = __range__(0, numColors, false).map(function(i3) {
            return f(dm + i3 / (numColors - 1) * dd);
          });
        } else {
          colors = [];
          var samples = [];
          if (_classes && _classes.length > 2) {
            for (var i2 = 1, end = _classes.length, asc = 1 <= end; asc ? i2 < end : i2 > end; asc ? i2++ : i2--) {
              samples.push((_classes[i2 - 1] + _classes[i2]) * 0.5);
            }
          } else {
            samples = _domain;
          }
          result = samples.map(function(v) {
            return f(v);
          });
        }
        if (chroma$4[out]) {
          result = result.map(function(c) {
            return c[out]();
          });
        }
        return result;
      };
      f.cache = function(c) {
        if (c != null) {
          _useCache = c;
          return f;
        } else {
          return _useCache;
        }
      };
      f.gamma = function(g) {
        if (g != null) {
          _gamma = g;
          return f;
        } else {
          return _gamma;
        }
      };
      f.nodata = function(d) {
        if (d != null) {
          _nacol = chroma$4(d);
          return f;
        } else {
          return _nacol;
        }
      };
      return f;
    };
    function __range__(left, right, inclusive) {
      var range = [];
      var ascending = left < right;
      var end = !inclusive ? right : ascending ? right + 1 : right - 1;
      for (var i2 = left; ascending ? i2 < end : i2 > end; ascending ? i2++ : i2--) {
        range.push(i2);
      }
      return range;
    }
    var Color$5 = Color_1;
    var scale$1 = scale$2;
    var binom_row = function(n) {
      var row = [1, 1];
      for (var i2 = 1; i2 < n; i2++) {
        var newrow = [1];
        for (var j = 1; j <= row.length; j++) {
          newrow[j] = (row[j] || 0) + row[j - 1];
        }
        row = newrow;
      }
      return row;
    };
    var bezier = function(colors) {
      var assign, assign$1, assign$2;
      var I, lab0, lab1, lab2;
      colors = colors.map(function(c) {
        return new Color$5(c);
      });
      if (colors.length === 2) {
        assign = colors.map(function(c) {
          return c.lab();
        }), lab0 = assign[0], lab1 = assign[1];
        I = function(t) {
          var lab4 = [0, 1, 2].map(function(i2) {
            return lab0[i2] + t * (lab1[i2] - lab0[i2]);
          });
          return new Color$5(lab4, "lab");
        };
      } else if (colors.length === 3) {
        assign$1 = colors.map(function(c) {
          return c.lab();
        }), lab0 = assign$1[0], lab1 = assign$1[1], lab2 = assign$1[2];
        I = function(t) {
          var lab4 = [0, 1, 2].map(function(i2) {
            return (1 - t) * (1 - t) * lab0[i2] + 2 * (1 - t) * t * lab1[i2] + t * t * lab2[i2];
          });
          return new Color$5(lab4, "lab");
        };
      } else if (colors.length === 4) {
        var lab3;
        assign$2 = colors.map(function(c) {
          return c.lab();
        }), lab0 = assign$2[0], lab1 = assign$2[1], lab2 = assign$2[2], lab3 = assign$2[3];
        I = function(t) {
          var lab4 = [0, 1, 2].map(function(i2) {
            return (1 - t) * (1 - t) * (1 - t) * lab0[i2] + 3 * (1 - t) * (1 - t) * t * lab1[i2] + 3 * (1 - t) * t * t * lab2[i2] + t * t * t * lab3[i2];
          });
          return new Color$5(lab4, "lab");
        };
      } else if (colors.length >= 5) {
        var labs, row, n;
        labs = colors.map(function(c) {
          return c.lab();
        });
        n = colors.length - 1;
        row = binom_row(n);
        I = function(t) {
          var u = 1 - t;
          var lab4 = [0, 1, 2].map(function(i2) {
            return labs.reduce(function(sum, el, j) {
              return sum + row[j] * Math.pow(u, n - j) * Math.pow(t, j) * el[i2];
            }, 0);
          });
          return new Color$5(lab4, "lab");
        };
      } else {
        throw new RangeError("No point in running bezier with only one color.");
      }
      return I;
    };
    var bezier_1 = function(colors) {
      var f = bezier(colors);
      f.scale = function() {
        return scale$1(f);
      };
      return f;
    };
    var chroma$3 = chroma_1;
    var blend = function(bottom, top, mode) {
      if (!blend[mode]) {
        throw new Error("unknown blend mode " + mode);
      }
      return blend[mode](bottom, top);
    };
    var blend_f = function(f) {
      return function(bottom, top) {
        var c0 = chroma$3(top).rgb();
        var c1 = chroma$3(bottom).rgb();
        return chroma$3.rgb(f(c0, c1));
      };
    };
    var each = function(f) {
      return function(c0, c1) {
        var out = [];
        out[0] = f(c0[0], c1[0]);
        out[1] = f(c0[1], c1[1]);
        out[2] = f(c0[2], c1[2]);
        return out;
      };
    };
    var normal = function(a) {
      return a;
    };
    var multiply = function(a, b) {
      return a * b / 255;
    };
    var darken = function(a, b) {
      return a > b ? b : a;
    };
    var lighten = function(a, b) {
      return a > b ? a : b;
    };
    var screen = function(a, b) {
      return 255 * (1 - (1 - a / 255) * (1 - b / 255));
    };
    var overlay = function(a, b) {
      return b < 128 ? 2 * a * b / 255 : 255 * (1 - 2 * (1 - a / 255) * (1 - b / 255));
    };
    var burn = function(a, b) {
      return 255 * (1 - (1 - b / 255) / (a / 255));
    };
    var dodge = function(a, b) {
      if (a === 255) {
        return 255;
      }
      a = 255 * (b / 255) / (1 - a / 255);
      return a > 255 ? 255 : a;
    };
    blend.normal = blend_f(each(normal));
    blend.multiply = blend_f(each(multiply));
    blend.screen = blend_f(each(screen));
    blend.overlay = blend_f(each(overlay));
    blend.darken = blend_f(each(darken));
    blend.lighten = blend_f(each(lighten));
    blend.dodge = blend_f(each(dodge));
    blend.burn = blend_f(each(burn));
    var blend_1 = blend;
    var type$1 = utils.type;
    var clip_rgb = utils.clip_rgb;
    var TWOPI = utils.TWOPI;
    var pow$2 = Math.pow;
    var sin$1 = Math.sin;
    var cos$1 = Math.cos;
    var chroma$2 = chroma_1;
    var cubehelix = function(start, rotations, hue, gamma, lightness) {
      if (start === void 0)
        start = 300;
      if (rotations === void 0)
        rotations = -1.5;
      if (hue === void 0)
        hue = 1;
      if (gamma === void 0)
        gamma = 1;
      if (lightness === void 0)
        lightness = [0, 1];
      var dh = 0, dl;
      if (type$1(lightness) === "array") {
        dl = lightness[1] - lightness[0];
      } else {
        dl = 0;
        lightness = [lightness, lightness];
      }
      var f = function(fract) {
        var a = TWOPI * ((start + 120) / 360 + rotations * fract);
        var l = pow$2(lightness[0] + dl * fract, gamma);
        var h = dh !== 0 ? hue[0] + fract * dh : hue;
        var amp = h * l * (1 - l) / 2;
        var cos_a = cos$1(a);
        var sin_a = sin$1(a);
        var r = l + amp * (-0.14861 * cos_a + 1.78277 * sin_a);
        var g = l + amp * (-0.29227 * cos_a - 0.90649 * sin_a);
        var b = l + amp * (1.97294 * cos_a);
        return chroma$2(clip_rgb([r * 255, g * 255, b * 255, 1]));
      };
      f.start = function(s) {
        if (s == null) {
          return start;
        }
        start = s;
        return f;
      };
      f.rotations = function(r) {
        if (r == null) {
          return rotations;
        }
        rotations = r;
        return f;
      };
      f.gamma = function(g) {
        if (g == null) {
          return gamma;
        }
        gamma = g;
        return f;
      };
      f.hue = function(h) {
        if (h == null) {
          return hue;
        }
        hue = h;
        if (type$1(hue) === "array") {
          dh = hue[1] - hue[0];
          if (dh === 0) {
            hue = hue[1];
          }
        } else {
          dh = 0;
        }
        return f;
      };
      f.lightness = function(h) {
        if (h == null) {
          return lightness;
        }
        if (type$1(h) === "array") {
          lightness = h;
          dl = h[1] - h[0];
        } else {
          lightness = [h, h];
          dl = 0;
        }
        return f;
      };
      f.scale = function() {
        return chroma$2.scale(f);
      };
      f.hue(hue);
      return f;
    };
    var Color$4 = Color_1;
    var digits = "0123456789abcdef";
    var floor$1 = Math.floor;
    var random = Math.random;
    var random_1 = function() {
      var code = "#";
      for (var i2 = 0; i2 < 6; i2++) {
        code += digits.charAt(floor$1(random() * 16));
      }
      return new Color$4(code, "hex");
    };
    var type = type$p;
    var log = Math.log;
    var pow$1 = Math.pow;
    var floor = Math.floor;
    var abs$1 = Math.abs;
    var analyze = function(data, key2) {
      if (key2 === void 0)
        key2 = null;
      var r = {
        min: Number.MAX_VALUE,
        max: Number.MAX_VALUE * -1,
        sum: 0,
        values: [],
        count: 0
      };
      if (type(data) === "object") {
        data = Object.values(data);
      }
      data.forEach(function(val) {
        if (key2 && type(val) === "object") {
          val = val[key2];
        }
        if (val !== void 0 && val !== null && !isNaN(val)) {
          r.values.push(val);
          r.sum += val;
          if (val < r.min) {
            r.min = val;
          }
          if (val > r.max) {
            r.max = val;
          }
          r.count += 1;
        }
      });
      r.domain = [r.min, r.max];
      r.limits = function(mode, num2) {
        return limits(r, mode, num2);
      };
      return r;
    };
    var limits = function(data, mode, num2) {
      if (mode === void 0)
        mode = "equal";
      if (num2 === void 0)
        num2 = 7;
      if (type(data) == "array") {
        data = analyze(data);
      }
      var min2 = data.min;
      var max2 = data.max;
      var values = data.values.sort(function(a, b) {
        return a - b;
      });
      if (num2 === 1) {
        return [min2, max2];
      }
      var limits2 = [];
      if (mode.substr(0, 1) === "c") {
        limits2.push(min2);
        limits2.push(max2);
      }
      if (mode.substr(0, 1) === "e") {
        limits2.push(min2);
        for (var i2 = 1; i2 < num2; i2++) {
          limits2.push(min2 + i2 / num2 * (max2 - min2));
        }
        limits2.push(max2);
      } else if (mode.substr(0, 1) === "l") {
        if (min2 <= 0) {
          throw new Error("Logarithmic scales are only possible for values > 0");
        }
        var min_log = Math.LOG10E * log(min2);
        var max_log = Math.LOG10E * log(max2);
        limits2.push(min2);
        for (var i$12 = 1; i$12 < num2; i$12++) {
          limits2.push(pow$1(10, min_log + i$12 / num2 * (max_log - min_log)));
        }
        limits2.push(max2);
      } else if (mode.substr(0, 1) === "q") {
        limits2.push(min2);
        for (var i$2 = 1; i$2 < num2; i$2++) {
          var p = (values.length - 1) * i$2 / num2;
          var pb = floor(p);
          if (pb === p) {
            limits2.push(values[pb]);
          } else {
            var pr = p - pb;
            limits2.push(values[pb] * (1 - pr) + values[pb + 1] * pr);
          }
        }
        limits2.push(max2);
      } else if (mode.substr(0, 1) === "k") {
        var cluster;
        var n = values.length;
        var assignments = new Array(n);
        var clusterSizes = new Array(num2);
        var repeat = true;
        var nb_iters = 0;
        var centroids = null;
        centroids = [];
        centroids.push(min2);
        for (var i$3 = 1; i$3 < num2; i$3++) {
          centroids.push(min2 + i$3 / num2 * (max2 - min2));
        }
        centroids.push(max2);
        while (repeat) {
          for (var j = 0; j < num2; j++) {
            clusterSizes[j] = 0;
          }
          for (var i$4 = 0; i$4 < n; i$4++) {
            var value = values[i$4];
            var mindist = Number.MAX_VALUE;
            var best = void 0;
            for (var j$1 = 0; j$1 < num2; j$1++) {
              var dist = abs$1(centroids[j$1] - value);
              if (dist < mindist) {
                mindist = dist;
                best = j$1;
              }
              clusterSizes[best]++;
              assignments[i$4] = best;
            }
          }
          var newCentroids = new Array(num2);
          for (var j$2 = 0; j$2 < num2; j$2++) {
            newCentroids[j$2] = null;
          }
          for (var i$5 = 0; i$5 < n; i$5++) {
            cluster = assignments[i$5];
            if (newCentroids[cluster] === null) {
              newCentroids[cluster] = values[i$5];
            } else {
              newCentroids[cluster] += values[i$5];
            }
          }
          for (var j$3 = 0; j$3 < num2; j$3++) {
            newCentroids[j$3] *= 1 / clusterSizes[j$3];
          }
          repeat = false;
          for (var j$4 = 0; j$4 < num2; j$4++) {
            if (newCentroids[j$4] !== centroids[j$4]) {
              repeat = true;
              break;
            }
          }
          centroids = newCentroids;
          nb_iters++;
          if (nb_iters > 200) {
            repeat = false;
          }
        }
        var kClusters = {};
        for (var j$5 = 0; j$5 < num2; j$5++) {
          kClusters[j$5] = [];
        }
        for (var i$6 = 0; i$6 < n; i$6++) {
          cluster = assignments[i$6];
          kClusters[cluster].push(values[i$6]);
        }
        var tmpKMeansBreaks = [];
        for (var j$6 = 0; j$6 < num2; j$6++) {
          tmpKMeansBreaks.push(kClusters[j$6][0]);
          tmpKMeansBreaks.push(kClusters[j$6][kClusters[j$6].length - 1]);
        }
        tmpKMeansBreaks = tmpKMeansBreaks.sort(function(a, b) {
          return a - b;
        });
        limits2.push(tmpKMeansBreaks[0]);
        for (var i$7 = 1; i$7 < tmpKMeansBreaks.length; i$7 += 2) {
          var v = tmpKMeansBreaks[i$7];
          if (!isNaN(v) && limits2.indexOf(v) === -1) {
            limits2.push(v);
          }
        }
      }
      return limits2;
    };
    var analyze_1 = { analyze, limits };
    var Color$3 = Color_1;
    var contrast = function(a, b) {
      a = new Color$3(a);
      b = new Color$3(b);
      var l1 = a.luminance();
      var l2 = b.luminance();
      return l1 > l2 ? (l1 + 0.05) / (l2 + 0.05) : (l2 + 0.05) / (l1 + 0.05);
    };
    var Color$2 = Color_1;
    var sqrt = Math.sqrt;
    var pow = Math.pow;
    var min = Math.min;
    var max = Math.max;
    var atan2 = Math.atan2;
    var abs = Math.abs;
    var cos = Math.cos;
    var sin = Math.sin;
    var exp = Math.exp;
    var PI = Math.PI;
    var deltaE = function(a, b, Kl, Kc, Kh) {
      if (Kl === void 0)
        Kl = 1;
      if (Kc === void 0)
        Kc = 1;
      if (Kh === void 0)
        Kh = 1;
      var rad2deg = function(rad) {
        return 360 * rad / (2 * PI);
      };
      var deg2rad = function(deg) {
        return 2 * PI * deg / 360;
      };
      a = new Color$2(a);
      b = new Color$2(b);
      var ref = Array.from(a.lab());
      var L1 = ref[0];
      var a1 = ref[1];
      var b1 = ref[2];
      var ref$1 = Array.from(b.lab());
      var L2 = ref$1[0];
      var a2 = ref$1[1];
      var b2 = ref$1[2];
      var avgL = (L1 + L2) / 2;
      var C1 = sqrt(pow(a1, 2) + pow(b1, 2));
      var C2 = sqrt(pow(a2, 2) + pow(b2, 2));
      var avgC = (C1 + C2) / 2;
      var G = 0.5 * (1 - sqrt(pow(avgC, 7) / (pow(avgC, 7) + pow(25, 7))));
      var a1p = a1 * (1 + G);
      var a2p = a2 * (1 + G);
      var C1p = sqrt(pow(a1p, 2) + pow(b1, 2));
      var C2p = sqrt(pow(a2p, 2) + pow(b2, 2));
      var avgCp = (C1p + C2p) / 2;
      var arctan1 = rad2deg(atan2(b1, a1p));
      var arctan2 = rad2deg(atan2(b2, a2p));
      var h1p = arctan1 >= 0 ? arctan1 : arctan1 + 360;
      var h2p = arctan2 >= 0 ? arctan2 : arctan2 + 360;
      var avgHp = abs(h1p - h2p) > 180 ? (h1p + h2p + 360) / 2 : (h1p + h2p) / 2;
      var T = 1 - 0.17 * cos(deg2rad(avgHp - 30)) + 0.24 * cos(deg2rad(2 * avgHp)) + 0.32 * cos(deg2rad(3 * avgHp + 6)) - 0.2 * cos(deg2rad(4 * avgHp - 63));
      var deltaHp = h2p - h1p;
      deltaHp = abs(deltaHp) <= 180 ? deltaHp : h2p <= h1p ? deltaHp + 360 : deltaHp - 360;
      deltaHp = 2 * sqrt(C1p * C2p) * sin(deg2rad(deltaHp) / 2);
      var deltaL = L2 - L1;
      var deltaCp = C2p - C1p;
      var sl = 1 + 0.015 * pow(avgL - 50, 2) / sqrt(20 + pow(avgL - 50, 2));
      var sc = 1 + 0.045 * avgCp;
      var sh = 1 + 0.015 * avgCp * T;
      var deltaTheta = 30 * exp(-pow((avgHp - 275) / 25, 2));
      var Rc = 2 * sqrt(pow(avgCp, 7) / (pow(avgCp, 7) + pow(25, 7)));
      var Rt = -Rc * sin(2 * deg2rad(deltaTheta));
      var result = sqrt(pow(deltaL / (Kl * sl), 2) + pow(deltaCp / (Kc * sc), 2) + pow(deltaHp / (Kh * sh), 2) + Rt * (deltaCp / (Kc * sc)) * (deltaHp / (Kh * sh)));
      return max(0, min(100, result));
    };
    var Color$1 = Color_1;
    var distance = function(a, b, mode) {
      if (mode === void 0)
        mode = "lab";
      a = new Color$1(a);
      b = new Color$1(b);
      var l1 = a.get(mode);
      var l2 = b.get(mode);
      var sum_sq = 0;
      for (var i2 in l1) {
        var d = (l1[i2] || 0) - (l2[i2] || 0);
        sum_sq += d * d;
      }
      return Math.sqrt(sum_sq);
    };
    var Color = Color_1;
    var valid = function() {
      var args = [], len = arguments.length;
      while (len--)
        args[len] = arguments[len];
      try {
        new (Function.prototype.bind.apply(Color, [null].concat(args)))();
        return true;
      } catch (e) {
        return false;
      }
    };
    var chroma$12 = chroma_1;
    var scale = scale$2;
    var scales = {
      cool: function cool() {
        return scale([chroma$12.hsl(180, 1, 0.9), chroma$12.hsl(250, 0.7, 0.4)]);
      },
      hot: function hot() {
        return scale(["#000", "#f00", "#ff0", "#fff"]).mode("rgb");
      }
    };
    var colorbrewer = {
      OrRd: ["#fff7ec", "#fee8c8", "#fdd49e", "#fdbb84", "#fc8d59", "#ef6548", "#d7301f", "#b30000", "#7f0000"],
      PuBu: ["#fff7fb", "#ece7f2", "#d0d1e6", "#a6bddb", "#74a9cf", "#3690c0", "#0570b0", "#045a8d", "#023858"],
      BuPu: ["#f7fcfd", "#e0ecf4", "#bfd3e6", "#9ebcda", "#8c96c6", "#8c6bb1", "#88419d", "#810f7c", "#4d004b"],
      Oranges: ["#fff5eb", "#fee6ce", "#fdd0a2", "#fdae6b", "#fd8d3c", "#f16913", "#d94801", "#a63603", "#7f2704"],
      BuGn: ["#f7fcfd", "#e5f5f9", "#ccece6", "#99d8c9", "#66c2a4", "#41ae76", "#238b45", "#006d2c", "#00441b"],
      YlOrBr: ["#ffffe5", "#fff7bc", "#fee391", "#fec44f", "#fe9929", "#ec7014", "#cc4c02", "#993404", "#662506"],
      YlGn: ["#ffffe5", "#f7fcb9", "#d9f0a3", "#addd8e", "#78c679", "#41ab5d", "#238443", "#006837", "#004529"],
      Reds: ["#fff5f0", "#fee0d2", "#fcbba1", "#fc9272", "#fb6a4a", "#ef3b2c", "#cb181d", "#a50f15", "#67000d"],
      RdPu: ["#fff7f3", "#fde0dd", "#fcc5c0", "#fa9fb5", "#f768a1", "#dd3497", "#ae017e", "#7a0177", "#49006a"],
      Greens: ["#f7fcf5", "#e5f5e0", "#c7e9c0", "#a1d99b", "#74c476", "#41ab5d", "#238b45", "#006d2c", "#00441b"],
      YlGnBu: ["#ffffd9", "#edf8b1", "#c7e9b4", "#7fcdbb", "#41b6c4", "#1d91c0", "#225ea8", "#253494", "#081d58"],
      Purples: ["#fcfbfd", "#efedf5", "#dadaeb", "#bcbddc", "#9e9ac8", "#807dba", "#6a51a3", "#54278f", "#3f007d"],
      GnBu: ["#f7fcf0", "#e0f3db", "#ccebc5", "#a8ddb5", "#7bccc4", "#4eb3d3", "#2b8cbe", "#0868ac", "#084081"],
      Greys: ["#ffffff", "#f0f0f0", "#d9d9d9", "#bdbdbd", "#969696", "#737373", "#525252", "#252525", "#000000"],
      YlOrRd: ["#ffffcc", "#ffeda0", "#fed976", "#feb24c", "#fd8d3c", "#fc4e2a", "#e31a1c", "#bd0026", "#800026"],
      PuRd: ["#f7f4f9", "#e7e1ef", "#d4b9da", "#c994c7", "#df65b0", "#e7298a", "#ce1256", "#980043", "#67001f"],
      Blues: ["#f7fbff", "#deebf7", "#c6dbef", "#9ecae1", "#6baed6", "#4292c6", "#2171b5", "#08519c", "#08306b"],
      PuBuGn: ["#fff7fb", "#ece2f0", "#d0d1e6", "#a6bddb", "#67a9cf", "#3690c0", "#02818a", "#016c59", "#014636"],
      Viridis: ["#440154", "#482777", "#3f4a8a", "#31678e", "#26838f", "#1f9d8a", "#6cce5a", "#b6de2b", "#fee825"],
      Spectral: ["#9e0142", "#d53e4f", "#f46d43", "#fdae61", "#fee08b", "#ffffbf", "#e6f598", "#abdda4", "#66c2a5", "#3288bd", "#5e4fa2"],
      RdYlGn: ["#a50026", "#d73027", "#f46d43", "#fdae61", "#fee08b", "#ffffbf", "#d9ef8b", "#a6d96a", "#66bd63", "#1a9850", "#006837"],
      RdBu: ["#67001f", "#b2182b", "#d6604d", "#f4a582", "#fddbc7", "#f7f7f7", "#d1e5f0", "#92c5de", "#4393c3", "#2166ac", "#053061"],
      PiYG: ["#8e0152", "#c51b7d", "#de77ae", "#f1b6da", "#fde0ef", "#f7f7f7", "#e6f5d0", "#b8e186", "#7fbc41", "#4d9221", "#276419"],
      PRGn: ["#40004b", "#762a83", "#9970ab", "#c2a5cf", "#e7d4e8", "#f7f7f7", "#d9f0d3", "#a6dba0", "#5aae61", "#1b7837", "#00441b"],
      RdYlBu: ["#a50026", "#d73027", "#f46d43", "#fdae61", "#fee090", "#ffffbf", "#e0f3f8", "#abd9e9", "#74add1", "#4575b4", "#313695"],
      BrBG: ["#543005", "#8c510a", "#bf812d", "#dfc27d", "#f6e8c3", "#f5f5f5", "#c7eae5", "#80cdc1", "#35978f", "#01665e", "#003c30"],
      RdGy: ["#67001f", "#b2182b", "#d6604d", "#f4a582", "#fddbc7", "#ffffff", "#e0e0e0", "#bababa", "#878787", "#4d4d4d", "#1a1a1a"],
      PuOr: ["#7f3b08", "#b35806", "#e08214", "#fdb863", "#fee0b6", "#f7f7f7", "#d8daeb", "#b2abd2", "#8073ac", "#542788", "#2d004b"],
      Set2: ["#66c2a5", "#fc8d62", "#8da0cb", "#e78ac3", "#a6d854", "#ffd92f", "#e5c494", "#b3b3b3"],
      Accent: ["#7fc97f", "#beaed4", "#fdc086", "#ffff99", "#386cb0", "#f0027f", "#bf5b17", "#666666"],
      Set1: ["#e41a1c", "#377eb8", "#4daf4a", "#984ea3", "#ff7f00", "#ffff33", "#a65628", "#f781bf", "#999999"],
      Set3: ["#8dd3c7", "#ffffb3", "#bebada", "#fb8072", "#80b1d3", "#fdb462", "#b3de69", "#fccde5", "#d9d9d9", "#bc80bd", "#ccebc5", "#ffed6f"],
      Dark2: ["#1b9e77", "#d95f02", "#7570b3", "#e7298a", "#66a61e", "#e6ab02", "#a6761d", "#666666"],
      Paired: ["#a6cee3", "#1f78b4", "#b2df8a", "#33a02c", "#fb9a99", "#e31a1c", "#fdbf6f", "#ff7f00", "#cab2d6", "#6a3d9a", "#ffff99", "#b15928"],
      Pastel2: ["#b3e2cd", "#fdcdac", "#cbd5e8", "#f4cae4", "#e6f5c9", "#fff2ae", "#f1e2cc", "#cccccc"],
      Pastel1: ["#fbb4ae", "#b3cde3", "#ccebc5", "#decbe4", "#fed9a6", "#ffffcc", "#e5d8bd", "#fddaec", "#f2f2f2"]
    };
    for (var i = 0, list = Object.keys(colorbrewer); i < list.length; i += 1) {
      var key = list[i];
      colorbrewer[key.toLowerCase()] = colorbrewer[key];
    }
    var colorbrewer_1 = colorbrewer;
    var chroma2 = chroma_1;
    chroma2.average = average;
    chroma2.bezier = bezier_1;
    chroma2.blend = blend_1;
    chroma2.cubehelix = cubehelix;
    chroma2.mix = chroma2.interpolate = mix$1;
    chroma2.random = random_1;
    chroma2.scale = scale$2;
    chroma2.analyze = analyze_1.analyze;
    chroma2.contrast = contrast;
    chroma2.deltaE = deltaE;
    chroma2.distance = distance;
    chroma2.limits = analyze_1.limits;
    chroma2.valid = valid;
    chroma2.scales = scales;
    chroma2.colors = w3cx11_1;
    chroma2.brewer = colorbrewer_1;
    var chroma_js = chroma2;
    return chroma_js;
  });
})(chroma$1);
var chroma = chroma$1.exports;
class Subject {
  constructor(name, color, styleType = "border") {
    __publicField(this, "name");
    __publicField(this, "color");
    __publicField(this, "styleType");
    __publicField(this, "xActive");
    this.name = name;
    this.color = color;
    this.styleType = styleType;
    this.active = true;
  }
  get active() {
    return this.xActive;
  }
  set active(val) {
    this.xActive = val;
  }
  get style() {
    const style = {};
    if (this.styleType === "background") {
      style["background-color"] = this.color;
      if (chroma.contrast(this.color, "#000000") >= 4.5)
        style.color = "#000000";
      else
        style.color = "#ffffff";
    }
    if (this.styleType === "text")
      style.color = this.color;
    if (this.styleType === "border") {
      style.border = "dotted 0.1em " + this.color;
      style["border-radius"] = "5px";
    }
    if (this.styleType === "underline") {
      style["border-bottom"] = "solid 0.1em " + this.color;
    }
    return style;
  }
}
class SubjectLedger {
  constructor() {
    __publicField(this, "composable");
    __publicField(this, "xGlossary");
    this.composable = null;
    this.xGlossary = /* @__PURE__ */ new Map();
  }
  get glossary() {
    return this.xGlossary;
  }
  get listSubjects() {
    return [...this.glossary.values()];
  }
  get listActiveSubjects() {
    return this.listSubjects.filter((sub) => sub.active);
  }
  link(composable) {
    this.composable = composable;
  }
  unlink() {
    this.composable = null;
  }
  byName(name) {
    return this.glossary.get(name);
  }
  subjectColor(subjectName) {
    var _a;
    return (_a = this.glossary.get(subjectName)) == null ? void 0 : _a.color;
  }
  subjectStyle(subjectName) {
    var _a;
    return (_a = this.glossary.get(subjectName)) == null ? void 0 : _a.style;
  }
  isSubjectActive(subjectName) {
    const subject = this.glossary.get(subjectName);
    return subject != null && subject.active;
  }
  activateSubject(subjectName) {
    var _a;
    const subject = this.glossary.get(subjectName);
    if (subject != null && !subject.active) {
      subject.active = true;
      (_a = this.composable) == null ? void 0 : _a.updateMarks();
    }
  }
  deactivateSubject(subjectName) {
    var _a;
    const subject = this.glossary.get(subjectName);
    if (subject != null && subject.active) {
      subject.active = false;
      (_a = this.composable) == null ? void 0 : _a.updateMarks();
    }
  }
  toggleSubject(subjectName) {
    const subject = this.glossary.get(subjectName);
    if (subject != null) {
      if (subject.active)
        this.deactivateSubject(subjectName);
      else
        this.activateSubject(subjectName);
    }
  }
  activateAllSubjects() {
    this.glossary.forEach((subject) => {
      subject.active = true;
    });
  }
  deactivateAllSubjects() {
    this.glossary.forEach((subject) => {
      subject.active = false;
    });
  }
}
/*! LeaderLine v1.0.7 (c) anseki https://anseki.github.io/leader-line/ */
(function() {
  var Z, w, O, M, I, o, t, s, h, u, n, a, e, _, v, l, r, i, E, x, p, c, d, C = "leader-line", b = 1, k = 2, L = 3, A = 4, V = { top: b, right: k, bottom: L, left: A }, P = 1, N = 2, T = 3, W = 4, B = 5, R = { straight: P, arc: N, fluid: T, magnet: W, grid: B }, Y = "behind", f = C + "-defs", y = '<svg xmlns="http://www.w3.org/2000/svg" version="1.1" id="leader-line-defs"><style><![CDATA[.leader-line{position:absolute;overflow:visible!important;pointer-events:none!important;font-size:16px}#leader-line-defs{width:0;height:0;position:absolute;left:0;top:0}.leader-line-line-path{fill:none}.leader-line-mask-bg-rect{fill:white}.leader-line-caps-mask-anchor,.leader-line-caps-mask-marker-shape{fill:black}.leader-line-caps-mask-anchor{stroke:black}.leader-line-caps-mask-line,.leader-line-plugs-face{stroke:rgba(0,0,0,0)}.leader-line-line-mask-shape{stroke:white}.leader-line-line-outline-mask-shape{stroke:black}.leader-line-plug-mask-shape{fill:white;stroke:black}.leader-line-plug-outline-mask-shape{fill:black;stroke:white}.leader-line-areaAnchor{position:absolute;overflow:visible!important}]]></style><defs><circle id="leader-line-disc" cx="0" cy="0" r="5"/><rect id="leader-line-square" x="-5" y="-5" width="10" height="10"/><polygon id="leader-line-arrow1" points="-8,-8 8,0 -8,8 -5,0"/><polygon id="leader-line-arrow2" points="-4,-8 4,0 -4,8 -7,5 -2,0 -7,-5"/><polygon id="leader-line-arrow3" points="-4,-5 8,0 -4,5"/><g id="leader-line-hand"><path style="fill: #fcfcfc" d="M9.19 11.14h4.75c1.38 0 2.49-1.11 2.49-2.49 0-.51-.15-.98-.41-1.37h1.3c1.38 0 2.49-1.11 2.49-2.49s-1.11-2.53-2.49-2.53h1.02c1.38 0 2.49-1.11 2.49-2.49s-1.11-2.49-2.49-2.49h14.96c1.37 0 2.49-1.11 2.49-2.49s-1.11-2.49-2.49-2.49H16.58C16-9.86 14.28-11.14 9.7-11.14c-4.79 0-6.55 3.42-7.87 4.73H-2.14v13.23h3.68C3.29 9.97 5.47 11.14 9.19 11.14L9.19 11.14Z"/><path style="fill: black" d="M13.95 12c1.85 0 3.35-1.5 3.35-3.35 0-.17-.02-.34-.04-.51h.07c1.85 0 3.35-1.5 3.35-3.35 0-.79-.27-1.51-.72-2.08 1.03-.57 1.74-1.67 1.74-2.93 0-.59-.16-1.15-.43-1.63h12.04c1.85 0 3.35-1.5 3.35-3.35 0-1.85-1.5-3.35-3.35-3.35H17.2C16.26-10.93 13.91-12 9.7-12 5.36-12 3.22-9.4 1.94-7.84c0 0-.29.33-.5.57-.63 0-3.58 0-3.58 0C-2.61-7.27-3-6.88-3-6.41v13.23c0 .47.39.86.86.86 0 0 2.48 0 3.2 0C2.9 10.73 5.29 12 9.19 12L13.95 12ZM9.19 10.28c-3.46 0-5.33-1.05-6.9-3.87-.15-.27-.44-.44-.75-.44 0 0-1.81 0-2.82 0V-5.55c1.06 0 3.11 0 3.11 0 .25 0 .44-.06.61-.25l.83-.95c1.23-1.49 2.91-3.53 6.43-3.53 3.45 0 4.9.74 5.57 1.72h-4.3c-.48 0-.86.38-.86.86s.39.86.86.86h22.34c.9 0 1.63.73 1.63 1.63 0 .9-.73 1.63-1.63 1.63H15.83c-.48 0-.86.38-.86.86 0 .47.39.86.86.86h2.52c.9 0 1.63.73 1.63 1.63s-.73 1.63-1.63 1.63h-3.12c-.48 0-.86.38-.86.86 0 .47.39.86.86.86h2.11c.88 0 1.63.76 1.63 1.67 0 .9-.73 1.63-1.63 1.63h-3.2c-.48 0-.86.39-.86.86 0 .47.39.86.86.86h1.36c.05.16.09.34.09.51 0 .9-.73 1.63-1.63 1.63C13.95 10.28 9.19 10.28 9.19 10.28Z"/></g><g id="leader-line-crosshair"><path d="M0-78.97c-43.54 0-78.97 35.43-78.97 78.97 0 43.54 35.43 78.97 78.97 78.97s78.97-35.43 78.97-78.97C78.97-43.54 43.55-78.97 0-78.97ZM76.51-1.21h-9.91v-9.11h-2.43v9.11h-11.45c-.64-28.12-23.38-50.86-51.5-51.5V-64.17h9.11V-66.6h-9.11v-9.91C42.46-75.86 75.86-42.45 76.51-1.21ZM-1.21-30.76h-9.11v2.43h9.11V-4.2c-1.44.42-2.57 1.54-2.98 2.98H-28.33v-9.11h-2.43v9.11H-50.29C-49.65-28-27.99-49.65-1.21-50.29V-30.76ZM-30.76 1.21v9.11h2.43v-9.11H-4.2c.42 1.44 1.54 2.57 2.98 2.98v24.13h-9.11v2.43h9.11v19.53C-27.99 49.65-49.65 28-50.29 1.21H-30.76ZM1.22 30.75h9.11v-2.43h-9.11V4.2c1.44-.42 2.56-1.54 2.98-2.98h24.13v9.11h2.43v-9.11h19.53C49.65 28 28 49.65 1.22 50.29V30.75ZM30.76-1.21v-9.11h-2.43v9.11H4.2c-.42-1.44-1.54-2.56-2.98-2.98V-28.33h9.11v-2.43h-9.11V-50.29C28-49.65 49.65-28 50.29-1.21H30.76ZM-1.21-76.51v9.91h-9.11v2.43h9.11v11.45c-28.12.64-50.86 23.38-51.5 51.5H-64.17v-9.11H-66.6v9.11h-9.91C-75.86-42.45-42.45-75.86-1.21-76.51ZM-76.51 1.21h9.91v9.11h2.43v-9.11h11.45c.64 28.12 23.38 50.86 51.5 51.5v11.45h-9.11v2.43h9.11v9.91C-42.45 75.86-75.86 42.45-76.51 1.21ZM1.22 76.51v-9.91h9.11v-2.43h-9.11v-11.45c28.12-.64 50.86-23.38 51.5-51.5h11.45v9.11h2.43v-9.11h9.91C75.86 42.45 42.45 75.86 1.22 76.51Z"/><path d="M0 83.58-7.1 96 7.1 96Z"/><path d="M0-83.58 7.1-96-7.1-96"/><path d="M83.58 0 96 7.1 96-7.1Z"/><path d="M-83.58 0-96-7.1-96 7.1Z"/></g></defs></svg>', X = { disc: { elmId: "leader-line-disc", noRotate: true, bBox: { left: -5, top: -5, width: 10, height: 10, right: 5, bottom: 5 }, widthR: 2.5, heightR: 2.5, bCircle: 5, sideLen: 5, backLen: 5, overhead: 0, outlineBase: 1, outlineMax: 4 }, square: { elmId: "leader-line-square", noRotate: true, bBox: { left: -5, top: -5, width: 10, height: 10, right: 5, bottom: 5 }, widthR: 2.5, heightR: 2.5, bCircle: 5, sideLen: 5, backLen: 5, overhead: 0, outlineBase: 1, outlineMax: 4 }, arrow1: { elmId: "leader-line-arrow1", bBox: { left: -8, top: -8, width: 16, height: 16, right: 8, bottom: 8 }, widthR: 4, heightR: 4, bCircle: 8, sideLen: 8, backLen: 8, overhead: 8, outlineBase: 2, outlineMax: 1.5 }, arrow2: { elmId: "leader-line-arrow2", bBox: { left: -7, top: -8, width: 11, height: 16, right: 4, bottom: 8 }, widthR: 2.75, heightR: 4, bCircle: 8, sideLen: 8, backLen: 7, overhead: 4, outlineBase: 1, outlineMax: 1.75 }, arrow3: { elmId: "leader-line-arrow3", bBox: { left: -4, top: -5, width: 12, height: 10, right: 8, bottom: 5 }, widthR: 3, heightR: 2.5, bCircle: 8, sideLen: 5, backLen: 4, overhead: 8, outlineBase: 1, outlineMax: 2.5 }, hand: { elmId: "leader-line-hand", bBox: { left: -3, top: -12, width: 40, height: 24, right: 37, bottom: 12 }, widthR: 10, heightR: 6, bCircle: 37, sideLen: 12, backLen: 3, overhead: 37 }, crosshair: { elmId: "leader-line-crosshair", noRotate: true, bBox: { left: -96, top: -96, width: 192, height: 192, right: 96, bottom: 96 }, widthR: 48, heightR: 48, bCircle: 96, sideLen: 96, backLen: 96, overhead: 0 } }, F = { behind: Y, disc: "disc", square: "square", arrow1: "arrow1", arrow2: "arrow2", arrow3: "arrow3", hand: "hand", crosshair: "crosshair" }, q = { disc: "disc", square: "square", arrow1: "arrow1", arrow2: "arrow2", arrow3: "arrow3", hand: "hand", crosshair: "crosshair" }, G = [b, k, L, A], D = "auto", Q = { x: "left", y: "top", width: "width", height: "height" }, z = 80, j = 4, H = 5, U = 120, K = 8, J = 3.75, $ = 10, ee = 30, te = 0.5522847, ne = 0.25 * Math.PI, m = /^\s*(\-?[\d\.]+)\s*(\%)?\s*$/, ae = "http://www.w3.org/2000/svg", S = "-ms-scroll-limit" in document.documentElement.style && "-ms-ime-align" in document.documentElement.style && !window.navigator.msPointerEnabled, ie = !S && !!document.uniqueID, oe = "MozAppearance" in document.documentElement.style, le = !(S || oe || !window.chrome || !window.CSS), re = !S && !ie && !oe && !le && !window.chrome && "WebkitAppearance" in document.documentElement.style, se = ie || S ? 0.2 : 0.1, ue = { path: T, lineColor: "coral", lineSize: 4, plugSE: [Y, "arrow1"], plugSizeSE: [1, 1], lineOutlineEnabled: false, lineOutlineColor: "indianred", lineOutlineSize: 0.25, plugOutlineEnabledSE: [false, false], plugOutlineSizeSE: [1, 1] }, he = (p = {}.toString, c = {}.hasOwnProperty.toString, d = c.call(Object), function(e2) {
    return e2 && p.call(e2) === "[object Object]" && (!(e2 = Object.getPrototypeOf(e2)) || (e2 = e2.hasOwnProperty("constructor") && e2.constructor) && typeof e2 == "function" && c.call(e2) === d);
  }), pe = Number.isFinite || function(e2) {
    return typeof e2 == "number" && window.isFinite(e2);
  }, g = (_ = { ease: [0.25, 0.1, 0.25, 1], linear: [0, 0, 1, 1], "ease-in": [0.42, 0, 1, 1], "ease-out": [0, 0, 0.58, 1], "ease-in-out": [0.42, 0, 0.58, 1] }, v = 1e3 / 60 / 2, l = window.requestAnimationFrame || window.mozRequestAnimationFrame || window.webkitRequestAnimationFrame || window.msRequestAnimationFrame || function(e2) {
    setTimeout(e2, v);
  }, r = window.cancelAnimationFrame || window.mozCancelAnimationFrame || window.webkitCancelAnimationFrame || window.msCancelAnimationFrame || function(e2) {
    clearTimeout(e2);
  }, i = Number.isFinite || function(e2) {
    return typeof e2 == "number" && window.isFinite(e2);
  }, E = [], x = 0, { add: function(n2, e2, t2, a2, i2, o2, l2) {
    var r2, s2, u2, h2, p2, c2, d2, f2, y2, m2, S2 = ++x;
    function g2(e3, t3) {
      return { value: n2(t3), timeRatio: e3, outputRatio: t3 };
    }
    if (typeof i2 == "string" && (i2 = _[i2]), n2 = n2 || function() {
    }, t2 < v)
      r2 = [g2(0, 0), g2(1, 1)];
    else {
      if (s2 = v / t2, r2 = [g2(0, 0)], i2[0] === 0 && i2[1] === 0 && i2[2] === 1 && i2[3] === 1)
        for (h2 = s2; h2 <= 1; h2 += s2)
          r2.push(g2(h2, h2));
      else
        for (p2 = u2 = (h2 = s2) / 10; p2 <= 1; p2 += u2)
          d2 = p2, m2 = y2 = f2 = void 0, f2 = (m2 = p2 * p2) * p2, m2 *= 3 * (y2 = 1 - p2), h2 <= (c2 = { x: (d2 = 3 * (y2 * y2) * p2) * i2[0] + m2 * i2[2] + f2, y: d2 * i2[1] + m2 * i2[3] + f2 }).x && (r2.push(g2(c2.x, c2.y)), h2 += s2);
      r2.push(g2(1, 1));
    }
    return E.push(o2 = { animId: S2, frameCallback: e2, duration: t2, count: a2, frames: r2, reverse: !!o2 }), l2 !== false && be(o2, l2), S2;
  }, remove: function(n2) {
    var a2;
    E.some(function(e2, t2) {
      return e2.animId === n2 && (a2 = t2, !(e2.framesStart = null));
    }) && E.splice(a2, 1);
  }, start: function(t2, n2, a2) {
    E.some(function(e2) {
      return e2.animId === t2 && (e2.reverse = !!n2, be(e2, a2), true);
    });
  }, stop: function(t2, n2) {
    var a2;
    return E.some(function(e2) {
      return e2.animId === t2 && (n2 ? e2.lastFrame != null && (a2 = e2.frames[e2.lastFrame].timeRatio) : (a2 = (Date.now() - e2.framesStart) / e2.duration, (a2 = e2.reverse ? 1 - a2 : a2) < 0 ? a2 = 0 : 1 < a2 && (a2 = 1)), !(e2.framesStart = null));
    }), a2;
  }, validTiming: function(t2) {
    return typeof t2 == "string" ? _[t2] : Array.isArray(t2) && [0, 1, 2, 3].every(function(e2) {
      return i(t2[e2]) && 0 <= t2[e2] && t2[e2] <= 1;
    }) ? [t2[0], t2[1], t2[2], t2[3]] : null;
  } }), ce = function(e2) {
    e2.SVGPathElement.prototype.getPathData && e2.SVGPathElement.prototype.setPathData || function() {
      function i2(e3) {
        this._string = e3, this._currentIndex = 0, this._endIndex = this._string.length, this._prevCommand = null, this._skipOptionalSpaces();
      }
      var a2 = { Z: "Z", M: "M", L: "L", C: "C", Q: "Q", A: "A", H: "H", V: "V", S: "S", T: "T", z: "Z", m: "m", l: "l", c: "c", q: "q", a: "a", h: "h", v: "v", s: "s", t: "t" }, o2 = e2.navigator.userAgent.indexOf("MSIE ") !== -1;
      i2.prototype = { parseSegment: function() {
        var e3 = this._string[this._currentIndex], t2 = a2[e3] || null;
        if (t2 === null) {
          if (this._prevCommand === null)
            return null;
          if ((t2 = (e3 === "+" || e3 === "-" || e3 === "." || "0" <= e3 && e3 <= "9") && this._prevCommand !== "Z" ? this._prevCommand === "M" ? "L" : this._prevCommand === "m" ? "l" : this._prevCommand : null) === null)
            return null;
        } else
          this._currentIndex += 1;
        var n3 = null, e3 = (this._prevCommand = t2).toUpperCase();
        return e3 === "H" || e3 === "V" ? n3 = [this._parseNumber()] : e3 === "M" || e3 === "L" || e3 === "T" ? n3 = [this._parseNumber(), this._parseNumber()] : e3 === "S" || e3 === "Q" ? n3 = [this._parseNumber(), this._parseNumber(), this._parseNumber(), this._parseNumber()] : e3 === "C" ? n3 = [this._parseNumber(), this._parseNumber(), this._parseNumber(), this._parseNumber(), this._parseNumber(), this._parseNumber()] : e3 === "A" ? n3 = [this._parseNumber(), this._parseNumber(), this._parseNumber(), this._parseArcFlag(), this._parseArcFlag(), this._parseNumber(), this._parseNumber()] : e3 === "Z" && (this._skipOptionalSpaces(), n3 = []), n3 === null || 0 <= n3.indexOf(null) ? null : { type: t2, values: n3 };
      }, hasMoreData: function() {
        return this._currentIndex < this._endIndex;
      }, peekSegmentType: function() {
        var e3 = this._string[this._currentIndex];
        return a2[e3] || null;
      }, initialCommandIsMoveTo: function() {
        if (!this.hasMoreData())
          return true;
        var e3 = this.peekSegmentType();
        return e3 === "M" || e3 === "m";
      }, _isCurrentSpace: function() {
        var e3 = this._string[this._currentIndex];
        return e3 <= " " && (e3 === " " || e3 === "\n" || e3 === "	" || e3 === "\r" || e3 === "\f");
      }, _skipOptionalSpaces: function() {
        for (; this._currentIndex < this._endIndex && this._isCurrentSpace(); )
          this._currentIndex += 1;
        return this._currentIndex < this._endIndex;
      }, _skipOptionalSpacesOrDelimiter: function() {
        return !(this._currentIndex < this._endIndex && !this._isCurrentSpace() && this._string[this._currentIndex] !== ",") && (this._skipOptionalSpaces() && this._currentIndex < this._endIndex && this._string[this._currentIndex] === "," && (this._currentIndex += 1, this._skipOptionalSpaces()), this._currentIndex < this._endIndex);
      }, _parseNumber: function() {
        var e3 = 0, t2 = 0, n3 = 1, a3 = 0, i3 = 1, o3 = 1, l3 = this._currentIndex;
        if (this._skipOptionalSpaces(), this._currentIndex < this._endIndex && this._string[this._currentIndex] === "+" ? this._currentIndex += 1 : this._currentIndex < this._endIndex && this._string[this._currentIndex] === "-" && (this._currentIndex += 1, i3 = -1), this._currentIndex === this._endIndex || (this._string[this._currentIndex] < "0" || "9" < this._string[this._currentIndex]) && this._string[this._currentIndex] !== ".")
          return null;
        for (var r3 = this._currentIndex; this._currentIndex < this._endIndex && "0" <= this._string[this._currentIndex] && this._string[this._currentIndex] <= "9"; )
          this._currentIndex += 1;
        if (this._currentIndex !== r3)
          for (var s3 = this._currentIndex - 1, u3 = 1; r3 <= s3; )
            t2 += u3 * (this._string[s3] - "0"), --s3, u3 *= 10;
        if (this._currentIndex < this._endIndex && this._string[this._currentIndex] === ".") {
          if (this._currentIndex += 1, this._currentIndex >= this._endIndex || this._string[this._currentIndex] < "0" || "9" < this._string[this._currentIndex])
            return null;
          for (; this._currentIndex < this._endIndex && "0" <= this._string[this._currentIndex] && this._string[this._currentIndex] <= "9"; )
            n3 *= 10, a3 += (this._string.charAt(this._currentIndex) - "0") / n3, this._currentIndex += 1;
        }
        if (this._currentIndex !== l3 && this._currentIndex + 1 < this._endIndex && (this._string[this._currentIndex] === "e" || this._string[this._currentIndex] === "E") && this._string[this._currentIndex + 1] !== "x" && this._string[this._currentIndex + 1] !== "m") {
          if (this._currentIndex += 1, this._string[this._currentIndex] === "+" ? this._currentIndex += 1 : this._string[this._currentIndex] === "-" && (this._currentIndex += 1, o3 = -1), this._currentIndex >= this._endIndex || this._string[this._currentIndex] < "0" || "9" < this._string[this._currentIndex])
            return null;
          for (; this._currentIndex < this._endIndex && "0" <= this._string[this._currentIndex] && this._string[this._currentIndex] <= "9"; )
            e3 *= 10, e3 += this._string[this._currentIndex] - "0", this._currentIndex += 1;
        }
        var h2 = t2 + a3;
        return h2 *= i3, e3 && (h2 *= Math.pow(10, o3 * e3)), l3 === this._currentIndex ? null : (this._skipOptionalSpacesOrDelimiter(), h2);
      }, _parseArcFlag: function() {
        if (this._currentIndex >= this._endIndex)
          return null;
        var e3 = null, t2 = this._string[this._currentIndex];
        if (this._currentIndex += 1, t2 === "0")
          e3 = 0;
        else {
          if (t2 !== "1")
            return null;
          e3 = 1;
        }
        return this._skipOptionalSpacesOrDelimiter(), e3;
      } };
      function n2(e3) {
        if (!e3 || e3.length === 0)
          return [];
        var t2 = new i2(e3), n3 = [];
        if (t2.initialCommandIsMoveTo())
          for (; t2.hasMoreData(); ) {
            var a3 = t2.parseSegment();
            if (a3 === null)
              break;
            n3.push(a3);
          }
        return n3;
      }
      function l2(e3) {
        return e3.map(function(e4) {
          return { type: e4.type, values: Array.prototype.slice.call(e4.values) };
        });
      }
      function r2(e3) {
        var u3 = [], h2 = null, p2 = null, c2 = null, d3 = null, f3 = null, y2 = null, m2 = null;
        return e3.forEach(function(e4) {
          var t2, n3, a3, i3, o3, l3, r3, s3;
          e4.type === "M" ? (r3 = e4.values[0], s3 = e4.values[1], u3.push({ type: "M", values: [r3, s3] }), d3 = y2 = r3, f3 = m2 = s3) : e4.type === "C" ? (o3 = e4.values[0], l3 = e4.values[1], t2 = e4.values[2], n3 = e4.values[3], r3 = e4.values[4], s3 = e4.values[5], u3.push({ type: "C", values: [o3, l3, t2, n3, r3, s3] }), p2 = t2, c2 = n3, d3 = r3, f3 = s3) : e4.type === "L" ? (r3 = e4.values[0], s3 = e4.values[1], u3.push({ type: "L", values: [r3, s3] }), d3 = r3, f3 = s3) : e4.type === "H" ? (r3 = e4.values[0], u3.push({ type: "L", values: [r3, f3] }), d3 = r3) : e4.type === "V" ? (s3 = e4.values[0], u3.push({ type: "L", values: [d3, s3] }), f3 = s3) : e4.type === "S" ? (t2 = e4.values[0], n3 = e4.values[1], r3 = e4.values[2], s3 = e4.values[3], i3 = h2 === "C" || h2 === "S" ? (a3 = d3 + (d3 - p2), f3 + (f3 - c2)) : (a3 = d3, f3), u3.push({ type: "C", values: [a3, i3, t2, n3, r3, s3] }), p2 = t2, c2 = n3, d3 = r3, f3 = s3) : e4.type === "T" ? (r3 = e4.values[0], s3 = e4.values[1], l3 = h2 === "Q" || h2 === "T" ? (o3 = d3 + (d3 - p2), f3 + (f3 - c2)) : (o3 = d3, f3), u3.push({ type: "C", values: [a3 = d3 + 2 * (o3 - d3) / 3, i3 = f3 + 2 * (l3 - f3) / 3, r3 + 2 * (o3 - r3) / 3, s3 + 2 * (l3 - s3) / 3, r3, s3] }), p2 = o3, c2 = l3, d3 = r3, f3 = s3) : e4.type === "Q" ? (o3 = e4.values[0], l3 = e4.values[1], r3 = e4.values[2], s3 = e4.values[3], u3.push({ type: "C", values: [a3 = d3 + 2 * (o3 - d3) / 3, i3 = f3 + 2 * (l3 - f3) / 3, r3 + 2 * (o3 - r3) / 3, s3 + 2 * (l3 - s3) / 3, r3, s3] }), p2 = o3, c2 = l3, d3 = r3, f3 = s3) : e4.type === "A" ? (n3 = e4.values[0], a3 = e4.values[1], i3 = e4.values[2], o3 = e4.values[3], l3 = e4.values[4], r3 = e4.values[5], s3 = e4.values[6], n3 === 0 || a3 === 0 ? (u3.push({ type: "C", values: [d3, f3, r3, s3, r3, s3] }), d3 = r3, f3 = s3) : d3 === r3 && f3 === s3 || b2(d3, f3, r3, s3, n3, a3, i3, o3, l3).forEach(function(e5) {
            u3.push({ type: "C", values: e5 }), d3 = r3, f3 = s3;
          })) : e4.type === "Z" && (u3.push(e4), d3 = y2, f3 = m2), h2 = e4.type;
        }), u3;
      }
      var s2 = e2.SVGPathElement.prototype.setAttribute, u2 = e2.SVGPathElement.prototype.removeAttribute, d2 = e2.Symbol ? e2.Symbol() : "__cachedPathData", f2 = e2.Symbol ? e2.Symbol() : "__cachedNormalizedPathData", b2 = function(e3, t2, n3, a3, i3, o3, l3, r3, s3, u3) {
        function h2(e4, t3, n4) {
          return { x: e4 * Math.cos(n4) - t3 * Math.sin(n4), y: e4 * Math.sin(n4) + t3 * Math.cos(n4) };
        }
        var p2 = Math.PI * l3 / 180, c2 = [];
        u3 ? (_2 = u3[0], v2 = u3[1], S2 = u3[2], g2 = u3[3]) : (e3 = (m2 = h2(e3, t2, -p2)).x, t2 = m2.y, 1 < (m2 = (y2 = (e3 - (n3 = (f3 = h2(n3, a3, -p2)).x)) / 2) * y2 / (i3 * i3) + (d3 = (t2 - (a3 = f3.y)) / 2) * d3 / (o3 * o3)) && (i3 *= m2 = Math.sqrt(m2), o3 *= m2), f3 = i3 * i3, m2 = o3 * o3, S2 = (f3 = (r3 === s3 ? -1 : 1) * Math.sqrt(Math.abs((f3 * m2 - f3 * d3 * d3 - m2 * y2 * y2) / (f3 * d3 * d3 + m2 * y2 * y2)))) * i3 * d3 / o3 + (e3 + n3) / 2, g2 = f3 * -o3 * y2 / i3 + (t2 + a3) / 2, _2 = Math.asin(parseFloat(((t2 - g2) / o3).toFixed(9))), v2 = Math.asin(parseFloat(((a3 - g2) / o3).toFixed(9))), e3 < S2 && (_2 = Math.PI - _2), n3 < S2 && (v2 = Math.PI - v2), _2 < 0 && (_2 = 2 * Math.PI + _2), v2 < 0 && (v2 = 2 * Math.PI + v2), s3 && v2 < _2 && (_2 -= 2 * Math.PI), !s3 && _2 < v2 && (v2 -= 2 * Math.PI));
        var d3, f3, y2, m2 = v2 - _2;
        Math.abs(m2) > 120 * Math.PI / 180 && (d3 = v2, f3 = n3, y2 = a3, v2 = s3 && _2 < v2 ? _2 + 120 * Math.PI / 180 * 1 : _2 + 120 * Math.PI / 180 * -1, n3 = S2 + i3 * Math.cos(v2), a3 = g2 + o3 * Math.sin(v2), c2 = b2(n3, a3, f3, y2, i3, o3, l3, 0, s3, [v2, d3, S2, g2]));
        var m2 = v2 - _2, S2 = Math.cos(_2), g2 = Math.sin(_2), _2 = Math.cos(v2), v2 = Math.sin(v2), m2 = Math.tan(m2 / 4), i3 = 4 / 3 * i3 * m2, o3 = 4 / 3 * o3 * m2, m2 = [e3, t2], S2 = [e3 + i3 * g2, t2 - o3 * S2], _2 = [n3 + i3 * v2, a3 - o3 * _2], a3 = [n3, a3];
        if (S2[0] = 2 * m2[0] - S2[0], S2[1] = 2 * m2[1] - S2[1], u3)
          return [S2, _2, a3].concat(c2);
        var c2 = [S2, _2, a3].concat(c2).join().split(","), E2 = [], x2 = [];
        return c2.forEach(function(e4, t3) {
          t3 % 2 ? x2.push(h2(c2[t3 - 1], c2[t3], p2).y) : x2.push(h2(c2[t3], c2[t3 + 1], p2).x), x2.length === 6 && (E2.push(x2), x2 = []);
        }), E2;
      };
      e2.SVGPathElement.prototype.setAttribute = function(e3, t2) {
        e3 === "d" && (this[d2] = null, this[f2] = null), s2.call(this, e3, t2);
      }, e2.SVGPathElement.prototype.removeAttribute = function(e3, t2) {
        e3 === "d" && (this[d2] = null, this[f2] = null), u2.call(this, e3);
      }, e2.SVGPathElement.prototype.getPathData = function(e3) {
        if (e3 && e3.normalize) {
          if (this[f2])
            return l2(this[f2]);
          this[d2] ? t2 = l2(this[d2]) : (t2 = n2(this.getAttribute("d") || ""), this[d2] = l2(t2));
          e3 = r2((s3 = [], c2 = p2 = h2 = u3 = null, t2.forEach(function(e4) {
            var t3, n3, a3, i3, o3, l3, r3 = e4.type;
            r3 === "M" ? (o3 = e4.values[0], l3 = e4.values[1], s3.push({ type: "M", values: [o3, l3] }), u3 = p2 = o3, h2 = c2 = l3) : r3 === "m" ? (o3 = u3 + e4.values[0], l3 = h2 + e4.values[1], s3.push({ type: "M", values: [o3, l3] }), u3 = p2 = o3, h2 = c2 = l3) : r3 === "L" ? (o3 = e4.values[0], l3 = e4.values[1], s3.push({ type: "L", values: [o3, l3] }), u3 = o3, h2 = l3) : r3 === "l" ? (o3 = u3 + e4.values[0], l3 = h2 + e4.values[1], s3.push({ type: "L", values: [o3, l3] }), u3 = o3, h2 = l3) : r3 === "C" ? (t3 = e4.values[0], n3 = e4.values[1], a3 = e4.values[2], i3 = e4.values[3], o3 = e4.values[4], l3 = e4.values[5], s3.push({ type: "C", values: [t3, n3, a3, i3, o3, l3] }), u3 = o3, h2 = l3) : r3 === "c" ? (t3 = u3 + e4.values[0], n3 = h2 + e4.values[1], a3 = u3 + e4.values[2], i3 = h2 + e4.values[3], o3 = u3 + e4.values[4], l3 = h2 + e4.values[5], s3.push({ type: "C", values: [t3, n3, a3, i3, o3, l3] }), u3 = o3, h2 = l3) : r3 === "Q" ? (t3 = e4.values[0], n3 = e4.values[1], o3 = e4.values[2], l3 = e4.values[3], s3.push({ type: "Q", values: [t3, n3, o3, l3] }), u3 = o3, h2 = l3) : r3 === "q" ? (t3 = u3 + e4.values[0], n3 = h2 + e4.values[1], o3 = u3 + e4.values[2], l3 = h2 + e4.values[3], s3.push({ type: "Q", values: [t3, n3, o3, l3] }), u3 = o3, h2 = l3) : r3 === "A" ? (o3 = e4.values[5], l3 = e4.values[6], s3.push({ type: "A", values: [e4.values[0], e4.values[1], e4.values[2], e4.values[3], e4.values[4], o3, l3] }), u3 = o3, h2 = l3) : r3 === "a" ? (o3 = u3 + e4.values[5], l3 = h2 + e4.values[6], s3.push({ type: "A", values: [e4.values[0], e4.values[1], e4.values[2], e4.values[3], e4.values[4], o3, l3] }), u3 = o3, h2 = l3) : r3 === "H" ? (o3 = e4.values[0], s3.push({ type: "H", values: [o3] }), u3 = o3) : r3 === "h" ? (o3 = u3 + e4.values[0], s3.push({ type: "H", values: [o3] }), u3 = o3) : r3 === "V" ? (l3 = e4.values[0], s3.push({ type: "V", values: [l3] }), h2 = l3) : r3 === "v" ? (l3 = h2 + e4.values[0], s3.push({ type: "V", values: [l3] }), h2 = l3) : r3 === "S" ? (a3 = e4.values[0], i3 = e4.values[1], o3 = e4.values[2], l3 = e4.values[3], s3.push({ type: "S", values: [a3, i3, o3, l3] }), u3 = o3, h2 = l3) : r3 === "s" ? (a3 = u3 + e4.values[0], i3 = h2 + e4.values[1], o3 = u3 + e4.values[2], l3 = h2 + e4.values[3], s3.push({ type: "S", values: [a3, i3, o3, l3] }), u3 = o3, h2 = l3) : r3 === "T" ? (o3 = e4.values[0], l3 = e4.values[1], s3.push({ type: "T", values: [o3, l3] }), u3 = o3, h2 = l3) : r3 === "t" ? (o3 = u3 + e4.values[0], l3 = h2 + e4.values[1], s3.push({ type: "T", values: [o3, l3] }), u3 = o3, h2 = l3) : r3 !== "Z" && r3 !== "z" || (s3.push({ type: "Z", values: [] }), u3 = p2, h2 = c2);
          }), s3));
          return this[f2] = l2(e3), e3;
        }
        if (this[d2])
          return l2(this[d2]);
        var s3, u3, h2, p2, c2, t2 = n2(this.getAttribute("d") || "");
        return this[d2] = l2(t2), t2;
      }, e2.SVGPathElement.prototype.setPathData = function(e3) {
        if (e3.length === 0)
          o2 ? this.setAttribute("d", "") : this.removeAttribute("d");
        else {
          for (var t2 = "", n3 = 0, a3 = e3.length; n3 < a3; n3 += 1) {
            var i3 = e3[n3];
            0 < n3 && (t2 += " "), t2 += i3.type, i3.values && 0 < i3.values.length && (t2 += " " + i3.values.join(" "));
          }
          this.setAttribute("d", t2);
        }
      }, e2.SVGRectElement.prototype.getPathData = function(e3) {
        var t2 = this.x.baseVal.value, n3 = this.y.baseVal.value, a3 = this.width.baseVal.value, i3 = this.height.baseVal.value, o3 = (this.hasAttribute("rx") ? this.rx : this.ry).baseVal.value, l3 = (this.hasAttribute("ry") ? this.ry : this.rx).baseVal.value, n3 = (n3 = [{ type: "M", values: [t2 + (o3 = a3 / 2 < o3 ? a3 / 2 : o3), n3] }, { type: "H", values: [t2 + a3 - o3] }, { type: "A", values: [o3, l3 = i3 / 2 < l3 ? i3 / 2 : l3, 0, 0, 1, t2 + a3, n3 + l3] }, { type: "V", values: [n3 + i3 - l3] }, { type: "A", values: [o3, l3, 0, 0, 1, t2 + a3 - o3, n3 + i3] }, { type: "H", values: [t2 + o3] }, { type: "A", values: [o3, l3, 0, 0, 1, t2, n3 + i3 - l3] }, { type: "V", values: [n3 + l3] }, { type: "A", values: [o3, l3, 0, 0, 1, t2 + o3, n3] }, { type: "Z", values: [] }]).filter(function(e4) {
          return e4.type !== "A" || e4.values[0] !== 0 && e4.values[1] !== 0;
        });
        return n3 = e3 && e3.normalize === true ? r2(n3) : n3;
      }, e2.SVGCircleElement.prototype.getPathData = function(e3) {
        var t2 = this.cx.baseVal.value, n3 = this.cy.baseVal.value, a3 = this.r.baseVal.value, n3 = [{ type: "M", values: [t2 + a3, n3] }, { type: "A", values: [a3, a3, 0, 0, 1, t2, n3 + a3] }, { type: "A", values: [a3, a3, 0, 0, 1, t2 - a3, n3] }, { type: "A", values: [a3, a3, 0, 0, 1, t2, n3 - a3] }, { type: "A", values: [a3, a3, 0, 0, 1, t2 + a3, n3] }, { type: "Z", values: [] }];
        return n3 = e3 && e3.normalize === true ? r2(n3) : n3;
      }, e2.SVGEllipseElement.prototype.getPathData = function(e3) {
        var t2 = this.cx.baseVal.value, n3 = this.cy.baseVal.value, a3 = this.rx.baseVal.value, i3 = this.ry.baseVal.value, n3 = [{ type: "M", values: [t2 + a3, n3] }, { type: "A", values: [a3, i3, 0, 0, 1, t2, n3 + i3] }, { type: "A", values: [a3, i3, 0, 0, 1, t2 - a3, n3] }, { type: "A", values: [a3, i3, 0, 0, 1, t2, n3 - i3] }, { type: "A", values: [a3, i3, 0, 0, 1, t2 + a3, n3] }, { type: "Z", values: [] }];
        return n3 = e3 && e3.normalize === true ? r2(n3) : n3;
      }, e2.SVGLineElement.prototype.getPathData = function() {
        return [{ type: "M", values: [this.x1.baseVal.value, this.y1.baseVal.value] }, { type: "L", values: [this.x2.baseVal.value, this.y2.baseVal.value] }];
      }, e2.SVGPolylineElement.prototype.getPathData = function() {
        for (var e3 = [], t2 = 0; t2 < this.points.numberOfItems; t2 += 1) {
          var n3 = this.points.getItem(t2);
          e3.push({ type: t2 === 0 ? "M" : "L", values: [n3.x, n3.y] });
        }
        return e3;
      }, e2.SVGPolygonElement.prototype.getPathData = function() {
        for (var e3 = [], t2 = 0; t2 < this.points.numberOfItems; t2 += 1) {
          var n3 = this.points.getItem(t2);
          e3.push({ type: t2 === 0 ? "M" : "L", values: [n3.x, n3.y] });
        }
        return e3.push({ type: "Z", values: [] }), e3;
      };
    }();
  }, S = (a = {}, Ee.m = n = [function(e2, t2, n2) {
    n2.r(t2);
    var a2 = 500, i2 = [], o2 = window.requestAnimationFrame || window.mozRequestAnimationFrame || window.webkitRequestAnimationFrame || window.msRequestAnimationFrame || function(e3) {
      return setTimeout(e3, 1e3 / 60);
    }, l2 = window.cancelAnimationFrame || window.mozCancelAnimationFrame || window.webkitCancelAnimationFrame || window.msCancelAnimationFrame || function(e3) {
      return clearTimeout(e3);
    }, r2 = Date.now(), s2 = void 0;
    function u2() {
      var n3 = void 0, e3 = void 0;
      s2 && (l2.call(window, s2), s2 = null), i2.forEach(function(e4) {
        var t3;
        (t3 = e4.event) && (e4.event = null, e4.listener(t3), n3 = true);
      }), n3 ? (r2 = Date.now(), e3 = true) : Date.now() - r2 < a2 && (e3 = true), e3 && (s2 = o2.call(window, u2));
    }
    function h2(n3) {
      var a3 = -1;
      return i2.some(function(e3, t3) {
        return e3.listener === n3 && (a3 = t3, true);
      }), a3;
    }
    t2.default = { add: function(e3) {
      var t3 = void 0;
      return h2(e3) === -1 ? (i2.push(t3 = { listener: e3 }), function(e4) {
        t3.event = e4, s2 || u2();
      }) : null;
    }, remove: function(e3) {
      -1 < (e3 = h2(e3)) && (i2.splice(e3, 1), !i2.length && s2 && (l2.call(window, s2), s2 = null));
    } };
  }], Ee.c = a, Ee.d = function(e2, t2, n2) {
    Ee.o(e2, t2) || Object.defineProperty(e2, t2, { enumerable: true, get: n2 });
  }, Ee.r = function(e2) {
    typeof Symbol != "undefined" && Symbol.toStringTag && Object.defineProperty(e2, Symbol.toStringTag, { value: "Module" }), Object.defineProperty(e2, "__esModule", { value: true });
  }, Ee.t = function(t2, e2) {
    if (1 & e2 && (t2 = Ee(t2)), 8 & e2)
      return t2;
    if (4 & e2 && typeof t2 == "object" && t2 && t2.__esModule)
      return t2;
    var n2 = /* @__PURE__ */ Object.create(null);
    if (Ee.r(n2), Object.defineProperty(n2, "default", { enumerable: true, value: t2 }), 2 & e2 && typeof t2 != "string")
      for (var a2 in t2)
        Ee.d(n2, a2, function(e3) {
          return t2[e3];
        }.bind(null, a2));
    return n2;
  }, Ee.n = function(e2) {
    var t2 = e2 && e2.__esModule ? function() {
      return e2.default;
    } : function() {
      return e2;
    };
    return Ee.d(t2, "a", t2), t2;
  }, Ee.o = function(e2, t2) {
    return Object.prototype.hasOwnProperty.call(e2, t2);
  }, Ee.p = "", Ee(Ee.s = 0).default), de = { line_altColor: { iniValue: false }, line_color: {}, line_colorTra: { iniValue: false }, line_strokeWidth: {}, plug_enabled: { iniValue: false }, plug_enabledSE: { hasSE: true, iniValue: false }, plug_plugSE: { hasSE: true, iniValue: Y }, plug_colorSE: { hasSE: true }, plug_colorTraSE: { hasSE: true, iniValue: false }, plug_markerWidthSE: { hasSE: true }, plug_markerHeightSE: { hasSE: true }, lineOutline_enabled: { iniValue: false }, lineOutline_color: {}, lineOutline_colorTra: { iniValue: false }, lineOutline_strokeWidth: {}, lineOutline_inStrokeWidth: {}, plugOutline_enabledSE: { hasSE: true, iniValue: false }, plugOutline_plugSE: { hasSE: true, iniValue: Y }, plugOutline_colorSE: { hasSE: true }, plugOutline_colorTraSE: { hasSE: true, iniValue: false }, plugOutline_strokeWidthSE: { hasSE: true }, plugOutline_inStrokeWidthSE: { hasSE: true }, position_socketXYSE: { hasSE: true, hasProps: true }, position_plugOverheadSE: { hasSE: true }, position_path: {}, position_lineStrokeWidth: {}, position_socketGravitySE: { hasSE: true }, path_pathData: {}, path_edge: { hasProps: true }, viewBox_bBox: { hasProps: true }, viewBox_plugBCircleSE: { hasSE: true }, lineMask_enabled: { iniValue: false }, lineMask_outlineMode: { iniValue: false }, lineMask_x: {}, lineMask_y: {}, lineOutlineMask_x: {}, lineOutlineMask_y: {}, maskBGRect_x: {}, maskBGRect_y: {}, capsMaskAnchor_enabledSE: { hasSE: true, iniValue: false }, capsMaskAnchor_pathDataSE: { hasSE: true }, capsMaskAnchor_strokeWidthSE: { hasSE: true }, capsMaskMarker_enabled: { iniValue: false }, capsMaskMarker_enabledSE: { hasSE: true, iniValue: false }, capsMaskMarker_plugSE: { hasSE: true, iniValue: Y }, capsMaskMarker_markerWidthSE: { hasSE: true }, capsMaskMarker_markerHeightSE: { hasSE: true }, caps_enabled: { iniValue: false }, attach_plugSideLenSE: { hasSE: true }, attach_plugBackLenSE: { hasSE: true } }, fe = { show_on: {}, show_effect: {}, show_animOptions: {}, show_animId: {}, show_inAnim: {} }, ye = "fade", me = [], Se = {}, ge = 0, _e = {}, ve = 0;
  function Ee(e2) {
    if (a[e2])
      return a[e2].exports;
    var t2 = a[e2] = { i: e2, l: false, exports: {} };
    return n[e2].call(t2.exports, t2, t2.exports, Ee), t2.l = true, t2.exports;
  }
  function xe() {
    var i2 = Date.now(), o2 = false;
    e && (r.call(window, e), e = null), E.forEach(function(e2) {
      var t2, n2, a2;
      if (e2.framesStart) {
        if ((t2 = i2 - e2.framesStart) >= e2.duration && e2.count && e2.loopsLeft <= 1)
          return a2 = e2.frames[e2.lastFrame = e2.reverse ? 0 : e2.frames.length - 1], e2.frameCallback(a2.value, true, a2.timeRatio, a2.outputRatio), void (e2.framesStart = null);
        if (t2 > e2.duration) {
          if (n2 = Math.floor(t2 / e2.duration), e2.count) {
            if (n2 >= e2.loopsLeft)
              return a2 = e2.frames[e2.lastFrame = e2.reverse ? 0 : e2.frames.length - 1], e2.frameCallback(a2.value, true, a2.timeRatio, a2.outputRatio), void (e2.framesStart = null);
            e2.loopsLeft -= n2;
          }
          e2.framesStart += e2.duration * n2, t2 = i2 - e2.framesStart;
        }
        e2.reverse && (t2 = e2.duration - t2), a2 = e2.frames[e2.lastFrame = Math.round(t2 / v)], e2.frameCallback(a2.value, false, a2.timeRatio, a2.outputRatio) !== false ? o2 = true : e2.framesStart = null;
      }
    }), o2 && (e = l.call(window, xe));
  }
  function be(e2, t2) {
    e2.framesStart = Date.now(), t2 != null && (e2.framesStart -= e2.duration * (e2.reverse ? 1 - t2 : t2)), e2.loopsLeft = e2.count, e2.lastFrame = null, xe();
  }
  function ke(t2, n2) {
    var e2, a2;
    return typeof t2 != typeof n2 || (e2 = he(t2) ? "obj" : Array.isArray(t2) ? "array" : "") != (he(n2) ? "obj" : Array.isArray(n2) ? "array" : "") || (e2 === "obj" ? ke(a2 = Object.keys(t2).sort(), Object.keys(n2).sort()) || a2.some(function(e3) {
      return ke(t2[e3], n2[e3]);
    }) : e2 === "array" ? t2.length !== n2.length || t2.some(function(e3, t3) {
      return ke(e3, n2[t3]);
    }) : t2 !== n2);
  }
  function we(n2) {
    return n2 && (he(n2) ? Object.keys(n2).reduce(function(e2, t2) {
      return e2[t2] = we(n2[t2]), e2;
    }, {}) : Array.isArray(n2) ? n2.map(we) : n2);
  }
  function Oe(e2) {
    var t2, n2, a2, i2 = 1, o2 = e2 = (e2 + "").trim();
    function l2(e3) {
      var t3 = 1, e3 = m.exec(e3);
      return e3 && (t3 = parseFloat(e3[1]), e3[2] ? t3 = 0 <= t3 && t3 <= 100 ? t3 / 100 : 1 : (t3 < 0 || 1 < t3) && (t3 = 1)), t3;
    }
    return (t2 = /^(rgba|hsla|hwb|gray|device\-cmyk)\s*\(([\s\S]+)\)$/i.exec(e2)) ? (n2 = t2[1].toLowerCase(), a2 = t2[2].trim().split(/\s*,\s*/), n2 === "rgba" && a2.length === 4 ? (i2 = l2(a2[3]), o2 = "rgb(" + a2.slice(0, 3).join(", ") + ")") : n2 === "hsla" && a2.length === 4 ? (i2 = l2(a2[3]), o2 = "hsl(" + a2.slice(0, 3).join(", ") + ")") : n2 === "hwb" && a2.length === 4 ? (i2 = l2(a2[3]), o2 = "hwb(" + a2.slice(0, 3).join(", ") + ")") : n2 === "gray" && a2.length === 2 ? (i2 = l2(a2[1]), o2 = "gray(" + a2[0] + ")") : n2 === "device-cmyk" && 5 <= a2.length && (i2 = l2(a2[4]), o2 = "device-cmyk(" + a2.slice(0, 4).join(", ") + ")")) : (t2 = /^\#(?:([\da-f]{6})([\da-f]{2})|([\da-f]{3})([\da-f]))$/i.exec(e2)) ? o2 = t2[1] ? (i2 = parseInt(t2[2], 16) / 255, "#" + t2[1]) : (i2 = parseInt(t2[4] + t2[4], 16) / 255, "#" + t2[3]) : e2.toLocaleLowerCase() === "transparent" && (i2 = 0), [i2, o2];
  }
  function Me(e2) {
    return !(!e2 || e2.nodeType !== Node.ELEMENT_NODE || typeof e2.getBoundingClientRect != "function");
  }
  function Ie(e2, t2) {
    var n2, a2, i2, o2 = {};
    if (!(i2 = e2.ownerDocument))
      return console.error("Cannot get document that contains the element."), null;
    if (e2.compareDocumentPosition(i2) & Node.DOCUMENT_POSITION_DISCONNECTED)
      return console.error("A disconnected element was passed."), null;
    for (a2 in n2 = e2.getBoundingClientRect())
      o2[a2] = n2[a2];
    if (!t2) {
      if (!(i2 = i2.defaultView))
        return console.error("Cannot get window that contains the element."), null;
      o2.left += i2.pageXOffset, o2.right += i2.pageXOffset, o2.top += i2.pageYOffset, o2.bottom += i2.pageYOffset;
    }
    return o2;
  }
  function Ce(e2, t2) {
    var n2, a2 = [], i2 = e2;
    for (t2 = t2 || window; ; ) {
      if (!(n2 = i2.ownerDocument))
        return console.error("Cannot get document that contains the element."), null;
      if (!(n2 = n2.defaultView))
        return console.error("Cannot get window that contains the element."), null;
      if (n2 === t2)
        break;
      if (!(i2 = n2.frameElement))
        return console.error("`baseWindow` was not found."), null;
      a2.unshift(i2);
    }
    return a2;
  }
  function Le(e2, t2) {
    var a2 = 0, i2 = 0;
    return (t2 = Ce(e2, t2 = t2 || window)) ? t2.length ? (t2.forEach(function(e3, t3) {
      var n2 = Ie(e3, 0 < t3);
      a2 += n2.left, i2 += n2.top, e3 = (t3 = e3).ownerDocument.defaultView.getComputedStyle(t3, ""), n2 = { left: t3.clientLeft + parseFloat(e3.paddingLeft), top: t3.clientTop + parseFloat(e3.paddingTop) }, a2 += n2.left, i2 += n2.top;
    }), (t2 = Ie(e2, true)).left += a2, t2.right += a2, t2.top += i2, t2.bottom += i2, t2) : Ie(e2) : null;
  }
  function Ae(e2, t2) {
    var n2 = e2.x - t2.x, t2 = e2.y - t2.y;
    return Math.sqrt(n2 * n2 + t2 * t2);
  }
  function Ve(e2, t2, n2) {
    var a2 = t2.x - e2.x, t2 = t2.y - e2.y;
    return { x: e2.x + a2 * n2, y: e2.y + t2 * n2, angle: Math.atan2(t2, a2) / (Math.PI / 180) };
  }
  function Pe(e2, t2, n2) {
    e2 = Math.atan2(e2.y - t2.y, t2.x - e2.x);
    return { x: t2.x + Math.cos(e2) * n2, y: t2.y + Math.sin(e2) * n2 * -1 };
  }
  function Ne(e2, t2, n2, a2, i2) {
    var o2 = i2 * i2, l2 = o2 * i2, r2 = 1 - i2, s2 = r2 * r2, u2 = s2 * r2, h2 = u2 * e2.x + 3 * s2 * i2 * t2.x + 3 * r2 * o2 * n2.x + l2 * a2.x, p2 = u2 * e2.y + 3 * s2 * i2 * t2.y + 3 * r2 * o2 * n2.y + l2 * a2.y, c2 = e2.x + 2 * i2 * (t2.x - e2.x) + o2 * (n2.x - 2 * t2.x + e2.x), u2 = e2.y + 2 * i2 * (t2.y - e2.y) + o2 * (n2.y - 2 * t2.y + e2.y), s2 = t2.x + 2 * i2 * (n2.x - t2.x) + o2 * (a2.x - 2 * n2.x + t2.x), l2 = t2.y + 2 * i2 * (n2.y - t2.y) + o2 * (a2.y - 2 * n2.y + t2.y), o2 = r2 * e2.x + i2 * t2.x, e2 = r2 * e2.y + i2 * t2.y, t2 = r2 * n2.x + i2 * a2.x, i2 = r2 * n2.y + i2 * a2.y, a2 = 90 - 180 * Math.atan2(c2 - s2, u2 - l2) / Math.PI;
    return { x: h2, y: p2, fromP2: { x: c2, y: u2 }, toP1: { x: s2, y: l2 }, fromP1: { x: o2, y: e2 }, toP2: { x: t2, y: i2 }, angle: a2 += 180 < a2 ? -180 : 180 };
  }
  function Te(n2, a2, i2, o2, e2) {
    function l2(e3, t2, n3, a3, i3) {
      return e3 * (e3 * (-3 * t2 + 9 * n3 - 9 * a3 + 3 * i3) + 6 * t2 - 12 * n3 + 6 * a3) - 3 * t2 + 3 * n3;
    }
    var r2, s2, u2 = [0.2491, 0.2491, 0.2335, 0.2335, 0.2032, 0.2032, 0.1601, 0.1601, 0.1069, 0.1069, 0.0472, 0.0472], h2 = 0, p2 = (e2 = e2 == null || 1 < e2 ? 1 : e2 < 0 ? 0 : e2) / 2;
    return [-0.1252, 0.1252, -0.3678, 0.3678, -0.5873, 0.5873, -0.7699, 0.7699, -0.9041, 0.9041, -0.9816, 0.9816].forEach(function(e3, t2) {
      r2 = l2(s2 = p2 * e3 + p2, n2.x, a2.x, i2.x, o2.x), s2 = l2(s2, n2.y, a2.y, i2.y, o2.y), s2 = r2 * r2 + s2 * s2, h2 += u2[t2] * Math.sqrt(s2);
    }), p2 * h2;
  }
  function We(e2, t2, n2, a2, i2) {
    for (var o2, l2 = 0.5, r2 = 1 - l2; o2 = Te(e2, t2, n2, a2, r2), !(Math.abs(o2 - i2) <= 0.01); )
      r2 += (o2 < i2 ? 1 : -1) * (l2 /= 2);
    return r2;
  }
  function Be(e2, t2) {
    var n2;
    return e2.forEach(function(e3) {
      e3 = t2 ? e3.map(function(e4) {
        e4 = { x: e4.x, y: e4.y };
        return t2(e4), e4;
      }) : e3;
      (n2 = n2 || [{ type: "M", values: [e3[0].x, e3[0].y] }]).push(e3.length ? e3.length === 2 ? { type: "L", values: [e3[1].x, e3[1].y] } : { type: "C", values: [e3[1].x, e3[1].y, e3[2].x, e3[2].y, e3[3].x, e3[3].y] } : { type: "Z", values: [] });
    }), n2;
  }
  function Re(e2) {
    var t2 = [], n2 = 0;
    return e2.forEach(function(e3) {
      e3 = (e3.length === 2 ? Ae : Te).apply(null, e3);
      t2.push(e3), n2 += e3;
    }), { segsLen: t2, lenAll: n2 };
  }
  function Fe(e2, a2) {
    return e2 == null || a2 == null || e2.length !== a2.length || e2.some(function(e3, t2) {
      var n2 = a2[t2];
      return e3.type !== n2.type || e3.values.some(function(e4, t3) {
        return e4 !== n2.values[t3];
      });
    });
  }
  function Ge(e2, t2, n2) {
    e2.events[t2] ? e2.events[t2].indexOf(n2) < 0 && e2.events[t2].push(n2) : e2.events[t2] = [n2];
  }
  function De(e2, t2, n2) {
    var a2;
    e2.events[t2] && -1 < (a2 = e2.events[t2].indexOf(n2)) && e2.events[t2].splice(a2, 1);
  }
  function ze(e2) {
    t && clearTimeout(t), me.push(e2), t = setTimeout(function() {
      me.forEach(function(e3) {
        e3();
      }), me = [];
    }, 0);
  }
  function je(e2, t2) {
    e2.reflowTargets.indexOf(t2) < 0 && e2.reflowTargets.push(t2);
  }
  function He(e2) {
    e2.reflowTargets.forEach(function(e3) {
      var n2;
      n2 = e3, setTimeout(function() {
        var e4 = n2.parentNode, t2 = n2.nextSibling;
        e4.insertBefore(e4.removeChild(n2), t2);
      }, 0);
    }), e2.reflowTargets = [];
  }
  function Ue(e2, t2, n2, a2, i2, o2, l2) {
    var r2;
    n2 === "auto-start-reverse" ? (typeof s != "boolean" && (t2.setAttribute("orient", "auto-start-reverse"), s = t2.orientType.baseVal === SVGMarkerElement.SVG_MARKER_ORIENT_UNKNOWN), s ? t2.setAttribute("orient", n2) : ((r2 = i2.createSVGTransform()).setRotate(180, 0, 0), o2.transform.baseVal.appendItem(r2), t2.setAttribute("orient", "auto"), r2 = true)) : (t2.setAttribute("orient", n2), s === false && o2.transform.baseVal.clear()), t2 = t2.viewBox.baseVal, r2 ? (t2.x = -a2.right, t2.y = -a2.bottom) : (t2.x = a2.left, t2.y = a2.top), t2.width = a2.width, t2.height = a2.height, ie && je(e2, l2);
  }
  function Ze(e2, t2) {
    return { prop: e2 ? "markerEnd" : "markerStart", orient: t2 ? t2.noRotate ? "0" : e2 ? "auto" : "auto-start-reverse" : null };
  }
  function Ye(n2, a2) {
    Object.keys(a2).forEach(function(e2) {
      var t2 = a2[e2];
      n2[e2] = t2.iniValue != null ? t2.hasSE ? [t2.iniValue, t2.iniValue] : t2.iniValue : t2.hasSE ? t2.hasProps ? [{}, {}] : [] : t2.hasProps ? {} : null;
    });
  }
  function Xe(t2, e2, n2, a2, i2) {
    return a2 !== e2[n2] && (e2[n2] = a2, i2 && i2.forEach(function(e3) {
      e3(t2, a2, n2);
    }), true);
  }
  function qe(e2) {
    function t2(e3, t3) {
      return e3 + parseFloat(t3);
    }
    var n2 = e2.document, a2 = e2.getComputedStyle(n2.documentElement, ""), e2 = e2.getComputedStyle(n2.body, ""), n2 = { x: 0, y: 0 };
    return e2.position !== "static" ? (n2.x -= [a2.marginLeft, a2.borderLeftWidth, a2.paddingLeft, e2.marginLeft, e2.borderLeftWidth].reduce(t2, 0), n2.y -= [a2.marginTop, a2.borderTopWidth, a2.paddingTop, e2.marginTop, e2.borderTopWidth].reduce(t2, 0)) : a2.position !== "static" && (n2.x -= [a2.marginLeft, a2.borderLeftWidth].reduce(t2, 0), n2.y -= [a2.marginTop, a2.borderTopWidth].reduce(t2, 0)), n2;
  }
  function Qe(e2) {
    var t2, n2 = e2.document;
    n2.getElementById(f) || (t2 = new e2.DOMParser().parseFromString(y, "image/svg+xml"), n2.body.appendChild(t2.documentElement), ce(e2));
  }
  function Ke(l2) {
    var g2, c2, _2, e2, n2, a2, i2, d2, o2, r2, s2, t2, u2, h2, p2 = l2.options, f2 = l2.curStats, y2 = l2.aplStats, v2 = f2.position_socketXYSE, m2 = false;
    function S2(e3, t3) {
      e3 = t3 === b ? { x: e3.left + e3.width / 2, y: e3.top } : t3 === k ? { x: e3.right, y: e3.top + e3.height / 2 } : t3 === L ? { x: e3.left + e3.width / 2, y: e3.bottom } : { x: e3.left, y: e3.top + e3.height / 2 };
      return e3.socketId = t3, e3;
    }
    function E2(e3) {
      return { x: e3.x, y: e3.y };
    }
    if (f2.position_path = p2.path, f2.position_lineStrokeWidth = f2.line_strokeWidth, f2.position_socketGravitySE = g2 = we(p2.socketGravitySE), c2 = [0, 1].map(function(e3) {
      var t3 = p2.anchorSE[e3], n3 = l2.optionIsAttach.anchorSE[e3], a3 = n3 !== false ? _e[t3._id] : null, i3 = n3 !== false && a3.conf.getStrokeWidth ? a3.conf.getStrokeWidth(a3, l2) : 0, o3 = n3 !== false && a3.conf.getBBoxNest ? a3.conf.getBBoxNest(a3, l2, i3) : Le(t3, l2.baseWindow);
      return f2.capsMaskAnchor_pathDataSE[e3] = n3 !== false && a3.conf.getPathData ? a3.conf.getPathData(a3, l2, i3) : (n3 = (t3 = o3).right != null ? t3.right : t3.left + t3.width, a3 = t3.bottom != null ? t3.bottom : t3.top + t3.height, [{ type: "M", values: [t3.left, t3.top] }, { type: "L", values: [n3, t3.top] }, { type: "L", values: [n3, a3] }, { type: "L", values: [t3.left, a3] }, { type: "Z", values: [] }]), f2.capsMaskAnchor_strokeWidthSE[e3] = i3, o3;
    }), i2 = -1, p2.socketSE[0] && p2.socketSE[1] ? (v2[0] = S2(c2[0], p2.socketSE[0]), v2[1] = S2(c2[1], p2.socketSE[1])) : (p2.socketSE[0] || p2.socketSE[1] ? (a2 = p2.socketSE[0] ? (n2 = 0, 1) : (n2 = 1, 0), v2[n2] = S2(c2[n2], p2.socketSE[n2]), (e2 = G.map(function(e3) {
      return S2(c2[a2], e3);
    })).forEach(function(e3) {
      var t3 = Ae(e3, v2[n2]);
      (t3 < i2 || i2 === -1) && (v2[a2] = e3, i2 = t3);
    })) : (e2 = G.map(function(e3) {
      return S2(c2[1], e3);
    }), G.map(function(e3) {
      return S2(c2[0], e3);
    }).forEach(function(n3) {
      e2.forEach(function(e3) {
        var t3 = Ae(n3, e3);
        (t3 < i2 || i2 === -1) && (v2[0] = n3, v2[1] = e3, i2 = t3);
      });
    })), [0, 1].forEach(function(e3) {
      var t3, n3;
      p2.socketSE[e3] || (c2[e3].width || c2[e3].height ? c2[e3].width || v2[e3].socketId !== A && v2[e3].socketId !== k ? c2[e3].height || v2[e3].socketId !== b && v2[e3].socketId !== L || (v2[e3].socketId = 0 <= v2[e3 ? 0 : 1].y - c2[e3].top ? L : b) : v2[e3].socketId = 0 <= v2[e3 ? 0 : 1].x - c2[e3].left ? k : A : (t3 = v2[e3 ? 0 : 1].x - c2[e3].left, n3 = v2[e3 ? 0 : 1].y - c2[e3].top, v2[e3].socketId = Math.abs(t3) >= Math.abs(n3) ? 0 <= t3 ? k : A : 0 <= n3 ? L : b));
    })), f2.position_path !== y2.position_path || f2.position_lineStrokeWidth !== y2.position_lineStrokeWidth || [0, 1].some(function(e3) {
      return f2.position_plugOverheadSE[e3] !== y2.position_plugOverheadSE[e3] || (t3 = v2[e3], n3 = y2.position_socketXYSE[e3], t3.x !== n3.x || t3.y !== n3.y || t3.socketId !== n3.socketId) || (t3 = g2[e3], n3 = y2.position_socketGravitySE[e3], (e3 = t3 == null ? "auto" : Array.isArray(t3) ? "array" : "number") != (n3 == null ? "auto" : Array.isArray(n3) ? "array" : "number") || (e3 == "array" ? t3[0] !== n3[0] || t3[1] !== n3[1] : t3 !== n3));
      var t3, n3;
    })) {
      switch (l2.pathList.baseVal = _2 = [], l2.pathList.animVal = null, f2.position_path) {
        case P:
          _2.push([E2(v2[0]), E2(v2[1])]);
          break;
        case N:
          t2 = typeof g2[0] == "number" && 0 < g2[0] || typeof g2[1] == "number" && 0 < g2[1], u2 = ne * (t2 ? -1 : 1), h2 = Math.atan2(v2[1].y - v2[0].y, v2[1].x - v2[0].x), t2 = u2 - h2, h2 = Math.PI - h2 - u2, u2 = Ae(v2[0], v2[1]) / Math.sqrt(2) * te, t2 = { x: v2[0].x + Math.cos(t2) * u2, y: v2[0].y + Math.sin(t2) * u2 * -1 }, u2 = { x: v2[1].x + Math.cos(h2) * u2, y: v2[1].y + Math.sin(h2) * u2 * -1 }, _2.push([E2(v2[0]), t2, u2, E2(v2[1])]);
          break;
        case T:
        case W:
          o2 = [g2[0], f2.position_path === W ? 0 : g2[1]], r2 = [], s2 = [], v2.forEach(function(e3, t3) {
            var n3, a3 = o2[t3], i3 = Array.isArray(a3) ? { x: a3[0], y: a3[1] } : typeof a3 == "number" ? e3.socketId === b ? { x: 0, y: -a3 } : e3.socketId === k ? { x: a3, y: 0 } : e3.socketId === L ? { x: 0, y: a3 } : { x: -a3, y: 0 } : (n3 = v2[t3 ? 0 : 1], a3 = 0 < (a3 = f2.position_plugOverheadSE[t3]) ? U + (K < a3 ? (a3 - K) * J : 0) : z + (f2.position_lineStrokeWidth > j ? (f2.position_lineStrokeWidth - j) * H : 0), e3.socketId === b ? { x: 0, y: -(i3 = (i3 = (e3.y - n3.y) / 2) < a3 ? a3 : i3) } : e3.socketId === k ? { x: i3 = (i3 = (n3.x - e3.x) / 2) < a3 ? a3 : i3, y: 0 } : e3.socketId === L ? { x: 0, y: i3 = (i3 = (n3.y - e3.y) / 2) < a3 ? a3 : i3 } : { x: -(i3 = (i3 = (e3.x - n3.x) / 2) < a3 ? a3 : i3), y: 0 });
            r2[t3] = e3.x + i3.x, s2[t3] = e3.y + i3.y;
          }), _2.push([E2(v2[0]), { x: r2[0], y: s2[0] }, { x: r2[1], y: s2[1] }, E2(v2[1])]);
          break;
        case B:
          !function() {
            var n3, i3 = 1, l3 = 2, r3 = 3, o3 = 4, s3 = [[], []], u3 = [];
            function h3(e3) {
              return e3 === i3 ? r3 : e3 === l3 ? o3 : e3 === r3 ? i3 : l3;
            }
            function p3(e3) {
              return e3 === l3 || e3 === o3 ? "x" : "y";
            }
            function c3(e3, t3, n4) {
              var a3 = { x: e3.x, y: e3.y };
              if (n4) {
                if (n4 === h3(e3.dirId))
                  throw new Error("Invalid dirId: " + n4);
                a3.dirId = n4;
              } else
                a3.dirId = e3.dirId;
              return a3.dirId === i3 ? a3.y -= t3 : a3.dirId === l3 ? a3.x += t3 : a3.dirId === r3 ? a3.y += t3 : a3.x -= t3, a3;
            }
            function d3(e3, t3) {
              return t3.dirId === i3 ? e3.y <= t3.y : t3.dirId === l3 ? e3.x >= t3.x : t3.dirId === r3 ? e3.y >= t3.y : e3.x <= t3.x;
            }
            function f3(e3, t3) {
              return t3.dirId === i3 || t3.dirId === r3 ? e3.x === t3.x : e3.y === t3.y;
            }
            function y3(e3) {
              return e3[0] ? { contain: 0, notContain: 1 } : { contain: 1, notContain: 0 };
            }
            function m3(e3, t3, n4) {
              return Math.abs(t3[n4] - e3[n4]);
            }
            function S3(e3, t3, n4) {
              return n4 === "x" ? e3.x < t3.x ? l3 : o3 : e3.y < t3.y ? r3 : i3;
            }
            for (v2.forEach(function(e3, t3) {
              var n4 = E2(e3), a3 = g2[t3];
              e3 = Array.isArray(a3) ? a3[0] < 0 ? [o3, -a3[0]] : 0 < a3[0] ? [l3, a3[0]] : a3[1] < 0 ? [i3, -a3[1]] : 0 < a3[1] ? [r3, a3[1]] : [e3.socketId, 0] : typeof a3 != "number" ? [e3.socketId, ee] : 0 <= a3 ? [e3.socketId, a3] : [h3(e3.socketId), -a3], n4.dirId = e3[0], a3 = e3[1], s3[t3].push(n4), u3[t3] = c3(n4, a3);
            }); function() {
              var e3, t3, a3, i4, n4 = [d3(u3[1], u3[0]), d3(u3[0], u3[1])], o4 = [p3(u3[0].dirId), p3(u3[1].dirId)];
              if (o4[0] === o4[1]) {
                if (n4[0] && n4[1])
                  return void (f3(u3[1], u3[0]) || (u3[0][o4[0]] === u3[1][o4[1]] ? (s3[0].push(u3[0]), s3[1].push(u3[1])) : (e3 = u3[0][o4[0]] + (u3[1][o4[1]] - u3[0][o4[0]]) / 2, s3[0].push(c3(u3[0], Math.abs(e3 - u3[0][o4[0]]))), s3[1].push(c3(u3[1], Math.abs(e3 - u3[1][o4[1]]))))));
                n4[0] !== n4[1] ? (t3 = y3(n4), (a3 = m3(u3[t3.notContain], u3[t3.contain], o4[t3.notContain])) < ee && (u3[t3.notContain] = c3(u3[t3.notContain], ee - a3)), s3[t3.notContain].push(u3[t3.notContain]), u3[t3.notContain] = c3(u3[t3.notContain], ee, f3(u3[t3.contain], u3[t3.notContain]) ? o4[t3.notContain] === "x" ? r3 : l3 : S3(u3[t3.notContain], u3[t3.contain], o4[t3.notContain] === "x" ? "y" : "x"))) : (a3 = m3(u3[0], u3[1], o4[0] === "x" ? "y" : "x"), s3.forEach(function(e4, t4) {
                  var n5 = t4 === 0 ? 1 : 0;
                  e4.push(u3[t4]), u3[t4] = c3(u3[t4], ee, 2 * ee <= a3 ? S3(u3[t4], u3[n5], o4[t4] === "x" ? "y" : "x") : o4[t4] === "x" ? r3 : l3);
                }));
              } else {
                if (n4[0] && n4[1])
                  return void (f3(u3[1], u3[0]) ? s3[1].push(u3[1]) : f3(u3[0], u3[1]) ? s3[0].push(u3[0]) : s3[0].push(o4[0] === "x" ? { x: u3[1].x, y: u3[0].y } : { x: u3[0].x, y: u3[1].y }));
                n4[0] !== n4[1] ? (t3 = y3(n4), s3[t3.notContain].push(u3[t3.notContain]), u3[t3.notContain] = c3(u3[t3.notContain], ee, m3(u3[t3.notContain], u3[t3.contain], o4[t3.contain]) >= ee ? S3(u3[t3.notContain], u3[t3.contain], o4[t3.contain]) : u3[t3.contain].dirId)) : (i4 = [{ x: u3[0].x, y: u3[0].y }, { x: u3[1].x, y: u3[1].y }], s3.forEach(function(e4, t4) {
                  var n5 = t4 === 0 ? 1 : 0, a4 = m3(i4[t4], i4[n5], o4[t4]);
                  a4 < ee && (u3[t4] = c3(u3[t4], ee - a4)), e4.push(u3[t4]), u3[t4] = c3(u3[t4], ee, S3(u3[t4], u3[n5], o4[n5]));
                }));
              }
              return 1;
            }(); )
              ;
            s3[1].reverse(), s3[0].concat(s3[1]).forEach(function(e3, t3) {
              e3 = { x: e3.x, y: e3.y };
              0 < t3 && _2.push([n3, e3]), n3 = e3;
            });
          }();
      }
      d2 = [], f2.position_plugOverheadSE.forEach(function(e3, t3) {
        var n3, a3, i3, o3, l3, r3, s3, u3, h3, p3 = !t3;
        0 < e3 ? (n3 = _2[a3 = p3 ? 0 : _2.length - 1]).length === 2 ? (d2[a3] = d2[a3] || Ae.apply(null, n3), d2[a3] > $ && (d2[a3] - e3 < $ && (e3 = d2[a3] - $), s3 = Ve(n3[0], n3[1], (p3 ? e3 : d2[a3] - e3) / d2[a3]), _2[a3] = p3 ? [s3, n3[1]] : [n3[0], s3], d2[a3] -= e3)) : (d2[a3] = d2[a3] || Te.apply(null, n3), d2[a3] > $ && (d2[a3] - e3 < $ && (e3 = d2[a3] - $), s3 = Ne(n3[0], n3[1], n3[2], n3[3], We(n3[0], n3[1], n3[2], n3[3], p3 ? e3 : d2[a3] - e3)), o3 = p3 ? (i3 = n3[0], s3.toP1) : (i3 = n3[3], s3.fromP2), l3 = Math.atan2(i3.y - s3.y, s3.x - i3.x), r3 = Ae(s3, o3), s3.x = i3.x + Math.cos(l3) * e3, s3.y = i3.y + Math.sin(l3) * e3 * -1, o3.x = s3.x + Math.cos(l3) * r3, o3.y = s3.y + Math.sin(l3) * r3 * -1, _2[a3] = p3 ? [s3, s3.toP1, s3.toP2, n3[3]] : [n3[0], s3.fromP1, s3.fromP2, s3], d2[a3] = null)) : e3 < 0 && (n3 = _2[a3 = p3 ? 0 : _2.length - 1], s3 = v2[t3].socketId, t3 = -c2[t3][(u3 = s3 === A || s3 === k ? "x" : "y") == "x" ? "width" : "height"], h3 = (e3 = e3 < t3 ? t3 : e3) * (s3 === A || s3 === b ? -1 : 1), n3.length === 2 ? n3[p3 ? 0 : n3.length - 1][u3] += h3 : (p3 ? [0, 1] : [n3.length - 2, n3.length - 1]).forEach(function(e4) {
          n3[e4][u3] += h3;
        }), d2[a3] = null);
      }), y2.position_socketXYSE = we(v2), y2.position_plugOverheadSE = we(f2.position_plugOverheadSE), y2.position_path = f2.position_path, y2.position_lineStrokeWidth = f2.position_lineStrokeWidth, y2.position_socketGravitySE = we(g2), m2 = true, l2.events.apl_position && l2.events.apl_position.forEach(function(e3) {
        e3(l2, _2);
      });
    }
    return m2;
  }
  function Je(t2, n2) {
    n2 !== t2.isShown && (!!n2 != !!t2.isShown && (t2.svg.style.visibility = n2 ? "" : "hidden"), t2.isShown = n2, t2.events && t2.events.svgShow && t2.events.svgShow.forEach(function(e2) {
      e2(t2, n2);
    }));
  }
  function $e(e2, t2) {
    var n2, a2, h2, p2, c2, d2, f2, i2, o2, l2, r2, s2, u2, y2, m2, S2, g2, _2, v2, E2, x2, b2, k2, w2, O2, M2, I2, C2, L2, A2, V2, P2, N2, T2, W2, B2, R2, F2, G2, D2, z2, j2, H2, U2 = {};
    t2.line && (U2.line = (i2 = (n2 = e2).options, a2 = n2.curStats, o2 = n2.events, l2 = false, l2 = Xe(n2, a2, "line_color", i2.lineColor, o2.cur_line_color) || l2, l2 = Xe(n2, a2, "line_colorTra", Oe(a2.line_color)[0] < 1) || l2, l2 = Xe(n2, a2, "line_strokeWidth", i2.lineSize, o2.cur_line_strokeWidth) || l2)), (t2.plug || U2.line) && (U2.plug = (p2 = (h2 = e2).options, c2 = h2.curStats, d2 = h2.events, f2 = false, [0, 1].forEach(function(e3) {
      var t3, n3, a3, i3, o3, l3, r3, s3, u3 = p2.plugSE[e3];
      f2 = Xe(h2, c2.plug_enabledSE, e3, u3 !== Y) || f2, f2 = Xe(h2, c2.plug_plugSE, e3, u3) || f2, f2 = Xe(h2, c2.plug_colorSE, e3, s3 = p2.plugColorSE[e3] || c2.line_color, d2.cur_plug_colorSE) || f2, f2 = Xe(h2, c2.plug_colorTraSE, e3, Oe(s3)[0] < 1) || f2, u3 !== Y && (i3 = n3 = (t3 = X[q[u3]]).widthR * p2.plugSizeSE[e3], o3 = a3 = t3.heightR * p2.plugSizeSE[e3], re && (i3 *= c2.line_strokeWidth, o3 *= c2.line_strokeWidth), f2 = Xe(h2, c2.plug_markerWidthSE, e3, i3) || f2, f2 = Xe(h2, c2.plug_markerHeightSE, e3, o3) || f2, c2.capsMaskMarker_markerWidthSE[e3] = n3, c2.capsMaskMarker_markerHeightSE[e3] = a3), c2.plugOutline_plugSE[e3] = c2.capsMaskMarker_plugSE[e3] = u3, c2.plug_enabledSE[e3] ? (s3 = c2.line_strokeWidth / ue.lineSize * p2.plugSizeSE[e3], c2.position_plugOverheadSE[e3] = t3.overhead * s3, c2.viewBox_plugBCircleSE[e3] = t3.bCircle * s3, l3 = t3.sideLen * s3, r3 = t3.backLen * s3) : (c2.position_plugOverheadSE[e3] = -c2.line_strokeWidth / 2, c2.viewBox_plugBCircleSE[e3] = l3 = r3 = 0), Xe(h2, c2.attach_plugSideLenSE, e3, l3, d2.cur_attach_plugSideLenSE), Xe(h2, c2.attach_plugBackLenSE, e3, r3, d2.cur_attach_plugBackLenSE), c2.capsMaskAnchor_enabledSE[e3] = !c2.plug_enabledSE[e3];
    }), f2 = Xe(h2, c2, "plug_enabled", c2.plug_enabledSE[0] || c2.plug_enabledSE[1]) || f2)), (t2.lineOutline || U2.line) && (U2.lineOutline = (o2 = (i2 = e2).options, l2 = i2.curStats, k2 = false, k2 = Xe(i2, l2, "lineOutline_enabled", o2.lineOutlineEnabled) || k2, k2 = Xe(i2, l2, "lineOutline_color", o2.lineOutlineColor) || k2, k2 = Xe(i2, l2, "lineOutline_colorTra", Oe(l2.lineOutline_color)[0] < 1) || k2, o2 = l2.line_strokeWidth * o2.lineOutlineSize, k2 = Xe(i2, l2, "lineOutline_strokeWidth", l2.line_strokeWidth - 2 * o2) || k2, k2 = Xe(i2, l2, "lineOutline_inStrokeWidth", l2.lineOutline_colorTra ? l2.lineOutline_strokeWidth + 2 * se : l2.line_strokeWidth - o2) || k2)), (t2.plugOutline || U2.line || U2.plug || U2.lineOutline) && (U2.plugOutline = (s2 = (r2 = e2).options, u2 = r2.curStats, y2 = false, [0, 1].forEach(function(e3) {
      var t3 = u2.plugOutline_plugSE[e3], n3 = t3 !== Y ? X[q[t3]] : null;
      y2 = Xe(r2, u2.plugOutline_enabledSE, e3, s2.plugOutlineEnabledSE[e3] && u2.plug_enabled && u2.plug_enabledSE[e3] && !!n3 && !!n3.outlineBase) || y2, y2 = Xe(r2, u2.plugOutline_colorSE, e3, t3 = s2.plugOutlineColorSE[e3] || u2.lineOutline_color) || y2, y2 = Xe(r2, u2.plugOutline_colorTraSE, e3, Oe(t3)[0] < 1) || y2, n3 && n3.outlineBase && ((t3 = s2.plugOutlineSizeSE[e3]) > n3.outlineMax && (t3 = n3.outlineMax), t3 *= 2 * n3.outlineBase, y2 = Xe(r2, u2.plugOutline_strokeWidthSE, e3, t3) || y2, y2 = Xe(r2, u2.plugOutline_inStrokeWidthSE, e3, u2.plugOutline_colorTraSE[e3] ? t3 - se / (u2.line_strokeWidth / ue.lineSize) / s2.plugSizeSE[e3] * 2 : t3 / 2) || y2);
    }), y2)), (t2.faces || U2.line || U2.plug || U2.lineOutline || U2.plugOutline) && (U2.faces = (g2 = (m2 = e2).curStats, _2 = m2.aplStats, v2 = m2.events, E2 = false, !g2.line_altColor && Xe(m2, _2, "line_color", S2 = g2.line_color, v2.apl_line_color) && (m2.lineFace.style.stroke = S2, E2 = true), Xe(m2, _2, "line_strokeWidth", S2 = g2.line_strokeWidth, v2.apl_line_strokeWidth) && (m2.lineShape.style.strokeWidth = S2 + "px", E2 = true, (oe || ie) && (je(m2, m2.lineShape), ie && (je(m2, m2.lineFace), je(m2, m2.lineMaskCaps)))), Xe(m2, _2, "lineOutline_enabled", S2 = g2.lineOutline_enabled, v2.apl_lineOutline_enabled) && (m2.lineOutlineFace.style.display = S2 ? "inline" : "none", E2 = true), g2.lineOutline_enabled && (Xe(m2, _2, "lineOutline_color", S2 = g2.lineOutline_color, v2.apl_lineOutline_color) && (m2.lineOutlineFace.style.stroke = S2, E2 = true), Xe(m2, _2, "lineOutline_strokeWidth", S2 = g2.lineOutline_strokeWidth, v2.apl_lineOutline_strokeWidth) && (m2.lineOutlineMaskShape.style.strokeWidth = S2 + "px", E2 = true, ie && (je(m2, m2.lineOutlineMaskCaps), je(m2, m2.lineOutlineFace))), Xe(m2, _2, "lineOutline_inStrokeWidth", S2 = g2.lineOutline_inStrokeWidth, v2.apl_lineOutline_inStrokeWidth) && (m2.lineMaskShape.style.strokeWidth = S2 + "px", E2 = true, ie && (je(m2, m2.lineOutlineMaskCaps), je(m2, m2.lineOutlineFace)))), Xe(m2, _2, "plug_enabled", S2 = g2.plug_enabled, v2.apl_plug_enabled) && (m2.plugsFace.style.display = S2 ? "inline" : "none", E2 = true), g2.plug_enabled && [0, 1].forEach(function(n3) {
      var e3 = g2.plug_plugSE[n3], t3 = e3 !== Y ? X[q[e3]] : null, a3 = Ze(n3, t3);
      Xe(m2, _2.plug_enabledSE, n3, S2 = g2.plug_enabledSE[n3], v2.apl_plug_enabledSE) && (m2.plugsFace.style[a3.prop] = S2 ? "url(#" + m2.plugMarkerIdSE[n3] + ")" : "none", E2 = true), g2.plug_enabledSE[n3] && (Xe(m2, _2.plug_plugSE, n3, e3, v2.apl_plug_plugSE) && (m2.plugFaceSE[n3].href.baseVal = "#" + t3.elmId, Ue(m2, m2.plugMarkerSE[n3], a3.orient, t3.bBox, m2.svg, m2.plugMarkerShapeSE[n3], m2.plugsFace), E2 = true, oe && je(m2, m2.plugsFace)), Xe(m2, _2.plug_colorSE, n3, S2 = g2.plug_colorSE[n3], v2.apl_plug_colorSE) && (m2.plugFaceSE[n3].style.fill = S2, E2 = true, (le || re || ie) && !g2.line_colorTra && je(m2, ie ? m2.lineMaskCaps : m2.capsMaskLine)), ["markerWidth", "markerHeight"].forEach(function(e4) {
        var t4 = "plug_" + e4 + "SE";
        Xe(m2, _2[t4], n3, S2 = g2[t4][n3], v2["apl_" + t4]) && (m2.plugMarkerSE[n3][e4].baseVal.value = S2, E2 = true);
      }), Xe(m2, _2.plugOutline_enabledSE, n3, S2 = g2.plugOutline_enabledSE[n3], v2.apl_plugOutline_enabledSE) && (S2 ? (m2.plugFaceSE[n3].style.mask = "url(#" + m2.plugMaskIdSE[n3] + ")", m2.plugOutlineFaceSE[n3].style.display = "inline") : (m2.plugFaceSE[n3].style.mask = "none", m2.plugOutlineFaceSE[n3].style.display = "none"), E2 = true), g2.plugOutline_enabledSE[n3] && (Xe(m2, _2.plugOutline_plugSE, n3, e3, v2.apl_plugOutline_plugSE) && (m2.plugOutlineFaceSE[n3].href.baseVal = m2.plugMaskShapeSE[n3].href.baseVal = m2.plugOutlineMaskShapeSE[n3].href.baseVal = "#" + t3.elmId, [m2.plugMaskSE[n3], m2.plugOutlineMaskSE[n3]].forEach(function(e4) {
        e4.x.baseVal.value = t3.bBox.left, e4.y.baseVal.value = t3.bBox.top, e4.width.baseVal.value = t3.bBox.width, e4.height.baseVal.value = t3.bBox.height;
      }), E2 = true), Xe(m2, _2.plugOutline_colorSE, n3, S2 = g2.plugOutline_colorSE[n3], v2.apl_plugOutline_colorSE) && (m2.plugOutlineFaceSE[n3].style.fill = S2, E2 = true, ie && (je(m2, m2.lineMaskCaps), je(m2, m2.lineOutlineMaskCaps))), Xe(m2, _2.plugOutline_strokeWidthSE, n3, S2 = g2.plugOutline_strokeWidthSE[n3], v2.apl_plugOutline_strokeWidthSE) && (m2.plugOutlineMaskShapeSE[n3].style.strokeWidth = S2 + "px", E2 = true), Xe(m2, _2.plugOutline_inStrokeWidthSE, n3, S2 = g2.plugOutline_inStrokeWidthSE[n3], v2.apl_plugOutline_inStrokeWidthSE) && (m2.plugMaskShapeSE[n3].style.strokeWidth = S2 + "px", E2 = true)));
    }), E2)), (t2.position || U2.line || U2.plug) && (U2.position = Ke(e2)), (t2.path || U2.position) && (U2.path = (k2 = (x2 = e2).curStats, I2 = x2.aplStats, M2 = x2.pathList.animVal || x2.pathList.baseVal, w2 = k2.path_edge, C2 = false, M2 && (w2.x1 = w2.x2 = M2[0][0].x, w2.y1 = w2.y2 = M2[0][0].y, k2.path_pathData = b2 = Be(M2, function(e3) {
      e3.x < w2.x1 && (w2.x1 = e3.x), e3.y < w2.y1 && (w2.y1 = e3.y), e3.x > w2.x2 && (w2.x2 = e3.x), e3.y > w2.y2 && (w2.y2 = e3.y);
    }), Fe(b2, I2.path_pathData) && (x2.linePath.setPathData(b2), I2.path_pathData = b2, C2 = true, ie ? (je(x2, x2.plugsFace), je(x2, x2.lineMaskCaps)) : oe && je(x2, x2.linePath), x2.events.apl_path && x2.events.apl_path.forEach(function(e3) {
      e3(x2, b2);
    }))), C2)), U2.viewBox = (M2 = (O2 = e2).curStats, I2 = O2.aplStats, C2 = M2.path_edge, L2 = M2.viewBox_bBox, A2 = I2.viewBox_bBox, V2 = O2.svg.viewBox.baseVal, P2 = O2.svg.style, N2 = false, I2 = Math.max(M2.line_strokeWidth / 2, M2.viewBox_plugBCircleSE[0] || 0, M2.viewBox_plugBCircleSE[1] || 0), T2 = { x1: C2.x1 - I2, y1: C2.y1 - I2, x2: C2.x2 + I2, y2: C2.y2 + I2 }, O2.events.new_edge4viewBox && O2.events.new_edge4viewBox.forEach(function(e3) {
      e3(O2, T2);
    }), L2.x = M2.lineMask_x = M2.lineOutlineMask_x = M2.maskBGRect_x = T2.x1, L2.y = M2.lineMask_y = M2.lineOutlineMask_y = M2.maskBGRect_y = T2.y1, L2.width = T2.x2 - T2.x1, L2.height = T2.y2 - T2.y1, ["x", "y", "width", "height"].forEach(function(e3) {
      var t3;
      (t3 = L2[e3]) !== A2[e3] && (V2[e3] = A2[e3] = t3, P2[Q[e3]] = t3 + (e3 === "x" || e3 === "y" ? O2.bodyOffset[e3] : 0) + "px", N2 = true);
    }), N2), U2.mask = (R2 = (W2 = e2).curStats, F2 = W2.aplStats, G2 = false, R2.plug_enabled ? [0, 1].forEach(function(e3) {
      R2.capsMaskMarker_enabledSE[e3] = R2.plug_enabledSE[e3] && R2.plug_colorTraSE[e3] || R2.plugOutline_enabledSE[e3] && R2.plugOutline_colorTraSE[e3];
    }) : R2.capsMaskMarker_enabledSE[0] = R2.capsMaskMarker_enabledSE[1] = false, R2.capsMaskMarker_enabled = R2.capsMaskMarker_enabledSE[0] || R2.capsMaskMarker_enabledSE[1], R2.lineMask_outlineMode = R2.lineOutline_enabled, R2.caps_enabled = R2.capsMaskMarker_enabled || R2.capsMaskAnchor_enabledSE[0] || R2.capsMaskAnchor_enabledSE[1], R2.lineMask_enabled = R2.caps_enabled || R2.lineMask_outlineMode, (R2.lineMask_enabled && !R2.lineMask_outlineMode || R2.lineOutline_enabled) && ["x", "y"].forEach(function(e3) {
      var t3 = "maskBGRect_" + e3;
      Xe(W2, F2, t3, B2 = R2[t3]) && (W2.maskBGRect[e3].baseVal.value = B2, G2 = true);
    }), Xe(W2, F2, "lineMask_enabled", B2 = R2.lineMask_enabled) && (W2.lineFace.style.mask = B2 ? "url(#" + W2.lineMaskId + ")" : "none", G2 = true, re && je(W2, W2.lineMask)), R2.lineMask_enabled && (Xe(W2, F2, "lineMask_outlineMode", B2 = R2.lineMask_outlineMode) && (B2 ? (W2.lineMaskBG.style.display = "none", W2.lineMaskShape.style.display = "inline") : (W2.lineMaskBG.style.display = "inline", W2.lineMaskShape.style.display = "none"), G2 = true), ["x", "y"].forEach(function(e3) {
      var t3 = "lineMask_" + e3;
      Xe(W2, F2, t3, B2 = R2[t3]) && (W2.lineMask[e3].baseVal.value = B2, G2 = true);
    }), Xe(W2, F2, "caps_enabled", B2 = R2.caps_enabled) && (W2.lineMaskCaps.style.display = W2.lineOutlineMaskCaps.style.display = B2 ? "inline" : "none", G2 = true, re && je(W2, W2.capsMaskLine)), R2.caps_enabled && ([0, 1].forEach(function(e3) {
      var t3;
      Xe(W2, F2.capsMaskAnchor_enabledSE, e3, B2 = R2.capsMaskAnchor_enabledSE[e3]) && (W2.capsMaskAnchorSE[e3].style.display = B2 ? "inline" : "none", G2 = true, re && je(W2, W2.lineMask)), R2.capsMaskAnchor_enabledSE[e3] && (Fe(t3 = R2.capsMaskAnchor_pathDataSE[e3], F2.capsMaskAnchor_pathDataSE[e3]) && (W2.capsMaskAnchorSE[e3].setPathData(t3), F2.capsMaskAnchor_pathDataSE[e3] = t3, G2 = true), Xe(W2, F2.capsMaskAnchor_strokeWidthSE, e3, B2 = R2.capsMaskAnchor_strokeWidthSE[e3]) && (W2.capsMaskAnchorSE[e3].style.strokeWidth = B2 + "px", G2 = true));
    }), Xe(W2, F2, "capsMaskMarker_enabled", B2 = R2.capsMaskMarker_enabled) && (W2.capsMaskLine.style.display = B2 ? "inline" : "none", G2 = true), R2.capsMaskMarker_enabled && [0, 1].forEach(function(n3) {
      var e3 = R2.capsMaskMarker_plugSE[n3], t3 = e3 !== Y ? X[q[e3]] : null, a3 = Ze(n3, t3);
      Xe(W2, F2.capsMaskMarker_enabledSE, n3, B2 = R2.capsMaskMarker_enabledSE[n3]) && (W2.capsMaskLine.style[a3.prop] = B2 ? "url(#" + W2.lineMaskMarkerIdSE[n3] + ")" : "none", G2 = true), R2.capsMaskMarker_enabledSE[n3] && (Xe(W2, F2.capsMaskMarker_plugSE, n3, e3) && (W2.capsMaskMarkerShapeSE[n3].href.baseVal = "#" + t3.elmId, Ue(W2, W2.capsMaskMarkerSE[n3], a3.orient, t3.bBox, W2.svg, W2.capsMaskMarkerShapeSE[n3], W2.capsMaskLine), G2 = true, oe && (je(W2, W2.capsMaskLine), je(W2, W2.lineFace))), ["markerWidth", "markerHeight"].forEach(function(e4) {
        var t4 = "capsMaskMarker_" + e4 + "SE";
        Xe(W2, F2[t4], n3, B2 = R2[t4][n3]) && (W2.capsMaskMarkerSE[n3][e4].baseVal.value = B2, G2 = true);
      }));
    }))), R2.lineOutline_enabled && ["x", "y"].forEach(function(e3) {
      var t3 = "lineOutlineMask_" + e3;
      Xe(W2, F2, t3, B2 = R2[t3]) && (W2.lineOutlineMask[e3].baseVal.value = B2, G2 = true);
    }), G2), t2.effect && (j2 = (D2 = e2).curStats, H2 = D2.aplStats, Object.keys(Z).forEach(function(e3) {
      var t3 = Z[e3], n3 = e3 + "_enabled", a3 = e3 + "_options", e3 = j2[a3];
      Xe(D2, H2, n3, z2 = j2[n3]) ? (z2 && (H2[a3] = we(e3)), t3[z2 ? "init" : "remove"](D2)) : z2 && ke(e3, H2[a3]) && (t3.remove(D2), H2[n3] = true, H2[a3] = we(e3), t3.init(D2));
    })), (le || re) && U2.line && !U2.path && je(e2, e2.lineShape), le && U2.plug && !U2.line && je(e2, e2.plugsFace), He(e2);
  }
  function et(e2, t2) {
    return { duration: (pe(e2.duration) && 0 < e2.duration ? e2 : t2).duration, timing: g.validTiming(e2.timing) ? e2.timing : we(t2.timing) };
  }
  function tt(e2, t2, n2, a2) {
    var i2 = e2.curStats, o2 = e2.aplStats, l2 = {};
    function r2() {
      ["show_on", "show_effect", "show_animOptions"].forEach(function(e3) {
        o2[e3] = i2[e3];
      });
    }
    i2.show_on = t2, n2 && w[n2] && (i2.show_effect = n2, i2.show_animOptions = et(he(a2) ? a2 : {}, w[n2].defaultAnimOptions)), l2.show_on = i2.show_on !== o2.show_on, l2.show_effect = i2.show_effect !== o2.show_effect, l2.show_animOptions = ke(i2.show_animOptions, o2.show_animOptions), l2.show_effect || l2.show_animOptions ? i2.show_inAnim ? (n2 = l2.show_effect ? w[o2.show_effect].stop(e2, true, true) : w[o2.show_effect].stop(e2), r2(), w[o2.show_effect].init(e2, n2)) : l2.show_on && (o2.show_effect && l2.show_effect && w[o2.show_effect].stop(e2, true, true), r2(), w[o2.show_effect].init(e2)) : l2.show_on && (r2(), w[o2.show_effect].start(e2));
  }
  function nt(e2, t2, n2) {
    n2 = { props: e2, optionName: n2 };
    return e2.attachments.indexOf(t2) < 0 && (!t2.conf.bind || t2.conf.bind(t2, n2)) && (e2.attachments.push(t2), t2.boundTargets.push(n2), 1);
  }
  function at(n2, a2, e2) {
    var i2 = n2.attachments.indexOf(a2);
    -1 < i2 && n2.attachments.splice(i2, 1), a2.boundTargets.some(function(e3, t2) {
      return e3.props === n2 && (a2.conf.unbind && a2.conf.unbind(a2, e3), i2 = t2, true);
    }) && (a2.boundTargets.splice(i2, 1), e2 || ze(function() {
      a2.boundTargets.length || o(a2);
    }));
  }
  function it(s2, u2) {
    var i2, n2, e2, t2, a2, o2, l2, r2, h2, p2, c2, d2, f2, y2, m2, S2 = s2.options, g2 = {};
    function _2(e3, t3, n3, a3, i3) {
      var o3 = {};
      return n3 ? a3 != null ? (o3.container = e3[n3], o3.key = a3) : (o3.container = e3, o3.key = n3) : (o3.container = e3, o3.key = t3), o3.default = i3, o3.acceptsAuto = o3.default == null, o3;
    }
    function v2(e3, t3, n3, a3, i3, o3, l3) {
      var r3, s3, u3, l3 = _2(e3, n3, i3, o3, l3);
      return t3[n3] != null && (s3 = (t3[n3] + "").toLowerCase()) && (l3.acceptsAuto && s3 === D || (u3 = a3[s3])) && u3 !== l3.container[l3.key] && (l3.container[l3.key] = u3, r3 = true), l3.container[l3.key] != null || l3.acceptsAuto || (l3.container[l3.key] = l3.default, r3 = true), r3;
    }
    function E2(e3, t3, n3, a3, i3, o3, l3, r3, s3) {
      var u3, h3, p3, c3, l3 = _2(e3, n3, i3, o3, l3);
      if (!a3) {
        if (l3.default == null)
          throw new Error("Invalid `type`: " + n3);
        a3 = typeof l3.default;
      }
      return t3[n3] != null && (l3.acceptsAuto && (t3[n3] + "").toLowerCase() === D || (p3 = h3 = t3[n3], ((c3 = a3) === "number" ? pe(p3) : typeof p3 === c3) && (h3 = s3 && a3 === "string" && h3 ? h3.trim() : h3, 1) && (!r3 || r3(h3)))) && h3 !== l3.container[l3.key] && (l3.container[l3.key] = h3, u3 = true), l3.container[l3.key] != null || l3.acceptsAuto || (l3.container[l3.key] = l3.default, u3 = true), u3;
    }
    if (u2 = u2 || {}, ["start", "end"].forEach(function(e3, t3) {
      var n3 = u2[e3], a3 = false;
      if (n3 && (Me(n3) || (a3 = I(n3, "anchor"))) && n3 !== S2.anchorSE[t3]) {
        if (s2.optionIsAttach.anchorSE[t3] !== false && at(s2, _e[S2.anchorSE[t3]._id]), a3 && !nt(s2, _e[n3._id], e3))
          throw new Error("Can't bind attachment");
        S2.anchorSE[t3] = n3, s2.optionIsAttach.anchorSE[t3] = a3, i2 = g2.position = true;
      }
    }), !S2.anchorSE[0] || !S2.anchorSE[1] || S2.anchorSE[0] === S2.anchorSE[1])
      throw new Error("`start` and `end` are required.");
    function x2(e3) {
      var t3 = a2.appendChild(y2.createElementNS(ae, "mask"));
      return t3.id = e3, t3.maskUnits.baseVal = SVGUnitTypes.SVG_UNIT_TYPE_USERSPACEONUSE, [t3.x, t3.y, t3.width, t3.height].forEach(function(e4) {
        e4.baseVal.newValueSpecifiedUnits(SVGLength.SVG_LENGTHTYPE_PX, 0);
      }), t3;
    }
    function b2(e3) {
      var t3 = a2.appendChild(y2.createElementNS(ae, "marker"));
      return t3.id = e3, t3.markerUnits.baseVal = SVGMarkerElement.SVG_MARKERUNITS_STROKEWIDTH, t3.viewBox.baseVal || t3.setAttribute("viewBox", "0 0 0 0"), t3;
    }
    function k2(e3) {
      return [e3.width, e3.height].forEach(function(e4) {
        e4.baseVal.newValueSpecifiedUnits(SVGLength.SVG_LENGTHTYPE_PERCENTAGE, 100);
      }), e3;
    }
    i2 && (c2 = function(e3, t3) {
      var n3, a3;
      if (!(e3 = Ce(e3)) || !(n3 = Ce(t3)))
        throw new Error("Cannot get frames.");
      return e3.length && n3.length && (e3.reverse(), n3.reverse(), e3.some(function(t4) {
        return n3.some(function(e4) {
          return e4 === t4 && (a3 = e4.contentWindow, true);
        });
      })), a3 || window;
    }(s2.optionIsAttach.anchorSE[0] !== false ? _e[S2.anchorSE[0]._id].element : S2.anchorSE[0], s2.optionIsAttach.anchorSE[1] !== false ? _e[S2.anchorSE[1]._id].element : S2.anchorSE[1])) !== s2.baseWindow && (e2 = c2, f2 = (n2 = s2).aplStats, y2 = e2.document, m2 = C + "-" + n2._id, n2.pathList = {}, Ye(f2, de), Object.keys(Z).forEach(function(e3) {
      var t3 = e3 + "_enabled";
      f2[t3] && (Z[e3].remove(n2), f2[t3] = false);
    }), n2.baseWindow && n2.svg && n2.baseWindow.document.body.removeChild(n2.svg), Qe(n2.baseWindow = e2), n2.bodyOffset = qe(e2), n2.svg = t2 = y2.createElementNS(ae, "svg"), t2.className.baseVal = C, t2.viewBox.baseVal || t2.setAttribute("viewBox", "0 0 0 0"), n2.defs = a2 = t2.appendChild(y2.createElementNS(ae, "defs")), n2.linePath = l2 = a2.appendChild(y2.createElementNS(ae, "path")), l2.id = r2 = m2 + "-line-path", l2.className.baseVal = C + "-line-path", re && (l2.style.fill = "none"), n2.lineShape = l2 = a2.appendChild(y2.createElementNS(ae, "use")), l2.id = h2 = m2 + "-line-shape", l2.href.baseVal = "#" + r2, (o2 = a2.appendChild(y2.createElementNS(ae, "g"))).id = p2 = m2 + "-caps", n2.capsMaskAnchorSE = [0, 1].map(function() {
      var e3 = o2.appendChild(y2.createElementNS(ae, "path"));
      return e3.className.baseVal = C + "-caps-mask-anchor", e3;
    }), n2.lineMaskMarkerIdSE = [m2 + "-caps-mask-marker-0", m2 + "-caps-mask-marker-1"], n2.capsMaskMarkerSE = [0, 1].map(function(e3) {
      return b2(n2.lineMaskMarkerIdSE[e3]);
    }), n2.capsMaskMarkerShapeSE = [0, 1].map(function(e3) {
      e3 = n2.capsMaskMarkerSE[e3].appendChild(y2.createElementNS(ae, "use"));
      return e3.className.baseVal = C + "-caps-mask-marker-shape", e3;
    }), n2.capsMaskLine = l2 = o2.appendChild(y2.createElementNS(ae, "use")), l2.className.baseVal = C + "-caps-mask-line", l2.href.baseVal = "#" + h2, n2.maskBGRect = l2 = k2(a2.appendChild(y2.createElementNS(ae, "rect"))), l2.id = c2 = m2 + "-mask-bg-rect", l2.className.baseVal = C + "-mask-bg-rect", re && (l2.style.fill = "white"), n2.lineMask = k2(x2(n2.lineMaskId = m2 + "-line-mask")), n2.lineMaskBG = l2 = n2.lineMask.appendChild(y2.createElementNS(ae, "use")), l2.href.baseVal = "#" + c2, n2.lineMaskShape = l2 = n2.lineMask.appendChild(y2.createElementNS(ae, "use")), l2.className.baseVal = C + "-line-mask-shape", l2.href.baseVal = "#" + r2, l2.style.display = "none", n2.lineMaskCaps = l2 = n2.lineMask.appendChild(y2.createElementNS(ae, "use")), l2.href.baseVal = "#" + p2, n2.lineOutlineMask = k2(x2(e2 = m2 + "-line-outline-mask")), (l2 = n2.lineOutlineMask.appendChild(y2.createElementNS(ae, "use"))).href.baseVal = "#" + c2, n2.lineOutlineMaskShape = l2 = n2.lineOutlineMask.appendChild(y2.createElementNS(ae, "use")), l2.className.baseVal = C + "-line-outline-mask-shape", l2.href.baseVal = "#" + r2, n2.lineOutlineMaskCaps = l2 = n2.lineOutlineMask.appendChild(y2.createElementNS(ae, "use")), l2.href.baseVal = "#" + p2, n2.face = t2.appendChild(y2.createElementNS(ae, "g")), n2.lineFace = l2 = n2.face.appendChild(y2.createElementNS(ae, "use")), l2.href.baseVal = "#" + h2, n2.lineOutlineFace = l2 = n2.face.appendChild(y2.createElementNS(ae, "use")), l2.href.baseVal = "#" + h2, l2.style.mask = "url(#" + e2 + ")", l2.style.display = "none", n2.plugMaskIdSE = [m2 + "-plug-mask-0", m2 + "-plug-mask-1"], n2.plugMaskSE = [0, 1].map(function(e3) {
      return x2(n2.plugMaskIdSE[e3]);
    }), n2.plugMaskShapeSE = [0, 1].map(function(e3) {
      e3 = n2.plugMaskSE[e3].appendChild(y2.createElementNS(ae, "use"));
      return e3.className.baseVal = C + "-plug-mask-shape", e3;
    }), d2 = [], n2.plugOutlineMaskSE = [0, 1].map(function(e3) {
      return x2(d2[e3] = m2 + "-plug-outline-mask-" + e3);
    }), n2.plugOutlineMaskShapeSE = [0, 1].map(function(e3) {
      e3 = n2.plugOutlineMaskSE[e3].appendChild(y2.createElementNS(ae, "use"));
      return e3.className.baseVal = C + "-plug-outline-mask-shape", e3;
    }), n2.plugMarkerIdSE = [m2 + "-plug-marker-0", m2 + "-plug-marker-1"], n2.plugMarkerSE = [0, 1].map(function(e3) {
      e3 = b2(n2.plugMarkerIdSE[e3]);
      return re && (e3.markerUnits.baseVal = SVGMarkerElement.SVG_MARKERUNITS_USERSPACEONUSE), e3;
    }), n2.plugMarkerShapeSE = [0, 1].map(function(e3) {
      return n2.plugMarkerSE[e3].appendChild(y2.createElementNS(ae, "g"));
    }), n2.plugFaceSE = [0, 1].map(function(e3) {
      return n2.plugMarkerShapeSE[e3].appendChild(y2.createElementNS(ae, "use"));
    }), n2.plugOutlineFaceSE = [0, 1].map(function(e3) {
      var t3 = n2.plugMarkerShapeSE[e3].appendChild(y2.createElementNS(ae, "use"));
      return t3.style.mask = "url(#" + d2[e3] + ")", t3.style.display = "none", t3;
    }), n2.plugsFace = l2 = n2.face.appendChild(y2.createElementNS(ae, "use")), l2.className.baseVal = C + "-plugs-face", l2.href.baseVal = "#" + h2, l2.style.display = "none", n2.curStats.show_inAnim ? (n2.isShown = 1, w[f2.show_effect].stop(n2, true)) : n2.isShown || (t2.style.visibility = "hidden"), y2.body.appendChild(t2), [0, 1, 2].forEach(function(e3) {
      var t3, e3 = n2.options.labelSEM[e3];
      e3 && I(e3, "label") && (t3 = _e[e3._id]).conf.initSvg && t3.conf.initSvg(t3, n2);
    }), g2.line = g2.plug = g2.lineOutline = g2.plugOutline = g2.faces = g2.effect = true), g2.position = v2(S2, u2, "path", R, null, null, ue.path) || g2.position, g2.position = v2(S2, u2, "startSocket", V, "socketSE", 0) || g2.position, g2.position = v2(S2, u2, "endSocket", V, "socketSE", 1) || g2.position, [u2.startSocketGravity, u2.endSocketGravity].forEach(function(e3, t3) {
      var n3, a3, i3 = false;
      e3 != null && (Array.isArray(e3) ? pe(e3[0]) && pe(e3[1]) && (i3 = [e3[0], e3[1]], Array.isArray(S2.socketGravitySE[t3]) && (n3 = i3, a3 = S2.socketGravitySE[t3], n3.length === a3.length && n3.every(function(e4, t4) {
        return e4 === a3[t4];
      })) && (i3 = false)) : ((e3 + "").toLowerCase() === D ? i3 = null : pe(e3) && 0 <= e3 && (i3 = e3), i3 === S2.socketGravitySE[t3] && (i3 = false)), i3 !== false && (S2.socketGravitySE[t3] = i3, g2.position = true));
    }), g2.line = E2(S2, u2, "color", null, "lineColor", null, ue.lineColor, null, true) || g2.line, g2.line = E2(S2, u2, "size", null, "lineSize", null, ue.lineSize, function(e3) {
      return 0 < e3;
    }) || g2.line, ["startPlug", "endPlug"].forEach(function(e3, t3) {
      g2.plug = v2(S2, u2, e3, F, "plugSE", t3, ue.plugSE[t3]) || g2.plug, g2.plug = E2(S2, u2, e3 + "Color", "string", "plugColorSE", t3, null, null, true) || g2.plug, g2.plug = E2(S2, u2, e3 + "Size", null, "plugSizeSE", t3, ue.plugSizeSE[t3], function(e4) {
        return 0 < e4;
      }) || g2.plug;
    }), g2.lineOutline = E2(S2, u2, "outline", null, "lineOutlineEnabled", null, ue.lineOutlineEnabled) || g2.lineOutline, g2.lineOutline = E2(S2, u2, "outlineColor", null, "lineOutlineColor", null, ue.lineOutlineColor, null, true) || g2.lineOutline, g2.lineOutline = E2(S2, u2, "outlineSize", null, "lineOutlineSize", null, ue.lineOutlineSize, function(e3) {
      return 0 < e3 && e3 <= 0.48;
    }) || g2.lineOutline, ["startPlugOutline", "endPlugOutline"].forEach(function(e3, t3) {
      g2.plugOutline = E2(S2, u2, e3, null, "plugOutlineEnabledSE", t3, ue.plugOutlineEnabledSE[t3]) || g2.plugOutline, g2.plugOutline = E2(S2, u2, e3 + "Color", "string", "plugOutlineColorSE", t3, null, null, true) || g2.plugOutline, g2.plugOutline = E2(S2, u2, e3 + "Size", null, "plugOutlineSizeSE", t3, ue.plugOutlineSizeSE[t3], function(e4) {
        return 1 <= e4;
      }) || g2.plugOutline;
    }), ["startLabel", "endLabel", "middleLabel"].forEach(function(e3, t3) {
      var n3, a3, i3, o3 = u2[e3], l3 = S2.labelSEM[t3] && !s2.optionIsAttach.labelSEM[t3] ? _e[S2.labelSEM[t3]._id].text : S2.labelSEM[t3], r3 = false;
      if ((n3 = typeof o3 == "string") && (o3 = o3.trim()), (n3 || o3 && (r3 = I(o3, "label"))) && o3 !== l3) {
        if (S2.labelSEM[t3] && (at(s2, _e[S2.labelSEM[t3]._id]), S2.labelSEM[t3] = ""), o3) {
          if (r3 ? (a3 = _e[(i3 = o3)._id]).boundTargets.slice().forEach(function(e4) {
            a3.conf.removeOption(a3, e4);
          }) : i3 = new M(O.captionLabel, [o3]), !nt(s2, _e[i3._id], e3))
            throw new Error("Can't bind attachment");
          S2.labelSEM[t3] = i3;
        }
        s2.optionIsAttach.labelSEM[t3] = r3;
      }
    }), Object.keys(Z).forEach(function(a3) {
      var e3, t3, o3 = Z[a3], n3 = a3 + "_enabled", i3 = a3 + "_options";
      function l3(a4) {
        var i4 = {};
        return o3.optionsConf.forEach(function(e4) {
          var t4 = e4[0], n4 = e4[3];
          e4[4] == null || i4[n4] || (i4[n4] = []), (typeof t4 == "function" ? t4 : t4 === "id" ? v2 : E2).apply(null, [i4, a4].concat(e4.slice(1)));
        }), i4;
      }
      function r3(e4) {
        var t4, n4 = a3 + "_animOptions";
        return e4.hasOwnProperty("animation") ? he(e4.animation) ? t4 = s2.curStats[n4] = et(e4.animation, o3.defaultAnimOptions) : (t4 = !!e4.animation, s2.curStats[n4] = t4 ? et({}, o3.defaultAnimOptions) : null) : (t4 = !!o3.defaultEnabled, s2.curStats[n4] = t4 ? et({}, o3.defaultAnimOptions) : null), t4;
      }
      u2.hasOwnProperty(a3) && (e3 = u2[a3], he(e3) ? (s2.curStats[n3] = true, t3 = s2.curStats[i3] = l3(e3), o3.anim && (s2.curStats[i3].animation = r3(e3))) : (t3 = s2.curStats[n3] = !!e3) && (s2.curStats[i3] = l3({}), o3.anim && (s2.curStats[i3].animation = r3({}))), ke(t3, S2[a3]) && (S2[a3] = t3, g2.effect = true));
    }), $e(s2, g2);
  }
  function ot(e2, t2, n2) {
    var a2 = { options: { anchorSE: [], socketSE: [], socketGravitySE: [], plugSE: [], plugColorSE: [], plugSizeSE: [], plugOutlineEnabledSE: [], plugOutlineColorSE: [], plugOutlineSizeSE: [], labelSEM: ["", "", ""] }, optionIsAttach: { anchorSE: [false, false], labelSEM: [false, false, false] }, curStats: {}, aplStats: {}, attachments: [], events: {}, reflowTargets: [] };
    Ye(a2.curStats, de), Ye(a2.aplStats, de), Object.keys(Z).forEach(function(e3) {
      var t3 = Z[e3].stats;
      Ye(a2.curStats, t3), Ye(a2.aplStats, t3), a2.options[e3] = false;
    }), Ye(a2.curStats, fe), Ye(a2.aplStats, fe), a2.curStats.show_effect = ye, a2.curStats.show_animOptions = we(w[ye].defaultAnimOptions), Object.defineProperty(this, "_id", { value: ++ge }), a2._id = this._id, Se[this._id] = a2, arguments.length === 1 && (n2 = e2, e2 = null), n2 = n2 || {}, (e2 || t2) && (n2 = we(n2), e2 && (n2.start = e2), t2 && (n2.end = t2)), a2.isShown = a2.aplStats.show_on = !n2.hide, this.setOptions(n2);
  }
  function lt(n2) {
    return function(e2) {
      var t2 = {};
      t2[n2] = e2, this.setOptions(t2);
    };
  }
  function rt(e2, t2) {
    var n2, a2 = { conf: e2, curStats: {}, aplStats: {}, boundTargets: [] }, i2 = {};
    e2.argOptions.every(function(e3) {
      return !(!t2.length || (typeof e3.type == "string" ? typeof t2[0] !== e3.type : typeof e3.type != "function" || !e3.type(t2[0]))) && (i2[e3.optionName] = t2.shift(), true);
    }), n2 = t2.length && he(t2[0]) ? we(t2[0]) : {}, Object.keys(i2).forEach(function(e3) {
      n2[e3] = i2[e3];
    }), e2.stats && (Ye(a2.curStats, e2.stats), Ye(a2.aplStats, e2.stats)), Object.defineProperty(this, "_id", { value: ++ve }), Object.defineProperty(this, "isRemoved", { get: function() {
      return !_e[this._id];
    } }), a2._id = this._id, e2.init && !e2.init(a2, n2) || (_e[this._id] = a2);
  }
  return Z = { dash: { stats: { dash_len: {}, dash_gap: {}, dash_maxOffset: {} }, anim: true, defaultAnimOptions: { duration: 1e3, timing: "linear" }, optionsConf: [["type", "len", "number", null, null, null, function(e2) {
    return 0 < e2;
  }], ["type", "gap", "number", null, null, null, function(e2) {
    return 0 < e2;
  }]], init: function(e2) {
    Ge(e2, "apl_line_strokeWidth", Z.dash.update), e2.lineFace.style.strokeDashoffset = 0, Z.dash.update(e2);
  }, remove: function(e2) {
    var t2 = e2.curStats;
    De(e2, "apl_line_strokeWidth", Z.dash.update), t2.dash_animId && (g.remove(t2.dash_animId), t2.dash_animId = null), e2.lineFace.style.strokeDasharray = "none", e2.lineFace.style.strokeDashoffset = 0, Ye(e2.aplStats, Z.dash.stats);
  }, update: function(t2) {
    var e2, n2 = t2.curStats, a2 = t2.aplStats, i2 = a2.dash_options, o2 = false;
    n2.dash_len = i2.len || 2 * a2.line_strokeWidth, n2.dash_gap = i2.gap || a2.line_strokeWidth, n2.dash_maxOffset = n2.dash_len + n2.dash_gap, o2 = Xe(t2, a2, "dash_len", n2.dash_len) || o2, (o2 = Xe(t2, a2, "dash_gap", n2.dash_gap) || o2) && (t2.lineFace.style.strokeDasharray = a2.dash_len + "," + a2.dash_gap), n2.dash_animOptions ? (o2 = Xe(t2, a2, "dash_maxOffset", n2.dash_maxOffset), a2.dash_animOptions && (o2 || ke(n2.dash_animOptions, a2.dash_animOptions)) && (n2.dash_animId && (e2 = g.stop(n2.dash_animId), g.remove(n2.dash_animId)), a2.dash_animOptions = null), a2.dash_animOptions || (n2.dash_animId = g.add(function(e3) {
      return (1 - e3) * a2.dash_maxOffset + "px";
    }, function(e3) {
      t2.lineFace.style.strokeDashoffset = e3;
    }, n2.dash_animOptions.duration, 0, n2.dash_animOptions.timing, false, e2), a2.dash_animOptions = we(n2.dash_animOptions))) : a2.dash_animOptions && (n2.dash_animId && (g.remove(n2.dash_animId), n2.dash_animId = null), t2.lineFace.style.strokeDashoffset = 0, a2.dash_animOptions = null);
  } }, gradient: { stats: { gradient_colorSE: { hasSE: true }, gradient_pointSE: { hasSE: true, hasProps: true } }, optionsConf: [["type", "startColor", "string", "colorSE", 0, null, null, true], ["type", "endColor", "string", "colorSE", 1, null, null, true]], init: function(e2) {
    var a2 = e2.baseWindow.document, t2 = e2.defs, n2 = C + "-" + e2._id + "-gradient";
    e2.efc_gradient_gradient = t2 = t2.appendChild(a2.createElementNS(ae, "linearGradient")), t2.id = n2, t2.gradientUnits.baseVal = SVGUnitTypes.SVG_UNIT_TYPE_USERSPACEONUSE, [t2.x1, t2.y1, t2.x2, t2.y2].forEach(function(e3) {
      e3.baseVal.newValueSpecifiedUnits(SVGLength.SVG_LENGTHTYPE_PX, 0);
    }), e2.efc_gradient_stopSE = [0, 1].map(function(t3) {
      var n3 = e2.efc_gradient_gradient.appendChild(a2.createElementNS(ae, "stop"));
      try {
        n3.offset.baseVal = t3;
      } catch (e3) {
        if (e3.code !== DOMException.NO_MODIFICATION_ALLOWED_ERR)
          throw e3;
        n3.setAttribute("offset", t3);
      }
      return n3;
    }), Ge(e2, "cur_plug_colorSE", Z.gradient.update), Ge(e2, "apl_path", Z.gradient.update), e2.curStats.line_altColor = true, e2.lineFace.style.stroke = "url(#" + n2 + ")", Z.gradient.update(e2);
  }, remove: function(e2) {
    e2.efc_gradient_gradient && (e2.defs.removeChild(e2.efc_gradient_gradient), e2.efc_gradient_gradient = e2.efc_gradient_stopSE = null), De(e2, "cur_plug_colorSE", Z.gradient.update), De(e2, "apl_path", Z.gradient.update), e2.curStats.line_altColor = false, e2.lineFace.style.stroke = e2.curStats.line_color, Ye(e2.aplStats, Z.gradient.stats);
  }, update: function(a2) {
    var e2, i2 = a2.curStats, o2 = a2.aplStats, t2 = o2.gradient_options, n2 = a2.pathList.animVal || a2.pathList.baseVal;
    [0, 1].forEach(function(e3) {
      i2.gradient_colorSE[e3] = t2.colorSE[e3] || i2.plug_colorSE[e3];
    }), e2 = n2[0][0], i2.gradient_pointSE[0] = { x: e2.x, y: e2.y }, e2 = (n2 = n2[n2.length - 1])[n2.length - 1], i2.gradient_pointSE[1] = { x: e2.x, y: e2.y }, [0, 1].forEach(function(t3) {
      var n3;
      Xe(a2, o2.gradient_colorSE, t3, n3 = i2.gradient_colorSE[t3]) && (re ? (n3 = Oe(n3), a2.efc_gradient_stopSE[t3].style.stopColor = n3[1], a2.efc_gradient_stopSE[t3].style.stopOpacity = n3[0]) : a2.efc_gradient_stopSE[t3].style.stopColor = n3), ["x", "y"].forEach(function(e3) {
        (n3 = i2.gradient_pointSE[t3][e3]) !== o2.gradient_pointSE[t3][e3] && (a2.efc_gradient_gradient[e3 + (t3 + 1)].baseVal.value = o2.gradient_pointSE[t3][e3] = n3);
      });
    });
  } }, dropShadow: { stats: { dropShadow_dx: {}, dropShadow_dy: {}, dropShadow_blur: {}, dropShadow_color: {}, dropShadow_opacity: {}, dropShadow_x: {}, dropShadow_y: {} }, optionsConf: [["type", "dx", null, null, null, 2], ["type", "dy", null, null, null, 4], ["type", "blur", null, null, null, 3, function(e2) {
    return 0 <= e2;
  }], ["type", "color", null, null, null, "#000", null, true], ["type", "opacity", null, null, null, 0.8, function(e2) {
    return 0 <= e2 && e2 <= 1;
  }]], init: function(t2) {
    var e2, n2, a2, i2, o2 = t2.baseWindow.document, l2 = t2.defs, r2 = C + "-" + t2._id + "-dropShadow", s2 = (e2 = o2, n2 = r2, i2 = {}, typeof u != "boolean" && (u = !!window.SVGFEDropShadowElement && !re), i2.elmsAppend = [i2.elmFilter = o2 = e2.createElementNS(ae, "filter")], o2.filterUnits.baseVal = SVGUnitTypes.SVG_UNIT_TYPE_USERSPACEONUSE, o2.x.baseVal.newValueSpecifiedUnits(SVGLength.SVG_LENGTHTYPE_PX, 0), o2.y.baseVal.newValueSpecifiedUnits(SVGLength.SVG_LENGTHTYPE_PX, 0), o2.width.baseVal.newValueSpecifiedUnits(SVGLength.SVG_LENGTHTYPE_PERCENTAGE, 100), o2.height.baseVal.newValueSpecifiedUnits(SVGLength.SVG_LENGTHTYPE_PERCENTAGE, 100), o2.id = n2, u ? (i2.elmOffset = i2.elmBlur = a2 = o2.appendChild(e2.createElementNS(ae, "feDropShadow")), i2.styleFlood = a2.style) : (i2.elmBlur = o2.appendChild(e2.createElementNS(ae, "feGaussianBlur")), i2.elmOffset = a2 = o2.appendChild(e2.createElementNS(ae, "feOffset")), a2.result.baseVal = "offsetblur", a2 = o2.appendChild(e2.createElementNS(ae, "feFlood")), i2.styleFlood = a2.style, (a2 = o2.appendChild(e2.createElementNS(ae, "feComposite"))).in2.baseVal = "offsetblur", a2.operator.baseVal = SVGFECompositeElement.SVG_FECOMPOSITE_OPERATOR_IN, (a2 = o2.appendChild(e2.createElementNS(ae, "feMerge"))).appendChild(e2.createElementNS(ae, "feMergeNode")), a2.appendChild(e2.createElementNS(ae, "feMergeNode")).in1.baseVal = "SourceGraphic"), i2);
    ["elmFilter", "elmOffset", "elmBlur", "styleFlood", "elmsAppend"].forEach(function(e3) {
      t2["efc_dropShadow_" + e3] = s2[e3];
    }), s2.elmsAppend.forEach(function(e3) {
      l2.appendChild(e3);
    }), t2.face.setAttribute("filter", "url(#" + r2 + ")"), Ge(t2, "new_edge4viewBox", Z.dropShadow.adjustEdge), Z.dropShadow.update(t2);
  }, remove: function(e2) {
    var t2 = e2.defs;
    e2.efc_dropShadow_elmsAppend && (e2.efc_dropShadow_elmsAppend.forEach(function(e3) {
      t2.removeChild(e3);
    }), e2.efc_dropShadow_elmFilter = e2.efc_dropShadow_elmOffset = e2.efc_dropShadow_elmBlur = e2.efc_dropShadow_styleFlood = e2.efc_dropShadow_elmsAppend = null), De(e2, "new_edge4viewBox", Z.dropShadow.adjustEdge), $e(e2, {}), e2.face.removeAttribute("filter"), Ye(e2.aplStats, Z.dropShadow.stats);
  }, update: function(e2) {
    var t2, n2, a2 = e2.curStats, i2 = e2.aplStats, o2 = i2.dropShadow_options;
    a2.dropShadow_dx = t2 = o2.dx, Xe(e2, i2, "dropShadow_dx", t2) && (e2.efc_dropShadow_elmOffset.dx.baseVal = t2, n2 = true), a2.dropShadow_dy = t2 = o2.dy, Xe(e2, i2, "dropShadow_dy", t2) && (e2.efc_dropShadow_elmOffset.dy.baseVal = t2, n2 = true), a2.dropShadow_blur = t2 = o2.blur, Xe(e2, i2, "dropShadow_blur", t2) && (e2.efc_dropShadow_elmBlur.setStdDeviation(t2, t2), n2 = true), n2 && $e(e2, {}), a2.dropShadow_color = t2 = o2.color, Xe(e2, i2, "dropShadow_color", t2) && (e2.efc_dropShadow_styleFlood.floodColor = t2), a2.dropShadow_opacity = t2 = o2.opacity, Xe(e2, i2, "dropShadow_opacity", t2) && (e2.efc_dropShadow_styleFlood.floodOpacity = t2);
  }, adjustEdge: function(a2, i2) {
    var e2, o2 = a2.curStats, l2 = a2.aplStats;
    o2.dropShadow_dx != null && (e2 = 3 * o2.dropShadow_blur, (e2 = { x1: i2.x1 - e2 + o2.dropShadow_dx, y1: i2.y1 - e2 + o2.dropShadow_dy, x2: i2.x2 + e2 + o2.dropShadow_dx, y2: i2.y2 + e2 + o2.dropShadow_dy }).x1 < i2.x1 && (i2.x1 = e2.x1), e2.y1 < i2.y1 && (i2.y1 = e2.y1), e2.x2 > i2.x2 && (i2.x2 = e2.x2), e2.y2 > i2.y2 && (i2.y2 = e2.y2), ["x", "y"].forEach(function(e3) {
      var t2, n2 = "dropShadow_" + e3;
      o2[n2] = t2 = i2[e3 + "1"], Xe(a2, l2, n2, t2) && (a2.efc_dropShadow_elmFilter[e3].baseVal.value = t2);
    }));
  } } }, Object.keys(Z).forEach(function(e2) {
    var t2 = Z[e2], n2 = t2.stats;
    n2[e2 + "_enabled"] = { iniValue: false }, n2[e2 + "_options"] = { hasProps: true }, t2.anim && (n2[e2 + "_animOptions"] = {}, n2[e2 + "_animId"] = {});
  }), w = { none: { defaultAnimOptions: {}, init: function(e2, t2) {
    var n2 = e2.curStats;
    n2.show_animId && (g.remove(n2.show_animId), n2.show_animId = null), w.none.start(e2, t2);
  }, start: function(e2, t2) {
    w.none.stop(e2, true);
  }, stop: function(e2, t2, n2) {
    var a2 = e2.curStats;
    return n2 = n2 != null ? n2 : e2.aplStats.show_on, a2.show_inAnim = false, t2 && Je(e2, n2), n2 ? 1 : 0;
  } }, fade: { defaultAnimOptions: { duration: 300, timing: "linear" }, init: function(n2, e2) {
    var t2 = n2.curStats, a2 = n2.aplStats;
    t2.show_animId && g.remove(t2.show_animId), t2.show_animId = g.add(function(e3) {
      return e3;
    }, function(e3, t3) {
      t3 ? w.fade.stop(n2, true) : (n2.svg.style.opacity = e3 + "", ie && (je(n2, n2.svg), He(n2)));
    }, a2.show_animOptions.duration, 1, a2.show_animOptions.timing, null, false), w.fade.start(n2, e2);
  }, start: function(e2, t2) {
    var n2, a2 = e2.curStats;
    a2.show_inAnim && (n2 = g.stop(a2.show_animId)), Je(e2, 1), a2.show_inAnim = true, g.start(a2.show_animId, !e2.aplStats.show_on, t2 != null ? t2 : n2);
  }, stop: function(e2, t2, n2) {
    var a2, i2 = e2.curStats;
    return n2 = n2 != null ? n2 : e2.aplStats.show_on, a2 = i2.show_inAnim ? g.stop(i2.show_animId) : n2 ? 1 : 0, i2.show_inAnim = false, t2 && (e2.svg.style.opacity = n2 ? "" : "0", Je(e2, n2)), a2;
  } }, draw: { defaultAnimOptions: { duration: 500, timing: [0.58, 0, 0.42, 1] }, init: function(n2, e2) {
    var t2 = n2.curStats, a2 = n2.aplStats, o2 = n2.pathList.baseVal, i2 = Re(o2), l2 = i2.segsLen, r2 = i2.lenAll;
    t2.show_animId && g.remove(t2.show_animId), t2.show_animId = g.add(function(e3) {
      var t3, n3, a3, i3 = -1;
      if (e3 === 0)
        n3 = [[o2[0][0], o2[0][0]]];
      else if (e3 === 1)
        n3 = o2;
      else {
        for (t3 = r2 * e3, n3 = []; t3 >= l2[++i3]; )
          n3.push(o2[i3]), t3 -= l2[i3];
        t3 && ((a3 = o2[i3]).length === 2 ? n3.push([a3[0], Ve(a3[0], a3[1], t3 / l2[i3])]) : (e3 = Ne(a3[0], a3[1], a3[2], a3[3], We(a3[0], a3[1], a3[2], a3[3], t3)), n3.push([a3[0], e3.fromP1, e3.fromP2, e3])));
      }
      return n3;
    }, function(e3, t3) {
      t3 ? w.draw.stop(n2, true) : (n2.pathList.animVal = e3, $e(n2, { path: true }));
    }, a2.show_animOptions.duration, 1, a2.show_animOptions.timing, null, false), w.draw.start(n2, e2);
  }, start: function(e2, t2) {
    var n2, a2 = e2.curStats;
    a2.show_inAnim && (n2 = g.stop(a2.show_animId)), Je(e2, 1), a2.show_inAnim = true, Ge(e2, "apl_position", w.draw.update), g.start(a2.show_animId, !e2.aplStats.show_on, t2 != null ? t2 : n2);
  }, stop: function(e2, t2, n2) {
    var a2, i2 = e2.curStats;
    return n2 = n2 != null ? n2 : e2.aplStats.show_on, a2 = i2.show_inAnim ? g.stop(i2.show_animId) : n2 ? 1 : 0, i2.show_inAnim = false, t2 && (e2.pathList.animVal = n2 ? null : [[e2.pathList.baseVal[0][0], e2.pathList.baseVal[0][0]]], $e(e2, { path: true }), Je(e2, n2)), a2;
  }, update: function(e2) {
    De(e2, "apl_position", w.draw.update), e2.curStats.show_inAnim ? w.draw.init(e2, w.draw.stop(e2)) : e2.aplStats.show_animOptions = {};
  } } }, [["start", "anchorSE", 0], ["end", "anchorSE", 1], ["color", "lineColor"], ["size", "lineSize"], ["startSocketGravity", "socketGravitySE", 0], ["endSocketGravity", "socketGravitySE", 1], ["startPlugColor", "plugColorSE", 0], ["endPlugColor", "plugColorSE", 1], ["startPlugSize", "plugSizeSE", 0], ["endPlugSize", "plugSizeSE", 1], ["outline", "lineOutlineEnabled"], ["outlineColor", "lineOutlineColor"], ["outlineSize", "lineOutlineSize"], ["startPlugOutline", "plugOutlineEnabledSE", 0], ["endPlugOutline", "plugOutlineEnabledSE", 1], ["startPlugOutlineColor", "plugOutlineColorSE", 0], ["endPlugOutlineColor", "plugOutlineColorSE", 1], ["startPlugOutlineSize", "plugOutlineSizeSE", 0], ["endPlugOutlineSize", "plugOutlineSizeSE", 1]].forEach(function(e2) {
    var t2 = e2[0], n2 = e2[1], a2 = e2[2];
    Object.defineProperty(ot.prototype, t2, { get: function() {
      var e3 = a2 != null ? Se[this._id].options[n2][a2] : n2 ? Se[this._id].options[n2] : Se[this._id].options[t2];
      return e3 == null ? D : we(e3);
    }, set: lt(t2), enumerable: true });
  }), [["path", R], ["startSocket", V, "socketSE", 0], ["endSocket", V, "socketSE", 1], ["startPlug", F, "plugSE", 0], ["endPlug", F, "plugSE", 1]].forEach(function(e2) {
    var a2 = e2[0], i2 = e2[1], o2 = e2[2], l2 = e2[3];
    Object.defineProperty(ot.prototype, a2, { get: function() {
      var t2, n2 = l2 != null ? Se[this._id].options[o2][l2] : o2 ? Se[this._id].options[o2] : Se[this._id].options[a2];
      return n2 ? Object.keys(i2).some(function(e3) {
        return i2[e3] === n2 && (t2 = e3, true);
      }) ? t2 : new Error("It's broken") : D;
    }, set: lt(a2), enumerable: true });
  }), Object.keys(Z).forEach(function(n2) {
    var a2 = Z[n2];
    Object.defineProperty(ot.prototype, n2, { get: function() {
      var s2, e2, t2 = Se[this._id].options[n2];
      return he(t2) ? (s2 = t2, e2 = a2.optionsConf.reduce(function(e3, t3) {
        var n3, a3 = t3[0], i2 = t3[1], o2 = t3[2], l2 = t3[3], t3 = t3[4], r2 = t3 != null ? s2[l2][t3] : l2 ? s2[l2] : s2[i2];
        return e3[i2] = a3 === "id" ? r2 ? Object.keys(o2).some(function(e4) {
          return o2[e4] === r2 && (n3 = e4, true);
        }) ? n3 : new Error("It's broken") : D : r2 == null ? D : we(r2), e3;
      }, {}), a2.anim && (e2.animation = we(s2.animation)), e2) : t2;
    }, set: lt(n2), enumerable: true });
  }), ["startLabel", "endLabel", "middleLabel"].forEach(function(e2, n2) {
    Object.defineProperty(ot.prototype, e2, { get: function() {
      var e3 = Se[this._id], t2 = e3.options;
      return t2.labelSEM[n2] && !e3.optionIsAttach.labelSEM[n2] ? _e[t2.labelSEM[n2]._id].text : t2.labelSEM[n2] || "";
    }, set: lt(e2), enumerable: true });
  }), ot.prototype.setOptions = function(e2) {
    return it(Se[this._id], e2), this;
  }, ot.prototype.position = function() {
    return $e(Se[this._id], { position: true }), this;
  }, ot.prototype.remove = function() {
    var t2 = Se[this._id], n2 = t2.curStats;
    Object.keys(Z).forEach(function(e2) {
      e2 += "_animId";
      n2[e2] && g.remove(n2[e2]);
    }), n2.show_animId && g.remove(n2.show_animId), t2.attachments.slice().forEach(function(e2) {
      at(t2, e2);
    }), t2.baseWindow && t2.svg && t2.baseWindow.document.body.removeChild(t2.svg), delete Se[this._id];
  }, ot.prototype.show = function(e2, t2) {
    return tt(Se[this._id], true, e2, t2), this;
  }, ot.prototype.hide = function(e2, t2) {
    return tt(Se[this._id], false, e2, t2), this;
  }, o = function(t2) {
    t2 && _e[t2._id] && (t2.boundTargets.slice().forEach(function(e2) {
      at(e2.props, t2, true);
    }), t2.conf.remove && t2.conf.remove(t2), delete _e[t2._id]);
  }, rt.prototype.remove = function() {
    var t2 = this, n2 = _e[t2._id];
    n2 && (n2.boundTargets.slice().forEach(function(e2) {
      n2.conf.removeOption(n2, e2);
    }), ze(function() {
      var e2 = _e[t2._id];
      e2 && (console.error("LeaderLineAttachment was not removed by removeOption"), o(e2));
    }));
  }, M = rt, window.LeaderLineAttachment = M, I = function(e2, t2) {
    return e2 instanceof M && (!(e2.isRemoved || t2 && _e[e2._id].conf.type !== t2) || null);
  }, O = { pointAnchor: { type: "anchor", argOptions: [{ optionName: "element", type: Me }], init: function(e2, t2) {
    return e2.element = O.pointAnchor.checkElement(t2.element), e2.x = O.pointAnchor.parsePercent(t2.x, true) || [0.5, true], e2.y = O.pointAnchor.parsePercent(t2.y, true) || [0.5, true], true;
  }, removeOption: function(e2, t2) {
    var n2 = t2.props, a2 = {}, i2 = e2.element, e2 = n2.options.anchorSE[t2.optionName === "start" ? 1 : 0];
    i2 === e2 && (i2 = e2 === document.body ? new M(O.pointAnchor, [i2]) : document.body), a2[t2.optionName] = i2, it(n2, a2);
  }, getBBoxNest: function(e2, t2) {
    var n2 = Le(e2.element, t2.baseWindow), a2 = n2.width, t2 = n2.height;
    return n2.width = n2.height = 0, n2.left = n2.right = n2.left + e2.x[0] * (e2.x[1] ? a2 : 1), n2.top = n2.bottom = n2.top + e2.y[0] * (e2.y[1] ? t2 : 1), n2;
  }, parsePercent: function(e2, t2) {
    var n2, a2, i2 = false;
    return pe(e2) ? a2 = e2 : typeof e2 == "string" && (n2 = m.exec(e2)) && n2[2] && (i2 = (a2 = parseFloat(n2[1]) / 100) !== 0), a2 != null && (t2 || 0 <= a2) ? [a2, i2] : null;
  }, checkElement: function(e2) {
    if (e2 == null)
      e2 = document.body;
    else if (!Me(e2))
      throw new Error("`element` must be Element");
    return e2;
  } }, areaAnchor: { type: "anchor", argOptions: [{ optionName: "element", type: Me }, { optionName: "shape", type: "string" }], stats: { color: {}, strokeWidth: {}, elementWidth: {}, elementHeight: {}, elementLeft: {}, elementTop: {}, pathListRel: {}, bBoxRel: {}, pathData: {}, viewBoxBBox: { hasProps: true }, dashLen: {}, dashGap: {} }, init: function(a2, e2) {
    var t2, n2 = [];
    return a2.element = O.pointAnchor.checkElement(e2.element), typeof e2.color == "string" && (a2.color = e2.color.trim()), typeof e2.fillColor == "string" && (a2.fill = e2.fillColor.trim()), pe(e2.size) && 0 <= e2.size && (a2.size = e2.size), e2.dash && (a2.dash = true, pe(e2.dash.len) && 0 < e2.dash.len && (a2.dashLen = e2.dash.len), pe(e2.dash.gap) && 0 < e2.dash.gap && (a2.dashGap = e2.dash.gap)), e2.shape === "circle" ? a2.shape = e2.shape : e2.shape === "polygon" && Array.isArray(e2.points) && 3 <= e2.points.length && e2.points.every(function(e3) {
      var t3 = {};
      return !(!(t3.x = O.pointAnchor.parsePercent(e3[0], true)) || !(t3.y = O.pointAnchor.parsePercent(e3[1], true))) && (n2.push(t3), (t3.x[1] || t3.y[1]) && (a2.hasRatio = true), true);
    }) ? (a2.shape = e2.shape, a2.points = n2) : (a2.shape = "rect", a2.radius = pe(e2.radius) && 0 <= e2.radius ? e2.radius : 0), a2.shape !== "rect" && a2.shape !== "circle" || (a2.x = O.pointAnchor.parsePercent(e2.x, true) || [-0.05, true], a2.y = O.pointAnchor.parsePercent(e2.y, true) || [-0.05, true], a2.width = O.pointAnchor.parsePercent(e2.width) || [1.1, true], a2.height = O.pointAnchor.parsePercent(e2.height) || [1.1, true], (a2.x[1] || a2.y[1] || a2.width[1] || a2.height[1]) && (a2.hasRatio = true)), t2 = a2.element.ownerDocument, a2.svg = e2 = t2.createElementNS(ae, "svg"), e2.className.baseVal = C + "-areaAnchor", e2.viewBox.baseVal || e2.setAttribute("viewBox", "0 0 0 0"), a2.path = e2.appendChild(t2.createElementNS(ae, "path")), a2.path.style.fill = a2.fill || "none", a2.isShown = false, e2.style.visibility = "hidden", t2.body.appendChild(e2), Qe(t2 = t2.defaultView), a2.bodyOffset = qe(t2), a2.updateColor = function() {
      var e3 = a2.curStats, t3 = a2.aplStats, n3 = a2.boundTargets.length ? a2.boundTargets[0].props.curStats : null;
      e3.color = n3 = a2.color || (n3 ? n3.line_color : ue.lineColor), Xe(a2, t3, "color", n3) && (a2.path.style.stroke = n3);
    }, a2.updateShow = function() {
      Je(a2, a2.boundTargets.some(function(e3) {
        return e3.props.isShown === true;
      }));
    }, true;
  }, bind: function(e2, t2) {
    t2 = t2.props;
    return e2.color || Ge(t2, "cur_line_color", e2.updateColor), Ge(t2, "svgShow", e2.updateShow), ze(function() {
      e2.updateColor(), e2.updateShow();
    }), true;
  }, unbind: function(e2, t2) {
    t2 = t2.props;
    e2.color || De(t2, "cur_line_color", e2.updateColor), De(t2, "svgShow", e2.updateShow), 1 < e2.boundTargets.length && ze(function() {
      e2.updateColor(), e2.updateShow(), O.areaAnchor.update(e2) && e2.boundTargets.forEach(function(e3) {
        $e(e3.props, { position: true });
      });
    });
  }, removeOption: function(e2, t2) {
    O.pointAnchor.removeOption(e2, t2);
  }, remove: function(t2) {
    t2.boundTargets.length && (console.error("LeaderLineAttachment was not unbound by remove"), t2.boundTargets.forEach(function(e2) {
      O.areaAnchor.unbind(t2, e2);
    })), t2.svg.parentNode.removeChild(t2.svg);
  }, getStrokeWidth: function(e2, t2) {
    return O.areaAnchor.update(e2) && 1 < e2.boundTargets.length && ze(function() {
      e2.boundTargets.forEach(function(e3) {
        e3.props !== t2 && $e(e3.props, { position: true });
      });
    }), e2.curStats.strokeWidth;
  }, getPathData: function(e2, t2) {
    var n2 = Le(e2.element, t2.baseWindow);
    return Be(e2.curStats.pathListRel, function(e3) {
      e3.x += n2.left, e3.y += n2.top;
    });
  }, getBBoxNest: function(e2, t2) {
    t2 = Le(e2.element, t2.baseWindow), e2 = e2.curStats.bBoxRel;
    return { left: e2.left + t2.left, top: e2.top + t2.top, right: e2.right + t2.left, bottom: e2.bottom + t2.top, width: e2.width, height: e2.height };
  }, update: function(t2) {
    var n2, a2, i2, o2, e2, l2, r2, s2, u2, h2, p2, c2, d2, f2, y2, m2, S2 = t2.curStats, g2 = t2.aplStats, _2 = t2.boundTargets.length ? t2.boundTargets[0].props.curStats : null, v2 = {};
    if (v2.strokeWidth = Xe(t2, S2, "strokeWidth", t2.size != null ? t2.size : _2 ? _2.line_strokeWidth : ue.lineSize), n2 = Ie(t2.element), v2.elementWidth = Xe(t2, S2, "elementWidth", n2.width), v2.elementHeight = Xe(t2, S2, "elementHeight", n2.height), v2.elementLeft = Xe(t2, S2, "elementLeft", n2.left), v2.elementTop = Xe(t2, S2, "elementTop", n2.top), v2.strokeWidth || t2.hasRatio && (v2.elementWidth || v2.elementHeight)) {
      switch (t2.shape) {
        case "rect":
          (c2 = { left: t2.x[0] * (t2.x[1] ? n2.width : 1), top: t2.y[0] * (t2.y[1] ? n2.height : 1), width: t2.width[0] * (t2.width[1] ? n2.width : 1), height: t2.height[0] * (t2.height[1] ? n2.height : 1) }).right = c2.left + c2.width, c2.bottom = c2.top + c2.height, p2 = S2.strokeWidth / 2, s2 = (r2 = Math.min(c2.width, c2.height)) ? r2 / 2 * Math.SQRT2 + p2 : 0, h2 = (r2 = t2.radius ? t2.radius <= s2 ? t2.radius : s2 : 0) ? (s2 = (r2 - p2) / Math.SQRT2, h2 = [{ x: c2.left - (u2 = r2 - s2), y: c2.top + s2 }, { x: c2.left + s2, y: c2.top - u2 }, { x: c2.right - s2, y: c2.top - u2 }, { x: c2.right + u2, y: c2.top + s2 }, { x: c2.right + u2, y: c2.bottom - s2 }, { x: c2.right - s2, y: c2.bottom + u2 }, { x: c2.left + s2, y: c2.bottom + u2 }, { x: c2.left - u2, y: c2.bottom - s2 }], S2.pathListRel = [[h2[0], { x: h2[0].x, y: h2[0].y - (p2 = r2 * te) }, { x: h2[1].x - p2, y: h2[1].y }, h2[1]]], h2[1].x !== h2[2].x && S2.pathListRel.push([h2[1], h2[2]]), S2.pathListRel.push([h2[2], { x: h2[2].x + p2, y: h2[2].y }, { x: h2[3].x, y: h2[3].y - p2 }, h2[3]]), h2[3].y !== h2[4].y && S2.pathListRel.push([h2[3], h2[4]]), S2.pathListRel.push([h2[4], { x: h2[4].x, y: h2[4].y + p2 }, { x: h2[5].x + p2, y: h2[5].y }, h2[5]]), h2[5].x !== h2[6].x && S2.pathListRel.push([h2[5], h2[6]]), S2.pathListRel.push([h2[6], { x: h2[6].x - p2, y: h2[6].y }, { x: h2[7].x, y: h2[7].y + p2 }, h2[7]]), h2[7].y !== h2[0].y && S2.pathListRel.push([h2[7], h2[0]]), S2.pathListRel.push([]), u2 = r2 - s2 + S2.strokeWidth / 2, [{ x: c2.left - u2, y: c2.top - u2 }, { x: c2.right + u2, y: c2.bottom + u2 }]) : (u2 = S2.strokeWidth / 2, h2 = [{ x: c2.left - u2, y: c2.top - u2 }, { x: c2.right + u2, y: c2.bottom + u2 }], S2.pathListRel = [[h2[0], { x: h2[1].x, y: h2[0].y }], [{ x: h2[1].x, y: h2[0].y }, h2[1]], [h2[1], { x: h2[0].x, y: h2[1].y }], []], [{ x: c2.left - S2.strokeWidth, y: c2.top - S2.strokeWidth }, { x: c2.right + S2.strokeWidth, y: c2.bottom + S2.strokeWidth }]), S2.bBoxRel = { left: h2[0].x, top: h2[0].y, right: h2[1].x, bottom: h2[1].y, width: h2[1].x - h2[0].x, height: h2[1].y - h2[0].y };
          break;
        case "circle":
          (l2 = { left: t2.x[0] * (t2.x[1] ? n2.width : 1), top: t2.y[0] * (t2.y[1] ? n2.height : 1), width: t2.width[0] * (t2.width[1] ? n2.width : 1), height: t2.height[0] * (t2.height[1] ? n2.height : 1) }).width || l2.height || (l2.width = l2.height = 10), l2.width || (l2.width = l2.height), l2.height || (l2.height = l2.width), l2.right = l2.left + l2.width, l2.bottom = l2.top + l2.height, p2 = l2.left + l2.width / 2, r2 = l2.top + l2.height / 2, e2 = S2.strokeWidth / 2, s2 = l2.width / 2, u2 = l2.height / 2, c2 = s2 * Math.SQRT2 + e2, h2 = u2 * Math.SQRT2 + e2, S2.pathListRel = [[(e2 = [{ x: p2 - c2, y: r2 }, { x: p2, y: r2 - h2 }, { x: p2 + c2, y: r2 }, { x: p2, y: r2 + h2 }])[0], { x: e2[0].x, y: e2[0].y - (p2 = h2 * te) }, { x: e2[1].x - (r2 = c2 * te), y: e2[1].y }, e2[1]], [e2[1], { x: e2[1].x + r2, y: e2[1].y }, { x: e2[2].x, y: e2[2].y - p2 }, e2[2]], [e2[2], { x: e2[2].x, y: e2[2].y + p2 }, { x: e2[3].x + r2, y: e2[3].y }, e2[3]], [e2[3], { x: e2[3].x - r2, y: e2[3].y }, { x: e2[0].x, y: e2[0].y + p2 }, e2[0]], []], s2 = c2 - s2 + S2.strokeWidth / 2, u2 = h2 - u2 + S2.strokeWidth / 2, e2 = [{ x: l2.left - s2, y: l2.top - u2 }, { x: l2.right + s2, y: l2.bottom + u2 }], S2.bBoxRel = { left: e2[0].x, top: e2[0].y, right: e2[1].x, bottom: e2[1].y, width: e2[1].x - e2[0].x, height: e2[1].y - e2[0].y };
          break;
        case "polygon":
          t2.points.forEach(function(e3) {
            var t3 = e3.x[0] * (e3.x[1] ? n2.width : 1), e3 = e3.y[0] * (e3.y[1] ? n2.height : 1);
            i2 ? (t3 < i2.left && (i2.left = t3), t3 > i2.right && (i2.right = t3), e3 < i2.top && (i2.top = e3), e3 > i2.bottom && (i2.bottom = e3)) : i2 = { left: t3, right: t3, top: e3, bottom: e3 }, o2 ? S2.pathListRel.push([o2, { x: t3, y: e3 }]) : S2.pathListRel = [], o2 = { x: t3, y: e3 };
          }), S2.pathListRel.push([]), e2 = S2.strokeWidth / 2, e2 = [{ x: i2.left - e2, y: i2.top - e2 }, { x: i2.right + e2, y: i2.bottom + e2 }], S2.bBoxRel = { left: e2[0].x, top: e2[0].y, right: e2[1].x, bottom: e2[1].y, width: e2[1].x - e2[0].x, height: e2[1].y - e2[0].y };
      }
      v2.pathListRel = v2.bBoxRel = true;
    }
    return (v2.pathListRel || v2.elementLeft || v2.elementTop) && (S2.pathData = Be(S2.pathListRel, function(e3) {
      e3.x += n2.left, e3.y += n2.top;
    })), Xe(t2, g2, "strokeWidth", a2 = S2.strokeWidth) && (t2.path.style.strokeWidth = a2 + "px"), Fe(a2 = S2.pathData, g2.pathData) && (t2.path.setPathData(a2), g2.pathData = a2, v2.pathData = true), t2.dash && (!v2.pathData && (!v2.strokeWidth || t2.dashLen && t2.dashGap) || (S2.dashLen = t2.dashLen || 2 * S2.strokeWidth, S2.dashGap = t2.dashGap || S2.strokeWidth), v2.dash = Xe(t2, g2, "dashLen", S2.dashLen) || v2.dash, v2.dash = Xe(t2, g2, "dashGap", S2.dashGap) || v2.dash, v2.dash && (t2.path.style.strokeDasharray = g2.dashLen + "," + g2.dashGap)), d2 = S2.viewBoxBBox, f2 = g2.viewBoxBBox, y2 = t2.svg.viewBox.baseVal, m2 = t2.svg.style, d2.x = S2.bBoxRel.left + n2.left, d2.y = S2.bBoxRel.top + n2.top, d2.width = S2.bBoxRel.width, d2.height = S2.bBoxRel.height, ["x", "y", "width", "height"].forEach(function(e3) {
      (a2 = d2[e3]) !== f2[e3] && (y2[e3] = f2[e3] = a2, m2[Q[e3]] = a2 + (e3 === "x" || e3 === "y" ? t2.bodyOffset[e3] : 0) + "px");
    }), v2.strokeWidth || v2.pathListRel || v2.bBoxRel;
  } }, mouseHoverAnchor: { type: "anchor", argOptions: [{ optionName: "element", type: Me }, { optionName: "showEffectName", type: "string" }], style: { backgroundImage: "url('data:image/svg+xml;charset=utf-8;base64,PHN2ZyB2ZXJzaW9uPSIxLjEiIHhtbG5zPSJodHRwOi8vd3d3LnczLm9yZy8yMDAwL3N2ZyIgd2lkdGg9IjI0IiBoZWlnaHQ9IjI0Ij48cG9seWdvbiBwb2ludHM9IjI0LDAgMCw4IDgsMTEgMCwxOSA1LDI0IDEzLDE2IDE2LDI0IiBmaWxsPSJjb3JhbCIvPjwvc3ZnPg==')", backgroundSize: "", backgroundRepeat: "no-repeat", backgroundColor: "#f8f881", cursor: "default" }, hoverStyle: { backgroundImage: "none", backgroundColor: "#fadf8f" }, padding: { top: 1, right: 15, bottom: 1, left: 2 }, minHeight: 15, backgroundPosition: { right: 2, top: 2 }, backgroundSize: { width: 12, height: 12 }, dirKeys: [["top", "Top"], ["right", "Right"], ["bottom", "Bottom"], ["left", "Left"]], init: function(a2, i2) {
    var n2, t2, e2, o2, l2, r2, s2, u2, h2, p2 = O.mouseHoverAnchor, c2 = {};
    if (a2.element = O.pointAnchor.checkElement(i2.element), s2 = a2.element, !((u2 = s2.ownerDocument) && (h2 = u2.defaultView) && h2.HTMLElement && s2 instanceof h2.HTMLElement))
      throw new Error("`element` must be HTML element");
    return p2.style.backgroundSize = p2.backgroundSize.width + "px " + p2.backgroundSize.height + "px", ["style", "hoverStyle"].forEach(function(e3) {
      var n3 = p2[e3];
      a2[e3] = Object.keys(n3).reduce(function(e4, t3) {
        return e4[t3] = n3[t3], e4;
      }, {});
    }), (n2 = a2.element.ownerDocument.defaultView.getComputedStyle(a2.element, "")).display === "inline" ? a2.style.display = "inline-block" : n2.display === "none" && (a2.style.display = "block"), O.mouseHoverAnchor.dirKeys.forEach(function(e3) {
      var t3 = e3[0], e3 = "padding" + e3[1];
      parseFloat(n2[e3]) < p2.padding[t3] && (a2.style[e3] = p2.padding[t3] + "px");
    }), a2.style.display && (e2 = a2.element.style.display, a2.element.style.display = a2.style.display), O.mouseHoverAnchor.dirKeys.forEach(function(e3) {
      e3 = "padding" + e3[1];
      a2.style[e3] && (c2[e3] = a2.element.style[e3], a2.element.style[e3] = a2.style[e3]);
    }), (s2 = a2.element.getBoundingClientRect()).height < p2.minHeight && (ie ? (h2 = p2.minHeight, n2.boxSizing === "content-box" ? h2 -= parseFloat(n2.borderTopWidth) + parseFloat(n2.borderBottomWidth) + parseFloat(n2.paddingTop) + parseFloat(n2.paddingBottom) : n2.boxSizing === "padding-box" && (h2 -= parseFloat(n2.borderTopWidth) + parseFloat(n2.borderBottomWidth)), a2.style.height = h2 + "px") : a2.style.height = parseFloat(n2.height) + (p2.minHeight - s2.height) + "px"), a2.style.backgroundPosition = re ? s2.width - p2.backgroundSize.width - p2.backgroundPosition.right + "px " + p2.backgroundPosition.top + "px" : "right " + p2.backgroundPosition.right + "px top " + p2.backgroundPosition.top + "px", a2.style.display && (a2.element.style.display = e2), O.mouseHoverAnchor.dirKeys.forEach(function(e3) {
      e3 = "padding" + e3[1];
      a2.style[e3] && (a2.element.style[e3] = c2[e3]);
    }), ["style", "hoverStyle"].forEach(function(e3) {
      var t3 = a2[e3], n3 = i2[e3];
      he(n3) && Object.keys(n3).forEach(function(e4) {
        typeof n3[e4] == "string" || pe(n3[e4]) ? t3[e4] = n3[e4] : n3[e4] == null && delete t3[e4];
      });
    }), typeof i2.onSwitch == "function" && (r2 = i2.onSwitch), i2.showEffectName && w[i2.showEffectName] && (a2.showEffectName = o2 = i2.showEffectName), l2 = i2.animOptions, a2.elmStyle = t2 = a2.element.style, a2.mouseenter = function(e3) {
      a2.hoverStyleSave = p2.getStyles(t2, Object.keys(a2.hoverStyle)), p2.setStyles(t2, a2.hoverStyle), a2.boundTargets.forEach(function(e4) {
        tt(e4.props, true, o2, l2);
      }), r2 && r2(e3);
    }, a2.mouseleave = function(e3) {
      p2.setStyles(t2, a2.hoverStyleSave), a2.boundTargets.forEach(function(e4) {
        tt(e4.props, false, o2, l2);
      }), r2 && r2(e3);
    }, true;
  }, bind: function(e2, t2) {
    var n2, a2, i2, o2, l2;
    return t2.props.svg ? O.mouseHoverAnchor.llShow(t2.props, false, e2.showEffectName) : ze(function() {
      O.mouseHoverAnchor.llShow(t2.props, false, e2.showEffectName);
    }), e2.enabled || (e2.styleSave = O.mouseHoverAnchor.getStyles(e2.elmStyle, Object.keys(e2.style)), O.mouseHoverAnchor.setStyles(e2.elmStyle, e2.style), e2.removeEventListener = (n2 = e2.element, a2 = e2.mouseenter, i2 = e2.mouseleave, "onmouseenter" in n2 && "onmouseleave" in n2 ? (n2.addEventListener("mouseenter", a2, false), n2.addEventListener("mouseleave", i2, false), function() {
      n2.removeEventListener("mouseenter", a2, false), n2.removeEventListener("mouseleave", i2, false);
    }) : (console.warn("mouseenter and mouseleave events polyfill is enabled."), n2.addEventListener("mouseover", o2 = function(e3) {
      e3.relatedTarget && (e3.relatedTarget === this || this.compareDocumentPosition(e3.relatedTarget) & Node.DOCUMENT_POSITION_CONTAINED_BY) || a2.apply(this, arguments);
    }), n2.addEventListener("mouseout", l2 = function(e3) {
      e3.relatedTarget && (e3.relatedTarget === this || this.compareDocumentPosition(e3.relatedTarget) & Node.DOCUMENT_POSITION_CONTAINED_BY) || i2.apply(this, arguments);
    }), function() {
      n2.removeEventListener("mouseover", o2, false), n2.removeEventListener("mouseout", l2, false);
    })), e2.enabled = true), true;
  }, unbind: function(e2, t2) {
    e2.enabled && e2.boundTargets.length <= 1 && (e2.removeEventListener(), O.mouseHoverAnchor.setStyles(e2.elmStyle, e2.styleSave), e2.enabled = false), O.mouseHoverAnchor.llShow(t2.props, true, e2.showEffectName);
  }, removeOption: function(e2, t2) {
    O.pointAnchor.removeOption(e2, t2);
  }, remove: function(t2) {
    t2.boundTargets.length && (console.error("LeaderLineAttachment was not unbound by remove"), t2.boundTargets.forEach(function(e2) {
      O.mouseHoverAnchor.unbind(t2, e2);
    }));
  }, getBBoxNest: function(e2, t2) {
    return Le(e2.element, t2.baseWindow);
  }, llShow: function(e2, t2, n2) {
    w[n2 || e2.curStats.show_effect].stop(e2, true, t2), e2.aplStats.show_on = t2;
  }, getStyles: function(n2, e2) {
    return e2.reduce(function(e3, t2) {
      return e3[t2] = n2[t2], e3;
    }, {});
  }, setStyles: function(t2, n2) {
    Object.keys(n2).forEach(function(e2) {
      t2[e2] = n2[e2];
    });
  } }, captionLabel: { type: "label", argOptions: [{ optionName: "text", type: "string" }], stats: { color: {}, x: {}, y: {} }, textStyleProps: ["fontFamily", "fontStyle", "fontVariant", "fontWeight", "fontStretch", "fontSize", "fontSizeAdjust", "kerning", "letterSpacing", "wordSpacing", "textDecoration"], init: function(l2, t2) {
    return typeof t2.text == "string" && (l2.text = t2.text.trim()), !!l2.text && (typeof t2.color == "string" && (l2.color = t2.color.trim()), l2.outlineColor = typeof t2.outlineColor == "string" ? t2.outlineColor.trim() : "#fff", Array.isArray(t2.offset) && pe(t2.offset[0]) && pe(t2.offset[1]) && (l2.offset = { x: t2.offset[0], y: t2.offset[1] }), pe(t2.lineOffset) && (l2.lineOffset = t2.lineOffset), O.captionLabel.textStyleProps.forEach(function(e2) {
      t2[e2] != null && (l2[e2] = t2[e2]);
    }), l2.updateColor = function(e2) {
      O.captionLabel.updateColor(l2, e2);
    }, l2.updateSocketXY = function(e2) {
      var t3, n2 = l2.curStats, a2 = l2.aplStats, i2 = e2.curStats, o2 = i2.position_socketXYSE[l2.socketIndex];
      o2.x != null && (l2.offset ? (n2.x = o2.x + l2.offset.x, n2.y = o2.y + l2.offset.y) : (t3 = l2.height / 2, e2 = Math.max(i2.attach_plugSideLenSE[l2.socketIndex] || 0, i2.line_strokeWidth / 2), i2 = i2.position_socketXYSE[l2.socketIndex ? 0 : 1], o2.socketId === A || o2.socketId === k ? (n2.x = o2.socketId === A ? o2.x - t3 - l2.width : o2.x + t3, n2.y = i2.y < o2.y ? o2.y + e2 + t3 : o2.y - e2 - t3 - l2.height) : (n2.x = i2.x < o2.x ? o2.x + e2 + t3 : o2.x - e2 - t3 - l2.width, n2.y = o2.socketId === b ? o2.y - t3 - l2.height : o2.y + t3)), Xe(l2, a2, "x", t3 = n2.x) && (l2.elmPosition.x.baseVal.getItem(0).value = t3), Xe(l2, a2, "y", t3 = n2.y) && (l2.elmPosition.y.baseVal.getItem(0).value = t3 + l2.height));
    }, l2.updatePath = function(e2) {
      var t3 = l2.curStats, n2 = l2.aplStats, e2 = e2.pathList.animVal || e2.pathList.baseVal;
      e2 && (e2 = O.captionLabel.getMidPoint(e2, l2.lineOffset), t3.x = e2.x - l2.width / 2, t3.y = e2.y - l2.height / 2, Xe(l2, n2, "x", e2 = t3.x) && (l2.elmPosition.x.baseVal.getItem(0).value = e2), Xe(l2, n2, "y", e2 = t3.y) && (l2.elmPosition.y.baseVal.getItem(0).value = e2 + l2.height));
    }, l2.updateShow = function(e2) {
      O.captionLabel.updateShow(l2, e2);
    }, re && (l2.adjustEdge = function(e2, t3) {
      var n2 = l2.curStats;
      n2.x != null && O.captionLabel.adjustEdge(t3, { x: n2.x, y: n2.y, width: l2.width, height: l2.height }, l2.strokeWidth / 2);
    }), true);
  }, updateColor: function(e2, t2) {
    var n2 = e2.curStats, a2 = e2.aplStats, t2 = t2.curStats;
    n2.color = t2 = e2.color || t2.line_color, Xe(e2, a2, "color", t2) && (e2.styleFill.fill = t2);
  }, updateShow: function(e2, t2) {
    t2 = t2.isShown === true;
    t2 !== e2.isShown && (e2.styleShow.visibility = t2 ? "" : "hidden", e2.isShown = t2);
  }, adjustEdge: function(e2, t2, n2) {
    n2 = { x1: t2.x - n2, y1: t2.y - n2, x2: t2.x + t2.width + n2, y2: t2.y + t2.height + n2 };
    n2.x1 < e2.x1 && (e2.x1 = n2.x1), n2.y1 < e2.y1 && (e2.y1 = n2.y1), n2.x2 > e2.x2 && (e2.x2 = n2.x2), n2.y2 > e2.y2 && (e2.y2 = n2.y2);
  }, newText: function(e2, t2, n2, a2, i2) {
    var o2, l2, r2 = t2.createElementNS(ae, "text");
    return r2.textContent = e2, [r2.x, r2.y].forEach(function(e3) {
      var t3 = n2.createSVGLength();
      t3.newValueSpecifiedUnits(SVGLength.SVG_LENGTHTYPE_PX, 0), e3.baseVal.initialize(t3);
    }), typeof h != "boolean" && (h = "paintOrder" in r2.style), i2 && !h ? (o2 = t2.createElementNS(ae, "defs"), r2.id = a2, o2.appendChild(r2), (l2 = (e2 = t2.createElementNS(ae, "g")).appendChild(t2.createElementNS(ae, "use"))).href.baseVal = "#" + a2, (t2 = e2.appendChild(t2.createElementNS(ae, "use"))).href.baseVal = "#" + a2, (l2 = l2.style).strokeLinejoin = "round", { elmPosition: r2, styleText: r2.style, styleFill: t2.style, styleStroke: l2, styleShow: e2.style, elmsAppend: [o2, e2] }) : (l2 = r2.style, i2 && (l2.strokeLinejoin = "round", l2.paintOrder = "stroke"), { elmPosition: r2, styleText: l2, styleFill: l2, styleStroke: i2 ? l2 : null, styleShow: l2, elmsAppend: [r2] });
  }, getMidPoint: function(e2, t2) {
    var n2, a2, i2 = Re(e2), o2 = i2.segsLen, i2 = i2.lenAll, l2 = -1, r2 = i2 / 2 + (t2 || 0);
    if (r2 <= 0)
      return (n2 = e2[0]).length === 2 ? Ve(n2[0], n2[1], 0) : Ne(n2[0], n2[1], n2[2], n2[3], 0);
    if (i2 <= r2)
      return (n2 = e2[e2.length - 1]).length === 2 ? Ve(n2[0], n2[1], 1) : Ne(n2[0], n2[1], n2[2], n2[3], 1);
    for (a2 = []; r2 > o2[++l2]; )
      a2.push(e2[l2]), r2 -= o2[l2];
    return (n2 = e2[l2]).length === 2 ? Ve(n2[0], n2[1], r2 / o2[l2]) : Ne(n2[0], n2[1], n2[2], n2[3], We(n2[0], n2[1], n2[2], n2[3], r2));
  }, initSvg: function(t2, n2) {
    var e2, a2, i2 = O.captionLabel.newText(t2.text, n2.baseWindow.document, n2.svg, C + "-captionLabel-" + t2._id, t2.outlineColor);
    ["elmPosition", "styleFill", "styleShow", "elmsAppend"].forEach(function(e3) {
      t2[e3] = i2[e3];
    }), t2.isShown = false, t2.styleShow.visibility = "hidden", O.captionLabel.textStyleProps.forEach(function(e3) {
      t2[e3] != null && (i2.styleText[e3] = t2[e3]);
    }), i2.elmsAppend.forEach(function(e3) {
      n2.svg.appendChild(e3);
    }), e2 = i2.elmPosition.getBBox(), t2.width = e2.width, t2.height = e2.height, t2.outlineColor && (a2 = e2.height / 9, i2.styleStroke.strokeWidth = (a2 = 10 < a2 ? 10 : a2 < 2 ? 2 : a2) + "px", i2.styleStroke.stroke = t2.outlineColor), t2.strokeWidth = a2 || 0, Ye(t2.aplStats, O.captionLabel.stats), t2.updateColor(n2), t2.refSocketXY ? t2.updateSocketXY(n2) : t2.updatePath(n2), re && $e(n2, {}), t2.updateShow(n2);
  }, bind: function(e2, t2) {
    var n2 = t2.props;
    return e2.color || Ge(n2, "cur_line_color", e2.updateColor), (e2.refSocketXY = t2.optionName === "startLabel" || t2.optionName === "endLabel") ? (e2.socketIndex = t2.optionName === "startLabel" ? 0 : 1, Ge(n2, "apl_position", e2.updateSocketXY), e2.offset || (Ge(n2, "cur_attach_plugSideLenSE", e2.updateSocketXY), Ge(n2, "cur_line_strokeWidth", e2.updateSocketXY))) : Ge(n2, "apl_path", e2.updatePath), Ge(n2, "svgShow", e2.updateShow), re && Ge(n2, "new_edge4viewBox", e2.adjustEdge), O.captionLabel.initSvg(e2, n2), true;
  }, unbind: function(e2, t2) {
    var n2 = t2.props;
    e2.elmsAppend && (e2.elmsAppend.forEach(function(e3) {
      n2.svg.removeChild(e3);
    }), e2.elmPosition = e2.styleFill = e2.styleShow = e2.elmsAppend = null), Ye(e2.curStats, O.captionLabel.stats), Ye(e2.aplStats, O.captionLabel.stats), e2.color || De(n2, "cur_line_color", e2.updateColor), e2.refSocketXY ? (De(n2, "apl_position", e2.updateSocketXY), e2.offset || (De(n2, "cur_attach_plugSideLenSE", e2.updateSocketXY), De(n2, "cur_line_strokeWidth", e2.updateSocketXY))) : De(n2, "apl_path", e2.updatePath), De(n2, "svgShow", e2.updateShow), re && (De(n2, "new_edge4viewBox", e2.adjustEdge), $e(n2, {}));
  }, removeOption: function(e2, t2) {
    var n2 = t2.props, a2 = {};
    a2[t2.optionName] = "", it(n2, a2);
  }, remove: function(t2) {
    t2.boundTargets.length && (console.error("LeaderLineAttachment was not unbound by remove"), t2.boundTargets.forEach(function(e2) {
      O.captionLabel.unbind(t2, e2);
    }));
  } }, pathLabel: { type: "label", argOptions: [{ optionName: "text", type: "string" }], stats: { color: {}, startOffset: {}, pathData: {} }, init: function(l2, t2) {
    return typeof t2.text == "string" && (l2.text = t2.text.trim()), !!l2.text && (typeof t2.color == "string" && (l2.color = t2.color.trim()), l2.outlineColor = typeof t2.outlineColor == "string" ? t2.outlineColor.trim() : "#fff", pe(t2.lineOffset) && (l2.lineOffset = t2.lineOffset), O.captionLabel.textStyleProps.forEach(function(e2) {
      t2[e2] != null && (l2[e2] = t2[e2]);
    }), l2.updateColor = function(e2) {
      O.captionLabel.updateColor(l2, e2);
    }, l2.updatePath = function(e2) {
      var t3 = l2.curStats, n2 = l2.aplStats, a2 = e2.curStats, i2 = e2.pathList.animVal || e2.pathList.baseVal;
      i2 && (t3.pathData = a2 = O.pathLabel.getOffsetPathData(i2, a2.line_strokeWidth / 2 + l2.strokeWidth / 2 + l2.height / 4, 1.25 * l2.height), Fe(a2, n2.pathData) && (l2.elmPath.setPathData(a2), n2.pathData = a2, l2.bBox = l2.elmPosition.getBBox(), l2.updateStartOffset(e2)));
    }, l2.updateStartOffset = function(e2) {
      var i2, t3, n2 = l2.curStats, a2 = l2.aplStats, o2 = e2.curStats;
      n2.pathData && (l2.semIndex === 2 && !l2.lineOffset || (t3 = n2.pathData.reduce(function(e3, t4) {
        var n3, a3 = t4.values;
        switch (t4.type) {
          case "M":
            i2 = { x: a3[0], y: a3[1] };
            break;
          case "L":
            n3 = { x: a3[0], y: a3[1] }, i2 && (e3 += Ae(i2, n3)), i2 = n3;
            break;
          case "C":
            n3 = { x: a3[4], y: a3[5] }, i2 && (e3 += Te(i2, { x: a3[0], y: a3[1] }, { x: a3[2], y: a3[3] }, n3)), i2 = n3;
        }
        return e3;
      }, 0), e2 = l2.semIndex === 0 ? 0 : l2.semIndex === 1 ? t3 : t3 / 2, l2.semIndex !== 2 && (o2 = Math.max(o2.attach_plugBackLenSE[l2.semIndex] || 0, o2.line_strokeWidth / 2) + l2.strokeWidth / 2 + l2.height / 4, e2 = (e2 += l2.semIndex === 0 ? o2 : -o2) < 0 ? 0 : t3 < e2 ? t3 : e2), l2.lineOffset && (e2 = (e2 += l2.lineOffset) < 0 ? 0 : t3 < e2 ? t3 : e2), n2.startOffset = e2, Xe(l2, a2, "startOffset", e2) && (l2.elmOffset.startOffset.baseVal.value = e2)));
    }, l2.updateShow = function(e2) {
      O.captionLabel.updateShow(l2, e2);
    }, re && (l2.adjustEdge = function(e2, t3) {
      l2.bBox && O.captionLabel.adjustEdge(t3, l2.bBox, l2.strokeWidth / 2);
    }), true);
  }, getOffsetPathData: function(e2, c2, n2) {
    var d2, a2, f2 = [];
    function y2(e3, t2) {
      return Math.abs(e3.x - t2.x) < 3 && Math.abs(e3.y - t2.y) < 3;
    }
    return e2.forEach(function(e3) {
      var t2, n3, a3, i2, o2, l2, r2, s2, u2, h2, p2;
      e3.length === 2 ? (s2 = e3[0], u2 = e3[1], h2 = c2, p2 = Math.atan2(s2.y - u2.y, u2.x - s2.x) + 0.5 * Math.PI, t2 = [{ x: s2.x + Math.cos(p2) * h2, y: s2.y + Math.sin(p2) * h2 * -1 }, { x: u2.x + Math.cos(p2) * h2, y: u2.y + Math.sin(p2) * h2 * -1 }], d2 ? (a3 = d2.points, 0 <= (r2 = Math.atan2(a3[1].y - a3[0].y, a3[0].x - a3[1].x) - Math.atan2(e3[0].y - e3[1].y, e3[1].x - e3[0].x)) && r2 <= Math.PI ? n3 = { type: "line", points: t2, inside: true } : (o2 = Pe(a3[0], a3[1], c2), i2 = Pe(t2[1], t2[0], c2), l2 = a3[0], s2 = t2[1], p2 = (u2 = o2).x - l2.x, h2 = u2.y - l2.y, r2 = s2.x - i2.x, u2 = s2.y - i2.y, s2 = (-h2 * (l2.x - i2.x) + p2 * (l2.y - i2.y)) / (-r2 * h2 + p2 * u2), u2 = (r2 * (l2.y - i2.y) - u2 * (l2.x - i2.x)) / (-r2 * h2 + p2 * u2), n3 = (h2 = 0 <= s2 && s2 <= 1 && 0 <= u2 && u2 <= 1 ? { x: l2.x + u2 * p2, y: l2.y + u2 * h2 } : null) ? { type: "line", points: [a3[1] = h2, t2[1]] } : (a3[1] = y2(i2, o2) ? i2 : o2, { type: "line", points: [i2, t2[1]] }), d2.len = Ae(a3[0], a3[1]))) : n3 = { type: "line", points: t2 }, n3.len = Ae(n3.points[0], n3.points[1]), f2.push(d2 = n3)) : (f2.push({ type: "cubic", points: function(e4, t3, n4, a4, i3, o3) {
        for (var l3, r3, s3 = Te(e4, t3, n4, a4) / o3, u3 = 1 / (o3 < i3 ? i3 / o3 * s3 : s3), h3 = [], p3 = 0; r3 = (90 - (l3 = Ne(e4, t3, n4, a4, p3)).angle) * (Math.PI / 180), h3.push({ x: l3.x + Math.cos(r3) * i3, y: l3.y + Math.sin(r3) * i3 * -1 }), !(1 <= p3); )
          1 < (p3 += u3) && (p3 = 1);
        return h3;
      }(e3[0], e3[1], e3[2], e3[3], c2, 16) }), d2 = null);
    }), d2 = null, f2.forEach(function(e3) {
      var t2;
      d2 = e3.type === "line" ? (e3.inside && (d2.len > c2 ? ((t2 = d2.points)[1] = Pe(t2[0], t2[1], -c2), d2.len = Ae(t2[0], t2[1])) : (d2.points = null, d2.len = 0), e3.len > c2 + n2 ? ((t2 = e3.points)[0] = Pe(t2[1], t2[0], -(c2 + n2)), e3.len = Ae(t2[0], t2[1])) : (e3.points = null, e3.len = 0)), e3) : null;
    }), f2.reduce(function(t2, e3) {
      var n3 = e3.points;
      return n3 && (a2 && y2(n3[0], a2) || t2.push({ type: "M", values: [n3[0].x, n3[0].y] }), e3.type === "line" ? t2.push({ type: "L", values: [n3[1].x, n3[1].y] }) : (n3.shift(), n3.forEach(function(e4) {
        t2.push({ type: "L", values: [e4.x, e4.y] });
      })), a2 = n3[n3.length - 1]), t2;
    }, []);
  }, newText: function(e2, t2, n2, a2) {
    var i2, o2, l2, r2, s2 = t2.createElementNS(ae, "defs"), u2 = s2.appendChild(t2.createElementNS(ae, "path"));
    return u2.id = i2 = n2 + "-path", (l2 = (o2 = t2.createElementNS(ae, "text")).appendChild(t2.createElementNS(ae, "textPath"))).href.baseVal = "#" + i2, l2.startOffset.baseVal.newValueSpecifiedUnits(SVGLength.SVG_LENGTHTYPE_PX, 0), l2.textContent = e2, typeof h != "boolean" && (h = "paintOrder" in o2.style), a2 && !h ? (o2.id = e2 = n2 + "-text", s2.appendChild(o2), (r2 = (n2 = t2.createElementNS(ae, "g")).appendChild(t2.createElementNS(ae, "use"))).href.baseVal = "#" + e2, (t2 = n2.appendChild(t2.createElementNS(ae, "use"))).href.baseVal = "#" + e2, (r2 = r2.style).strokeLinejoin = "round", { elmPosition: o2, elmPath: u2, elmOffset: l2, styleText: o2.style, styleFill: t2.style, styleStroke: r2, styleShow: n2.style, elmsAppend: [s2, n2] }) : (r2 = o2.style, a2 && (r2.strokeLinejoin = "round", r2.paintOrder = "stroke"), { elmPosition: o2, elmPath: u2, elmOffset: l2, styleText: r2, styleFill: r2, styleStroke: a2 ? r2 : null, styleShow: r2, elmsAppend: [s2, o2] });
  }, initSvg: function(t2, n2) {
    var e2, a2, i2, o2 = O.pathLabel.newText(t2.text, n2.baseWindow.document, C + "-pathLabel-" + t2._id, t2.outlineColor);
    ["elmPosition", "elmPath", "elmOffset", "styleFill", "styleShow", "elmsAppend"].forEach(function(e3) {
      t2[e3] = o2[e3];
    }), t2.isShown = false, t2.styleShow.visibility = "hidden", O.captionLabel.textStyleProps.forEach(function(e3) {
      t2[e3] != null && (o2.styleText[e3] = t2[e3]);
    }), o2.elmsAppend.forEach(function(e3) {
      n2.svg.appendChild(e3);
    }), o2.elmPath.setPathData([{ type: "M", values: [0, 100] }, { type: "h", values: [100] }]), le && (i2 = o2.elmOffset.href.baseVal, o2.elmOffset.href.baseVal = ""), e2 = o2.elmPosition.getBBox(), le && (o2.elmOffset.href.baseVal = i2), o2.styleText.textAnchor = ["start", "end", "middle"][t2.semIndex], t2.semIndex !== 2 || t2.lineOffset || o2.elmOffset.startOffset.baseVal.newValueSpecifiedUnits(SVGLength.SVG_LENGTHTYPE_PERCENTAGE, 50), t2.height = e2.height, t2.outlineColor && (a2 = e2.height / 9, o2.styleStroke.strokeWidth = (a2 = 10 < a2 ? 10 : a2 < 2 ? 2 : a2) + "px", o2.styleStroke.stroke = t2.outlineColor), t2.strokeWidth = a2 || 0, Ye(t2.aplStats, O.pathLabel.stats), t2.updateColor(n2), t2.updatePath(n2), t2.updateStartOffset(n2), re && $e(n2, {}), t2.updateShow(n2);
  }, bind: function(e2, t2) {
    var n2 = t2.props;
    return e2.color || Ge(n2, "cur_line_color", e2.updateColor), Ge(n2, "cur_line_strokeWidth", e2.updatePath), Ge(n2, "apl_path", e2.updatePath), e2.semIndex = t2.optionName === "startLabel" ? 0 : t2.optionName === "endLabel" ? 1 : 2, e2.semIndex === 2 && !e2.lineOffset || Ge(n2, "cur_attach_plugBackLenSE", e2.updateStartOffset), Ge(n2, "svgShow", e2.updateShow), re && Ge(n2, "new_edge4viewBox", e2.adjustEdge), O.pathLabel.initSvg(e2, n2), true;
  }, unbind: function(e2, t2) {
    var n2 = t2.props;
    e2.elmsAppend && (e2.elmsAppend.forEach(function(e3) {
      n2.svg.removeChild(e3);
    }), e2.elmPosition = e2.elmPath = e2.elmOffset = e2.styleFill = e2.styleShow = e2.elmsAppend = null), Ye(e2.curStats, O.pathLabel.stats), Ye(e2.aplStats, O.pathLabel.stats), e2.color || De(n2, "cur_line_color", e2.updateColor), De(n2, "cur_line_strokeWidth", e2.updatePath), De(n2, "apl_path", e2.updatePath), e2.semIndex === 2 && !e2.lineOffset || De(n2, "cur_attach_plugBackLenSE", e2.updateStartOffset), De(n2, "svgShow", e2.updateShow), re && (De(n2, "new_edge4viewBox", e2.adjustEdge), $e(n2, {}));
  }, removeOption: function(e2, t2) {
    var n2 = t2.props, a2 = {};
    a2[t2.optionName] = "", it(n2, a2);
  }, remove: function(t2) {
    t2.boundTargets.length && (console.error("LeaderLineAttachment was not unbound by remove"), t2.boundTargets.forEach(function(e2) {
      O.pathLabel.unbind(t2, e2);
    }));
  } } }, Object.keys(O).forEach(function(e2) {
    ot[e2] = function() {
      return new M(O[e2], Array.prototype.slice.call(arguments));
    };
  }), ot.positionByWindowResize = true, window.addEventListener("resize", S.add(function() {
    ot.positionByWindowResize && Object.keys(Se).forEach(function(e2) {
      $e(Se[e2], { position: true });
    });
  }), false), ot;
})();
class SubjectEngine {
  constructor(ledger, colorModule) {
    __publicField(this, "markedText");
    __publicField(this, "ledger");
    __publicField(this, "colorModule");
    __publicField(this, "leaderLines");
    this.markedText = null;
    this.ledger = ledger;
    this.colorModule = colorModule;
    this.leaderLines = /* @__PURE__ */ new Map();
  }
  link(markedText) {
    this.markedText = markedText;
    this.ledger.link(markedText);
    this.colorModule.link(markedText);
  }
  unlink() {
    if (this.markedText != null) {
      this.colorModule.unlink();
      this.ledger.unlink();
      this.markedText = null;
    }
  }
  setLedger(newLedger) {
    if (this.ledger !== newLedger) {
      this.ledger.unlink();
      this.ledger = newLedger;
      if (this.markedText)
        this.ledger.link(this.markedText);
      this.addSubjectsFromText();
    }
  }
  setColorModule(newColorModule) {
    if (this.colorModule !== newColorModule) {
      this.colorModule.unlink();
      this.colorModule = newColorModule;
      if (this.markedText)
        this.colorModule.link(this.markedText);
      this.resetColors();
    }
  }
  addSubjectsFromText() {
    if (this.markedText == null) {
      throw Error("Link SubjectLedger with MarkedText before calling resetSubjects");
    }
    const subjectNames = new Set(Array().concat(...this.markedText.marks.map((mark) => mark.subjects)));
    for (const subjectName of subjectNames) {
      if (!this.ledger.glossary.get(subjectName)) {
        this.ledger.glossary.set(subjectName, new Subject(subjectName, this.colorModule.subjectColor(subjectName), this.markedText.subjectStyleType));
      }
    }
    this.markedText.$forceUpdate();
  }
  addSubjects(subjects) {
    if (this.markedText == null) {
      throw Error("Link SubjectLedger with MarkedText before calling addSubjects");
    }
    for (const subjectName of subjects) {
      if (!this.ledger.glossary.has(subjectName)) {
        this.ledger.glossary.set(subjectName, new Subject(subjectName, this.colorModule.subjectColor(subjectName), this.markedText.subjectStyleType));
      }
    }
  }
  resetColors() {
    for (const sub of this.ledger.glossary.values()) {
      sub.color = this.colorModule.subjectColor(sub.name);
    }
  }
  lineConnectSubject(subjectName) {
    const subject = this.ledger.glossary.get(subjectName);
    if (subject != null) {
      const leaderLines = [];
      const spans = this.subjectSpans(subjectName);
      for (let idx = 1; idx < spans.length; ++idx) {
        leaderLines.push(new LeaderLine(spans[idx - 1], spans[idx], {
          startPlug: "square",
          endPlug: "square",
          color: subject.color,
          path: "magnet",
          size: 1
        }));
      }
      this.leaderLines.set(subjectName, leaderLines);
    }
  }
  lineDisconnectSubject(subjectName) {
    var _a;
    (_a = this.leaderLines.get(subjectName)) == null ? void 0 : _a.forEach((leaderLine) => {
      leaderLine.remove();
    });
    this.leaderLines.delete(subjectName);
  }
  toggleLines(subjectName) {
    if (this.leaderLines.has(subjectName))
      this.lineDisconnectSubject(subjectName);
    else
      this.lineConnectSubject(subjectName);
  }
  subjectCSSClassName(subjectName) {
    return "mt-subject-" + subjectName;
  }
  subjectSpans(subjectName) {
    var _a;
    const spans = Array.from(((_a = this.markedText) == null ? void 0 : _a.$el.getElementsByClassName(this.subjectCSSClassName(subjectName))) || []);
    return spans;
  }
}
class ManualColorModule {
  constructor(defaultColor = "black") {
    __publicField(this, "composable");
    __publicField(this, "subjectColorMap");
    __publicField(this, "defaultColor");
    this.composable = null;
    this.subjectColorMap = /* @__PURE__ */ new Map();
    this.defaultColor = defaultColor;
  }
  link(composable) {
    this.composable = composable;
  }
  unlink() {
    if (this.composable != null) {
      this.composable = null;
    }
  }
  subjectColor(subject) {
    let color = this.subjectColorMap.get(subject);
    if (color == null) {
      color = this.defaultColor;
    }
    return color;
  }
  setSubjectColor(subject, color) {
    var _a;
    this.subjectColorMap.set(subject, color);
    (_a = this.composable) == null ? void 0 : _a.resetColors();
  }
  unsetSubjectColor(subject) {
    var _a;
    this.subjectColorMap.delete(subject);
    (_a = this.composable) == null ? void 0 : _a.resetColors();
  }
}
class ColorScaleModule {
  constructor(subjectColorLightness, numSubjectColors) {
    __publicField(this, "composable");
    __publicField(this, "subjectColorLightness");
    __publicField(this, "numSubjectColors");
    __publicField(this, "subjectColorMap");
    __publicField(this, "colorIdx");
    __publicField(this, "generatedColors");
    this.composable = null;
    this.subjectColorLightness = subjectColorLightness;
    this.numSubjectColors = numSubjectColors;
    this.subjectColorMap = /* @__PURE__ */ new Map();
    this.colorIdx = 0;
    this.generatedColors = this.generateColors();
  }
  link(composable) {
    this.composable = composable;
  }
  unlink() {
    if (this.composable != null) {
      this.composable = null;
    }
  }
  subjectColor(subject) {
    let color = this.subjectColorMap.get(subject);
    if (color == null) {
      color = this.generatedColors[this.colorIdx];
      this.colorIdx = (this.colorIdx + 1) % this.numSubjectColors;
      this.subjectColorMap.set(subject, color);
    }
    return color;
  }
  setNumSubjectColors(val) {
    var _a;
    this.numSubjectColors = val;
    (_a = this.composable) == null ? void 0 : _a.$forceUpdate();
  }
  setSubjectColorLightness(val) {
    var _a;
    this.subjectColorLightness = val;
    (_a = this.composable) == null ? void 0 : _a.$forceUpdate();
  }
  generateColors() {
    const spectrum = chroma.scale(["ff0000", "ffff00", "00ff00", "00ffff", "0000ff", "ff00ff", "ff0000"].map((colorStr) => chroma.hex(colorStr).hsl()).map((hcl) => chroma.hsl(hcl[0], hcl[1], hcl[2] * this.subjectColorLightness)));
    const colors = spectrum.colors(this.numSubjectColors + 1).slice(0, this.numSubjectColors);
    let diff = Math.max(Math.round(colors.length / 6), 1);
    while (diff > 1 && colors.length % diff === 0)
      diff -= 1;
    if (diff === 1)
      return colors;
    const newColors = colors.slice();
    let idx = 0;
    for (const color of colors) {
      newColors[idx] = color;
      idx += diff;
      if (idx >= newColors.length)
        idx -= newColors.length;
    }
    return newColors;
  }
}
var MarkedText_vue_vue_type_style_index_0_scoped_true_lang = "";
var MarkedText_vue_vue_type_style_index_1_lang = "";
const MarkedText$1 = defineComponent({
  name: "VueMarkedText",
  components: {
    DepotRenderer: DepotRenderer$1
  },
  props: {
    sourceText: {
      type: String,
      required: true
    },
    marks: {
      type: Array,
      required: true
    },
    controller: {
      type: Object,
      required: true
    },
    batchSize: {
      type: Number,
      default: 20
    },
    colorModule: {
      type: Object,
      default: new ColorScaleModule(1, 8)
    },
    subjectLedger: {
      type: Object,
      default: new SubjectLedger()
    },
    subjectStyleType: {
      type: String,
      default: "border"
    },
    showBatches: {
      type: Boolean,
      default: false
    }
  },
  data() {
    const subjectEngine = new SubjectEngine(this.subjectLedger, this.colorModule);
    const manuscript = new Manuscript(this.sourceText, this.marks, this.batchSize);
    return {
      subjectEngine,
      manuscript
    };
  },
  computed: {
    spanBatches() {
      return this.manuscript.spanBatches;
    }
  },
  watch: {
    sourceText() {
      this.manuscript = new Manuscript(this.sourceText, this.marks, this.batchSize);
      this.resetSpans();
    },
    marks: {
      handler() {
        this.updateMarks();
      },
      deep: true
    },
    controller(newController, oldController) {
      oldController.unlink();
      newController.link(this);
    },
    colorModule(newModule) {
      this.subjectEngine.setColorModule(newModule);
    },
    subjectLedger(newLedger) {
      this.subjectEngine.setLedger(newLedger);
    },
    batchSize(val) {
      this.manuscript.batchSize = val;
      this.manuscript.resetSpans();
    },
    subjectStyleType() {
      this.$forceUpdate();
    },
    showBatches(val) {
      if (val)
        this.metaStringDivideBatches();
      else
        this.removeMetaStrings("divide-batches");
    }
  },
  methods: {
    updateMarks() {
      this.controller.deselect(false);
      this.subjectEngine.addSubjectsFromText();
      const activeSubjects = this.subjectLedger.listActiveSubjects.map((sub) => sub.name);
      const filteredMarks = this.marks.filter((mark) => mark.subjects.some((sub) => activeSubjects.includes(sub)));
      this.manuscript.changeMarks(filteredMarks);
    },
    resetColors() {
      this.subjectEngine.resetColors();
    },
    refreshManuscript() {
      this.manuscript.refresh();
    },
    spanDataToStyles(spanData) {
      return spanData.subjects.map((subject) => this.subjectLedger.byName(subject)).filter((subject) => subject != null && subject.active).map((subject) => subject.style);
    },
    spanDataTrigger(payload) {
      payload.spanControllerEvent(payload.rawEvent, payload.spanData, this.controller);
    },
    resetSpans() {
      this.manuscript.resetSpans();
    },
    setSelection(charRange, immediate) {
      this.manuscript.setSelection(charRange, immediate);
    },
    getSelection() {
      return this.manuscript.selection;
    },
    metaStringEncloseSections(begSections, endSections) {
      this.manuscript.metaStringEncloseSections(begSections, endSections);
    },
    metaStringDivideBatches() {
      this.manuscript.metaStringDivideBatches();
    },
    removeMetaStrings(metaStringType) {
      this.manuscript.removeMetaStrings(metaStringType);
    },
    subjectStyle(name) {
      var _a;
      return (_a = this.subjectLedger.byName(name)) == null ? void 0 : _a.style;
    }
  },
  beforeMount() {
    this.subjectEngine.link(this);
    this.subjectEngine.addSubjectsFromText();
    this.controller.link(this);
    if (this.showBatches)
      this.metaStringDivideBatches();
  },
  beforeUnmount() {
    this.controller.unlink();
    this.subjectEngine.unlink();
  }
});
const _sfc_main = MarkedText$1;
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_DepotRenderer = resolveComponent("DepotRenderer");
  return openBlock(), createElementBlock("p", {
    class: "marked-text",
    onMouseup: _cache[0] || (_cache[0] = (event) => _ctx.controller.onMouseUpOther(event))
  }, [
    createVNode(_component_DepotRenderer, {
      spanBatches: _ctx.spanBatches,
      spanDataToStyles: _ctx.spanDataToStyles,
      onTrigger: _ctx.spanDataTrigger
    }, null, 8, ["spanBatches", "spanDataToStyles", "onTrigger"])
  ], 32);
}
var VMarkedText = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render], ["__scopeId", "data-v-421a254f"]]);
const MarkedText = VMarkedText;
class AController {
  constructor() {
    __publicField(this, "composable", null);
  }
  link(composable) {
    if (this.composable !== composable) {
      this.deselect();
      this.composable = composable;
    }
  }
  unlink() {
    if (this.composable != null) {
      this.deselect();
      this.composable = null;
    }
  }
}
class NullController extends AController {
  deselect() {
    return;
  }
  selectNew() {
    return;
  }
  selectMarks() {
    return;
  }
  onMouseUpText() {
    return;
  }
  onMouseUpMark() {
    return;
  }
  onMouseUpSelection() {
    return;
  }
  onMouseUpMetaString() {
    return;
  }
  onMouseUpOther() {
    return;
  }
}
class TextSelectionController extends AController {
  constructor(deselectCbk, selectNewCbk, selectMarksCbk) {
    super();
    __publicField(this, "deselectCbk");
    __publicField(this, "selectNewCbk");
    __publicField(this, "selectMarksCbk");
    this.deselectCbk = deselectCbk;
    this.selectNewCbk = selectNewCbk;
    this.selectMarksCbk = selectMarksCbk;
  }
  deselect(immediate = true) {
    if (this.composable)
      this.composable.setSelection(null, false);
    this.deselectCbk();
    if (this.composable && immediate)
      this.composable.refreshManuscript();
  }
  selectNew(begChar, endChar) {
    if (this.composable)
      this.composable.setSelection([begChar, endChar], false);
    this.selectNewCbk(begChar, endChar);
    if (this.composable)
      this.composable.refreshManuscript();
  }
  selectMarks(marks) {
    if (this.composable) {
      if (marks.length === 1)
        this.composable.setSelection([marks[0].begChar, marks[0].endChar], false);
      else
        this.composable.setSelection(null, false);
    }
    this.selectMarksCbk(marks);
    if (this.composable)
      this.composable.refreshManuscript();
  }
  onMouseUpText(e, charRange) {
    e.stopPropagation();
    const selection = window.getSelection();
    if (!selection)
      return;
    if (!(selection.anchorNode instanceof Text) || !(selection.focusNode instanceof Text)) {
      console.error("Window selection behaving strangely; anchor or focus not a Text.");
      this.deselect();
      return;
    }
    let isReversed = false;
    const range = document.createRange();
    range.setStart(selection.anchorNode, selection.anchorOffset);
    range.setEnd(selection.focusNode, selection.focusOffset);
    if (range.compareBoundaryPoints(Range.START_TO_END, range) !== 1) {
      isReversed = true;
      range.setStart(selection.focusNode, selection.focusOffset);
      range.setEnd(selection.anchorNode, selection.anchorOffset);
    }
    if (range.toString().length === 0) {
      if (selection.focusNode.length > selection.focusOffset) {
        range.setEnd(range.endContainer, range.endOffset + 1);
      }
    }
    let begChar = range.startOffset;
    let endChar = range.endOffset;
    const textLength = range.toString().length;
    if (isReversed) {
      begChar += charRange[0];
      endChar = begChar + textLength;
    } else {
      endChar += charRange[0];
      begChar = endChar - textLength;
    }
    this.selectNew(begChar, endChar);
  }
  onMouseUpMark(e, charRange, marks) {
    e.stopPropagation();
    const selection = window.getSelection();
    if (!selection)
      return;
    if (selection.getRangeAt(0).toString().length !== 0) {
      this.onMouseUpText(e, charRange);
      return;
    }
    const range = document.createRange();
    let startNode = e.target;
    while (!(startNode instanceof Text)) {
      startNode = startNode.childNodes[0];
    }
    range.setStart(startNode, 0);
    let endNode = e.target;
    while (!(endNode instanceof Text)) {
      const endChildren = endNode.childNodes;
      endNode = endChildren[endChildren.length - 1];
    }
    range.setEnd(endNode, endNode.length);
    this.selectMarks(marks);
  }
  onMouseUpSelection(e, charRange) {
    e.stopPropagation();
  }
  onMouseUpMetaString(e, charRange, metaStringText) {
    e.stopPropagation();
  }
  onMouseUpOther(e) {
    e.stopPropagation();
    this.deselect();
  }
}
class WordSelectionController extends TextSelectionController {
  onMouseUpText(e, charRange) {
    e.stopPropagation();
    const selection = window.getSelection();
    if (!selection)
      return;
    if (!(selection.anchorNode instanceof Text) || !(selection.focusNode instanceof Text)) {
      console.error("Window selection behaving strangely; anchor or focus not a Text.");
      this.deselect();
      return;
    }
    let isReversed = false;
    const range = document.createRange();
    range.setStart(selection.anchorNode, selection.anchorOffset);
    range.setEnd(selection.focusNode, selection.focusOffset);
    if (range.compareBoundaryPoints(Range.START_TO_END, range) !== 1) {
      isReversed = true;
      range.setStart(selection.focusNode, selection.focusOffset);
      range.setEnd(selection.anchorNode, selection.anchorOffset);
    }
    if (range.toString().length === 0) {
      if (selection.focusNode.length > selection.focusOffset) {
        range.setEnd(range.endContainer, range.endOffset + 1);
      }
    }
    const text = range.toString();
    if (!/\S/.test(text)) {
      this.deselect();
      return;
    }
    let begChar;
    let endChar;
    if (/\s/.test(text[0])) {
      begChar = text.search(/(\S)/) + range.startOffset;
    } else {
      const preRange = document.createRange();
      preRange.setStart(range.startContainer, 0);
      preRange.setEnd(range.startContainer, range.startOffset);
      begChar = preRange.toString().search(/([^\w\d])[\w\d]*$/) + 1;
    }
    if (/\s/.test(text[text.length - 1])) {
      endChar = text.search(/(\S)\s*$/) + range.endOffset - text.length + 1;
      if (endChar < 0)
        endChar = 0;
    } else {
      const postRange = document.createRange();
      postRange.setStart(range.endContainer, range.endOffset);
      postRange.setEnd(range.endContainer, range.endContainer.length);
      endChar = postRange.toString().search(/([^\w\d])/);
      if (endChar === -1)
        endChar = range.endContainer.length;
      else
        endChar += range.endOffset;
    }
    range.setStart(range.startContainer, begChar);
    range.setEnd(range.endContainer, endChar);
    selection.removeAllRanges();
    selection.addRange(range);
    const textLength = range.toString().length;
    if (isReversed) {
      begChar += charRange[0];
      endChar = begChar + textLength;
    } else {
      endChar += charRange[0];
      begChar = endChar - textLength;
    }
    this.selectNew(begChar, endChar);
  }
}
class TwoClickController extends TextSelectionController {
  constructor() {
    super(...arguments);
    __publicField(this, "clickState", "empty");
    __publicField(this, "anchorNode", null);
    __publicField(this, "anchorOffset", null);
  }
  onFirstClick() {
    this.clickState = "clicked";
    const selection = window.getSelection();
    if (!selection)
      return;
    if (!(selection.anchorNode instanceof Text)) {
      console.error("Window selection behaving strangely; anchor or focus not a Text.");
      this.deselect();
      return;
    }
    this.anchorNode = selection.anchorNode;
    this.anchorOffset = selection.anchorOffset;
  }
  onSecondClick(textRange) {
    const selection = window.getSelection();
    if (!selection)
      return;
    if (this.anchorNode == null || this.anchorOffset == null || !(selection.focusNode instanceof Text)) {
      console.error("Window selection behaving strangely; anchor or focus not a Text.");
      this.deselect();
      return;
    }
    let isReversed = false;
    const range = document.createRange();
    range.setStart(this.anchorNode, this.anchorOffset);
    range.setEnd(selection.focusNode, selection.focusOffset);
    if (range.compareBoundaryPoints(Range.START_TO_END, range) !== 1) {
      isReversed = true;
      range.setStart(selection.focusNode, selection.focusOffset);
      range.setEnd(this.anchorNode, this.anchorOffset);
    }
    if (range.toString().length === 0) {
      if (selection.focusNode.length > selection.focusOffset) {
        range.setEnd(range.endContainer, range.endOffset + 1);
      }
    }
    let begChar = range.startOffset;
    let endChar = range.endOffset;
    range.setStart(range.startContainer, begChar);
    range.setEnd(range.endContainer, endChar);
    selection.removeAllRanges();
    selection.addRange(range);
    const textLength = range.toString().length;
    if (isReversed) {
      begChar += textRange[0];
      endChar = begChar + textLength;
    } else {
      endChar += textRange[0];
      begChar = endChar - textLength;
    }
    this.resetClick();
    this.selectNew(begChar, endChar);
  }
  resetClick() {
    this.clickState = "empty";
    this.anchorNode = null;
    this.anchorOffset = null;
  }
  onMouseUpText(e, charRange) {
    e.stopPropagation();
    switch (this.clickState) {
      case "empty":
        this.onFirstClick();
        break;
      case "clicked":
        this.onSecondClick(charRange);
        break;
    }
  }
  onMouseUpMark(e, charRange, marks) {
    this.resetClick();
    super.onMouseUpMark(e, charRange, marks);
  }
  onMouseUpSelection(e, charRange) {
    this.resetClick();
    super.onMouseUpSelection(e, charRange);
  }
  onMouseUpMetaString(e, charRange, metaStringText) {
    this.resetClick();
    super.onMouseUpMetaString(e, charRange, metaStringText);
  }
  onMouseUpOther(e) {
    this.resetClick();
    super.onMouseUpOther(e);
  }
}
export { AController, ColorScaleModule, Layers, ManualColorModule, Manuscript, MarkedText, NullController, Patch, Press, SpanData, Subject, SubjectEngine, SubjectLedger, TextSelectionController, TwoClickController, TypeSpanData, WordSelectionController, compareMarks, createSpanData };
